<?
#############################################################
# abfrage_collections.php - Browsen nach Collections 
#
# letzte nderung:
# 18.3.2005, Annette Maile, UB Stuttgart
# Auslagerung Design in lib/design.php
# In Abhaengigkeit von $la kann das entsprechende Design eingelesen werden.
#
# 10.6.05, Annette Maile, UB Stuttgart
# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# in Abhaengigkeit der IP-Adresse des Nutzers und der
# Variablen $alle_doks_anzeigen wird die Suche generiert
#
# 21.9.2005, Annette Maile, UB Stuttgart 
# Einfuehrung der Mehrsprachigkeit (Variable $la)
# Textdatei: texte/$la/abfrage_collections.conf
#
#############################################################

include ("../lib/class.configFile.php");
$conf = new configFile ("../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");

include ("../lib/class.opus_$dbms.$php");
$opus = new opus;

$db = $conf->value("db");
$opustable = $conf->value("opus_table");
$opus_coll = $opustable . "_coll";
$url = $conf->value("url");
$doku_pfad = $conf->value("doku_pfad");
$alle_doks_anzeigen = $conf->value("alle_doks_anzeigen");

# A. Maile steht nun in der Textdatei
# $titel = $conf->value("titel_abfrage_collections");;
# $ueberschrift = $conf->value("ueberschrift_abfrage_collections");

include ("../lib/stringValidation.php");
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# A.Maile, 18.03.05: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}

# A. Maile Texte aus Textdatei in Programmvariablen fllen
$texte = new configFile ("../texte/$la/abfrage_collections.conf");
$titel = $texte->value("titel");
$ueberschrift = $texte->value("ueberschrift");

# Annette Maile, 18.3.05 Design aus lib/design.php einlesen
require ("../lib/design.$php");
$design = new design;
$design->head_titel($titel);
$design->head_ueberschrift($ueberschrift, $la);

$geschwister_an = 0; // 1 = Geschwister-Collections werden dargestellt; 0 = Geschwister-Collections werden nicht dargestellt

print("<FONT COLOR=red>");
$sock = $opus->connect();
if ( $sock < 0 ) {
	echo ("Error: $ERRMSG\n");
}

if ( $opus->select_db($db) < 0 ) {
	echo ("Error: $ERRMSG\n");
}
print("</FONT> \n");

if( !$coll_id ) {
	$coll_id = 1;	// coll_id, von der ausgegangen wird
}

# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# Es wird die IP des Nutzers ermittelt.
# Wenn alle_doks_anzeigen = 0 gesetzt ist:
# Es wird auf jeden Fall im Bereich 1 = freier Zugriff gesucht
# Falls in Altbestaenden (< Opus 3.0) kein Bereich angegeben ist,
# wird auch nach bereich_id = 0 und null gesucht
# Dann wird in der Tabelle ip_bereich nach den Bereichen gesucht,
# in deren IP-Range die IP liegt.
# Wenn alle_doks_anzeigen = 1 gesetzt ist:
# Es wird in allen Bereichen gesucht

$ip = $_SERVER['REMOTE_ADDR'];
if ($alle_doks_anzeigen == 0) {
        $bereichsgrenze = "(o.bereich_id = 1 or o.bereich_id = 0 or o.bereich_id is NULL";
        $res = $opus->query("SELECT bereich_id, ip_range FROM ip_bereich");
        $num = $opus->num_rows($res);
        if ($num > 0) {
                $i = 0;
                while ($i < $num) {
                        $mrow = $opus->fetch_row($res);
                        $bereich_id = $mrow[0];
                        $ip_range = $mrow[1];
                        if (ereg("^$ip_range", "$ip")) {
                                $bereichsgrenze = $bereichsgrenze . " OR o.bereich_id = $bereich_id";
                        }
                        $i++;
                }
                $opus->free_result($res);
                $bereichsgrenze = $bereichsgrenze . ")";
        }
}
else {
        # Es wird in allen Bereichen gesucht
        $bereichsgrenze = "(o.bereich_id is not null or o.bereich_id is null)";
}
# Ende Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche

//***********************************************************************************
// Allgemeine Funktion um die Anzahl Dokumente einer Collection zu ermitteln

function anzahl_doks( $coll_id ) {
	global $opus, $opustable, $opus_coll, $bereichsgrenze;
	$query = "SELECT oc.source_opus FROM $opus_coll oc, $opustable o WHERE coll_id = $coll_id and oc.source_opus = o.source_opus and $bereichsgrenze";
	$res1 = $opus->query( $query );
	$num = $opus->num_rows( $res1 );
	if( $num ) {
		$anzahl = $num;
	} else {
		$anzahl = 0;
	}
	return $anzahl;
	$opus->free_result( $res1 );
}

//  Allgemeine Funktion um aus einem coll_id den coll_name zu ermitteln
function get_coll_name( $coll_id ) {
	global $opus;
	$query = "SELECT coll_name FROM collections WHERE coll_id = $coll_id;";
	$res2 = $opus->query( $query );
	$mrow = $opus->fetch_row( $res2 );
	return $mrow[0];
	$opus->free_result( $res2 );
}

// Allgemeine Funktion um zu ermitteln, ob eine Collection ein Kind hat
// Bei nested sets ist lft einer Collection immer genau 1 kleiner als rgt
function hat_kind( $coll_id ) {
	global $opus;
	$query = "SELECT lft, rgt FROM collections WHERE coll_id = $coll_id;";
	$res3 = $opus->query( $query );
	$mrow = $opus->fetch_row( $res3 );
	if( ($mrow[1] - $mrow[0]) > 1 ) { // Die Collection hat ein Kind
		return "true";
	} else { // Die Collection hat kein Kind
		return "false";
	}
	$opus->free_result( $res3 );
}


//***********************************************************************************
// Wir ermitteln die coll_id und coll_name des Elternelements

if( $coll_id > 1 ) {
	$query_eltern =	"SELECT v.coll_id, v.coll_name 
			FROM collections v, collections s
			WHERE s.lft BETWEEN v.lft AND v.rgt
			AND s.coll_id = $coll_id
			ORDER BY v.lft DESC;";
	
	$res_eltern = $opus->query( $query_eltern );
	$mrow = $opus->fetch_row( $res_eltern ); // Dies ist die Information zu $coll_id und kann ignoriert werden
	$mrow = $opus->fetch_row( $res_eltern ); // Dies ist die Information zu dem Elternelement
	$coll_id_eltern = $mrow[0];
	$coll_name_eltern = $mrow[1];
	$anzahl_doks_eltern = anzahl_doks( $coll_id_eltern );
	$opus->free_result( $res_eltern );
} 
//***********************************************************************************
// Wir suchen alle Geschwister, und nur die Geschwister einer Collection

// Dazu gibt es zwei Funktionen. Einmal eine, die alle Geschwister rechts sucht, dann eine, die alle Geschwister links sucht

function coll_ids_rechts( &$collect_ids_rgt, &$collect_ids2_rgt ) { 	// Sucht alle Geschwister rechts 
									// von dem Eingangs-coll_id. 
								    	// Arrays werden als Referenzen �bergeben, damit sie 
									//ver�ndert werden k�nnen

// $collect_ids_rgt ist ein Array, das die gefundenen coll_ids enh�lt. Dieses Array wird f�r die Suche benutzt. 
// Fertig bearbeitete coll_ids werden entfernt und nach collect_ids2 �bertragen
// $collect_ids2_rgt ist ein Array, das alle gefundenen coll_ids enth�lt

	$query_rechts = "SELECT a.coll_id FROM collections as a, collections as b 
			WHERE a.lft = b.rgt + 1 AND b.coll_id = $collect_ids_rgt[0];"; 	// Query um den rechten Bruder 
											// von $collect_ids_rgt[0] zu finden
	global $opus; 	// damit wir eine Query an die Datenbank schicken k�nnen
	$res_rechts = $opus->query( $query_rechts ); 	// Schickt Query an Datenbank
	$mrow_rechts = $opus->fetch_row( $res_rechts ); 	// Holt Antwort von Datenbank
       	if( !empty( $mrow_rechts[0] ) ) {	// ja, es gibt einen rechten Bruder. Der muss verarbeitet werden

		array_push( $collect_ids_rgt, $mrow_rechts[0] );	// f�gt coll_id des gefundenen Bruders ans Ende 
									// von collect_ids_rgt. Diese coll_id muss beim 
									// n�chsten Durchlauf der Schleife bearbeitet werden
		$erstes_element = array_shift( $collect_ids_rgt );	// das erste Element, also das, was gerade bearbeitet 
									// wurde, wird von $collect_ids_rgt entfernt, 
									// weil es nicht mehr gebraucht wird
		array_push( $collect_ids2_rgt, $erstes_element );	// das entfernte erste Element von collect_ids_rgt 
									// wird in collect_ids2_rgt eingef�gt
		
		return "unfertig";	// Es wurde noch ein rechter Bruder gefunden; while-Schleife muss nochmal durchlaufen
	} else { return "fertig"; }	// Es wurden keine weiteren Br�der gefunden; while-Schleife kann beendet werden
	$opus->free_result( $res_rechts );
}	

function coll_ids_links( &$collect_ids_lft, &$collect_ids2_lft ) { 	// Sucht alle Geschwister links 
									// von dem Eingangs-coll_id. 
									// Arrays werden als Referenzen �bergeben, damit sie 
									// ver�ndert werden k�nnen

// $collect_ids_lft ist ein Array, das die gefundenen coll_ids enh�lt. Dieses Array wird f�r die Suche benutzt. 
// Fertig bearbeitete coll_ids werden entfernt und nach collect_ids2 �bertragen
// $collect_ids2_lft ist ein Array, das alle gefundenen coll_ids enth�lt

	$query_links = "SELECT a.coll_id FROM collections as a, collections as b 
			WHERE a.rgt = b.lft - 1 AND b.coll_id = $collect_ids_lft[0];"; 	// Query um den linken Bruder von 
											// $collect_ids_rgt[0] zu finden
	global $opus; 	// damit wir eine Query an die Datenbank schicken k�nnen
	$res_links = $opus->query( $query_links ); 	// Schickt Query an Datenbank
	$mrow_links = $opus->fetch_row( $res_links ); 	// Holt Antwort von Datenbank
       	if( !empty( $mrow_links[0] ) ) {	// ja, es gibt einen linken Bruder. Der muss verarbeitet werden

		array_push( $collect_ids_lft, $mrow_links[0] );	// f�gt coll_id des gefundenen Bruders ans Ende von collect_ids_lft. Diese coll_id muss beim n�chsten Durchlauf der Schleife bearbeitet werden
		$erstes_element = array_shift( $collect_ids_lft );	// das erste Element, also das, was gerade bearbeitet 
									// wurde, wird von $collect_ids_lft entfernt, weil es 
									// nicht mehr gebraucht wird
		array_push( $collect_ids2_lft, $erstes_element );	// das entfernte erste Element von collect_ids_lft wird 
									// in collect_ids2_lft eingef�gt
		
		return "unfertig";	// Es wurde noch ein linker Bruder gefunden; while-Schleife muss nochmal durchlaufen
	} else { return "fertig"; }	// Es wurden keine weiteren Br�der gefunden; while-Schleife kann beendet werden
	$opus->free_result( $res_links );
}	

// Nun k�nnen die Funktionen ausgef�hrt werden

// Die n�chsten Arrays werden ben�tigt um die rechten Br�der von $coll_id zu finden
$collect_ids_rgt = array( $coll_id );
$collect_ids2_rgt = array();
$ergebnis_rgt = "unfertig"; // Solange $ergebnis_rgt unfertig ist, wird die while-Schleife aufgerufen

// Die n�chsten Arrays werden ben�tigt um die linken Br�der von $coll_id zu finden
$collect_ids_lft = array( $coll_id );
$collect_ids2_lft = array();
$ergebnis_lft = "unfertig"; // Solange $ergebnis_lft unfertig ist, wird die while-Schleife aufgerufen


// Nun werden zwei while-Schleifen ausgef�hrt. Sie rufen die obrigen Funktionen auf. Die erste ermittelt alle rechten Br�der,
// Die zweite alle linken Br�der

while( $ergebnis_rgt == "unfertig" ) { // es gibt einen Eintrag in collect_ids, der bearbeitet werden muss
	global $ergebnis_rgt;	// die Variable muss ge�ndert werden k�nnen, sonst haben wir eine Endlosschleife
	$ergebnis_rgt = coll_ids_rechts( $collect_ids_rgt, $collect_ids2_rgt ); // ruft Funktion auf. 
										// $ergebnis wird neu 
										// gesetzt und entscheidet, ob die Schleife 
										// nochmal l�uft oder nicht
}

while( $ergebnis_lft == "unfertig" ) { // es gibt einen Eintrag in collect_ids, der bearbeitet werden muss
	global $ergebnis_lft;	// die Variable muss ge�ndert werden k�nnen, sonst haben wir eine Endlosschleife
	$ergebnis_lft = coll_ids_links( $collect_ids_lft, $collect_ids2_lft ); // ruft Funktion auf. 
										// $ergebnis wird neu 
										// gesetzt und entscheidet, ob die Schleife 
										// nochmal l�uft oder nicht
}

// In collect_ids_rgt und collect_ids_lft gibt es noch coll_ids, die in collect_ids2_rgt und -lft verschoben werden m�ssen
array_push( $collect_ids2_rgt, array_shift( $collect_ids_rgt ) );
array_push( $collect_ids2_lft, array_shift( $collect_ids_lft ) );

// Die beiden collect_ids2 haben beide einmal die gleiche coll_id: Die, die Anfangs-coll_id war. 
// Bei einem der beiden muss sie gel�scht werden.

array_shift( $collect_ids2_lft );

// collect_ids2_lft ist in falscher Reihenfolge; wir drehen einfach den Array um

$collect_ids2_lft = array_reverse( $collect_ids2_lft );

// Nun verbinden wir die beiden collect_ids2_*-Arrays

$geschwister = array_merge( $collect_ids2_lft, $collect_ids2_rgt );

// Ende Suchen aller Geschwister. Das Ergebnis ist in der Variable $geschwister

//***********************************************************************************
// Wir suchen alle direkten Kinder einer Collection - nicht die Kindeskinder

// Zuerst das erste Kind
// Das erste Kind hat lft + 1 von der Ausgangs-coll_id

$query_bruder = "SELECT a.coll_id FROM collections AS a, collections AS b WHERE a.lft = b.lft + 1 AND b.coll_id = $coll_id;";

$res_bruder = $opus->query( $query_bruder );
$num_rows_bruder = $opus->num_rows( $res_bruder );
if( $num_rows_bruder > 0 ) { // es gibt mindestens ein Kind
	$mrow = $opus->fetch_row( $res_bruder );
	$erstes_kind = $mrow[0];

	// Nun m�ssen wir alle Br�der rechts vom ersten coll_id holen. 
	// Wir benutzen dazu die funktion coll_ids_rechts, die oben definiert wurde
	
	$collect_ids_bruder = array( $erstes_kind );
	$collect_ids_bruder2 = array();
	$ergebnis_bruder = "unfertig";
	
	while( $ergebnis_bruder == "unfertig" ) { // es gibt einen Eintrag in collect_ids, der bearbeitet werden muss
		global $ergebnis_bruder;	// die Variable muss ge�ndert werden k�nnen, sonst haben wir eine Endlosschleife
		$ergebnis_bruder = coll_ids_rechts( $collect_ids_bruder, $collect_ids_bruder2 ); 	// ruft Funktion auf. $ergebnis wird neu 
												// gesetzt und entscheidet, ob die Schleife 
												// nochmal l�uft oder nicht
	}
	// In collect_ids_bruder gibt es noch coll_ids, die in collect_ids_bruder2 verschoben werden m�ssen
	array_push( $collect_ids_bruder2, array_shift( $collect_ids_bruder ) );
} else {
	echo "<p>Kein Kind</p>";
}
$opus->free_result( $res_bruder );


//***********************************************************************************

// Und nun geben wir sie hintereinander aus:

// Nun geben wir das Elternelement aus:
if( $coll_id > 1 ) {
	$hatkind = hat_kind( $coll_id_eltern );
	echo "\n<ul>\n";
	if( $hatkind == "true" ) {
		echo "<li /><a href=\"abfrage_collections.php?coll_id=${coll_id_eltern}&la=$la\"> $coll_name_eltern</a> ";
	} else {
		echo "<li />$coll_name_eltern ";
	}
	if( $anzahl_doks_eltern == 0 ) {
		echo "( $anzahl_doks_eltern Docs )\n";
	} else {
		echo "( <a href=\"ergebnis.php?suchart=teil&Lines_Displayed=10&sort=o.date_year+DESC%2C+o.title&suchfeld1=oc.coll_id&suchwert1=$coll_id_eltern&opt1=AND&suchfeld2=person&suchwert2=&opt2=AND&suchfeld3=data_year&suchwert3=&startindex=0&page=0&dir=2&suche=&la=$la\">$anzahl_doks_eltern Docs</a> )\n";
	}
}
// Dann die Geschwister
echo "\n<ul>\n";
$num_geschwister = sizeof( $geschwister );

for( $i = 0; $i < $num_geschwister; $i++ ) {
	if( $geschwister[$i] == $coll_id ) {
		$hatkind1 = hat_kind( $geschwister[$i] );
		$anzahl_doks_geschwister = anzahl_doks( $geschwister[$i] );
		$name_geschwister = get_coll_name( $geschwister[$i] );
		if( $hatkind1 == "true" ) {
			echo "<li /><b><a href=\"abfrage_collections.php?coll_id=${geschwister[$i]}&la=$la\">$name_geschwister</a> ";
		} else {
			echo "<li /><b>$name_geschwister ";
		}
		if( $anzahl_doks_geschwister == 0 ) {
			echo "( $anzahl_doks_geschwister Docs )</b>\n";
		} else {
			echo "( <a href=\"ergebnis.php?suchart=teil&Lines_Displayed=10&sort=o.date_year+DESC%2C+o.title&suchfeld1=oc.coll_id&suchwert1=$geschwister[$i]&opt1=AND&suchfeld2=person&suchwert2=&opt2=AND&suchfeld3=data_year&suchwert3=&startindex=0&page=0&dir=2&suche=&la=$la\">$anzahl_doks_geschwister Docs</a> )</b>\n";
		}

		// Ausgabe der Kinder
		echo "<ul>\n";
		$num_brueder = sizeof( $collect_ids_bruder2 );
		for( $j = 0; $j < $num_brueder; $j++ ) {
			$hatkind2 = hat_kind( $collect_ids_bruder2[$j] );
			$anzahl_doks_kind = anzahl_doks( $collect_ids_bruder2[$j] );
			$name_kind = get_coll_name( $collect_ids_bruder2[$j] );
			if( $hatkind2 == "true" ) {
				echo "<li><a href=\"abfrage_collections.php?coll_id=${collect_ids_bruder2[$j]}&la=$la\">$name_kind</a> ";
			} else {
				echo "<li>$name_kind ";
			}
			if( $anzahl_doks_kind == 0 ) {
				echo "( $anzahl_doks_kind Docs )\n";
			} else {
				echo "( <a href=\"ergebnis.php?suchart=teil&Lines_Displayed=10&sort=o.date_year+DESC%2C+o.title&suchfeld1=oc.coll_id&suchwert1=$collect_ids_bruder2[$j]&opt1=AND&suchfeld2=person&suchwert2=&opt2=AND&suchfeld3=data_year&suchwert3=&startindex=0&page=0&dir=2&suche=&la=$la\">$anzahl_doks_kind Docs </a> )\n";
			}
		}
		echo "</ul>\n";
	} 
    else {
        if( $geschwister_an == 1 ) {
            $hatkind3 = hat_kind( $geschwister[$i] );
            $anzahl_doks_geschwister = anzahl_doks( $geschwister[$i] );
            $name_geschwister = get_coll_name( $geschwister[$i] );
            if( $hatkind3 == "true" ) {
                echo "<li /><a href=\"abfrage_collections.php?coll_id=${geschwister[$i]}&la=$la\">$name_geschwister</a> ";
            } else {
                echo "<li />$name_geschwister ";		}
            if( $anzahl_doks_geschwister == 0 ) {
                echo "( $anzahl_doks_geschwister Docs )</b>\n";
            } else {
                echo "( <a href=\"ergebnis.php?suchart=teil&Lines_Displayed=10&sort=o.date_year+DESC%2C+o.title&suchfeld1=oc.coll_id&suchwert1=$geschwister[$i]&opt1=AND&suchfeld2=person&suchwert2=&opt2=AND&suchfeld3=data_year&suchwert3=&startindex=0&page=0&dir=2&suche=&la=$la\">$anzahl_doks_geschwister Docs</a> )</b>\n";
            }
        }
	}
}
echo "</ul>\n";
if( $coll_id > 1 ) {
	echo "</ul>\n";
}





$opus->close($sock);

$design->foot("abfrage_collections.$php", $la);

?>
