<?
/*
	File: dateimanager.php  Rev. 20.12.2004
	------------------------------------
	For use with OPUS Document Server by A. Maile, UB Stuttgart
	Based on 'change_document_files.php' by G. Schupfner, UB Regensburg
	Modified by M. Reymann, UB Regensburg
*/
#############################################################
# letzte nderung:
#
# 22.4.2005, Annette Maile, UB Stuttgart
# Auslagerung Design in lib/design.php
# In Abhaengigkeit von $la kann das entsprechende Design eingelesen werden.
#
#############################################################

include ("../../lib/class.configFile.php");
$conf = new configFile ("../../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");
$table = $conf->value("temp_table");

include ("../../lib/class.opus_$dbms.$php");
$opus = new opus;

$url = $conf->value("url");
define('INCOMING',$conf->value("incoming_pfad"));
define('INCOMING_URL',$conf->value("incoming_url"));
$opustable = $conf->value("opus_table");
$db = $conf->value("db");
$bemerkung_datei_admin = $conf->value("bemerkung_datei_admin");

$titel = $conf->value("titel_dateimanager");
$ueberschrift = $conf->value("ueberschrift_dateimanager");

include ("../../lib/stringValidation.php");
$userfile = $_FILES['userfile'];
$anz_files = count($userfile['name']);
$bem_userfile = $_REQUEST['bem_userfile'];
$bem_userfile = eregi_replace("[`\n\r]","",$bem_userfile);
$creator_name = $_REQUEST['creator_name'];
$creator_name = eregi_replace("[`\n\r]","",$creator_name);
$title = $_REQUEST['title'];
$title = eregi_replace("[`\n\r]","",$title);
$source_opus = $_REQUEST['source_opus'];
if (! _is_valid($source_opus,1,10,"[0-9]+")) {die ("Fehler in Parameter source_opus: $source_opus");}
$jahr = $_REQUEST['jahr'];
if (! _is_valid($jahr,4,4,"[0-9]+")) {die ("Fehler in Parameter jahr");}
$dir_format = $_REQUEST['dir_format'];
if (! _is_valid($dir_format,0,10,"[A-Za-z]*")) {die ("Fehler in Parameter dir_format");}
$pathname = $_REQUEST['pathname'];
if (! _is_valid($pathname,0,300,"[A-Za-z0-9\/\.\_\-]*")) {die ("Fehler in Parameter pathname");}
$bem_pathname = $_REQUEST['bem_pathname'];
if (! _is_valid($bem_pathname,0,300,"[A-Za-z0-9\/\.\_\-]*")) {die ("Fehler in Parameter bem_pathname");}
$bem_file = $_REQUEST['bem_file'];
$bem_file = eregi_replace("[`\n\r]","",$bem_file);
$action  = $_REQUEST['action'];
if (! _is_valid($action,0,20,"[a-z\_]*")) {die ("Fehler in Parameter action");}
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# A.Maile 22.4.05: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}

# Annette Maile, 22.4.05 Design aus lib/design.php einlesen
require ("../../lib/design.$php");
$design = new design;
$design->head_titel($titel);
$design->head_ueberschrift($ueberschrift, $la);

function getSubdirs($path) {
  $subdirs = array();
  $dir = opendir($path);
  while (false != ($entry = readdir($dir))) {
    if ($entry == "." || $entry == "..") {
      continue;
    }
    if (is_dir($path."/".$entry)) {
      $subdirs[] = $entry;
    }
  }
  closedir($dir);
  return $subdirs;
}

function getFiles($path) {
  $files = array();
  $dir = opendir($path);
  while (false != ($entry = readdir($dir))) {
    if ($entry == "." || $entry == "..") {
      continue;
    }
    if (is_file($path."/".$entry)) {
      $files[] = $entry;
    }
  }
  closedir($dir);
  sort($files);
  return $files;
}

function getDirList($path,$level=0) {
  global $PHP_SELF, $creator_name, $title, $source_opus, $jahr, $bemerkung_datei_admin;
  
  $dir = opendir($path);
  $nentries = 0;
  $spaces = '';
  for ($i=0; $i<$level; $i++) {
    $spaces .= '&nbsp;&nbsp;';
  }
  while (false != ($entry = readdir($dir))) {
    if ($entry == "." || $entry == "..") {
      continue;
    }
    $entries[] = $entry;
    $nentries++;
//    sort($entries);
  }
  for ($i=0; $i<$nentries; $i++) {
    if (is_dir($path."/".$entries[$i])) {
	echo("<form action=\"$PHP_SELF\" method=\"POST\" enctype=\"multipart/form-data\">\n");
      echo("$spaces$entries[$i]:\n");
	echo("<input type=\"file\" name=\"userfile\">\n");
	if ($bemerkung_datei_admin) {
		echo("Bemerkung: <input type=\"text\" name=\"bem_userfile\">\n");
	}
	echo("<INPUT TYPE = submit  VALUE=\"Neue $entries[$i] - Datei hochladen\">\n");
        echo("<INPUT TYPE = hidden NAME=\"creator_name\" VALUE=\"$creator_name\">\n");
        echo("<INPUT TYPE = hidden NAME=\"title\" VALUE = \"$title\">\n");
        echo("<INPUT TYPE = hidden NAME=\"source_opus\" VALUE=\"$source_opus\">\n");
        echo("<INPUT TYPE = hidden NAME=\"jahr\" VALUE=\"$jahr\">\n");
	echo("<INPUT TYPE = hidden NAME=\"pathname\" VALUE=\"$path/$entries[$i]\">\n");
        echo("<INPUT TYPE = hidden NAME=\"action\" VALUE=\"upload\">\n");
	echo("<input type=\"hidden\" name=\"la\" value=\"$la\">\n");
        echo("<br><br></form>\n");
      getDirList ($path."/".$entries[$i],$level+1);
    }
    else {
      $urlpath = ereg_replace(INCOMING,INCOMING_URL,$path);
      $entry_enc = urlencode($entries[$i]);
      $entry_enc = htmlentities($entry_enc);
      $entry_enc = ereg_replace("\+","%20",$entry_enc);
      
/*      if ($level==0 && $entries[$i] == 'index.html') {
        echo("<a href=\"$urlpath/$entry_enc\">$spaces$entries[$i]</a>\n");
      }
*/
      /* Dateien, die mit .bem_ beginnen sind Bemerkungen zu den Dateien,    */
      /* daher werden nur Dateien, die nicht mit .bem_ anfangen aufgelistet, */
      /* damit sie gegebenenfalls geloescht werden koennen.                  */
      if ($level!=0 && $entries[$i] != 'index.html' && ereg("^.bem_*", $entries[$i]) != 1) {
        echo("<form action=\"$PHP_SELF\" method=\"POST\">\n");
        echo("<a href=\"$urlpath/$entry_enc\">$spaces$entries[$i]</a>\n");
	echo("$spaces<INPUT TYPE = submit  VALUE=\"$entries[$i] l&ouml;schen\">\n");
        echo("<INPUT TYPE = hidden NAME=\"creator_name\" VALUE=\"$creator_name\">\n");
        echo("<INPUT TYPE = hidden NAME=\"title\" VALUE = \"$title\">\n");
        echo("<INPUT TYPE = hidden NAME=\"source_opus\" VALUE=\"$source_opus\">\n");
        echo("<INPUT TYPE = hidden NAME=\"jahr\" VALUE=\"$jahr\">\n");
	echo("<INPUT TYPE = hidden NAME=\"pathname\" VALUE=\"$path/$entries[$i]\">\n");
	echo("<INPUT TYPE = hidden NAME=\"bem_pathname\" VALUE=\"$path/.bem_$entries[$i]\">\n");
        echo("<INPUT TYPE = hidden NAME=\"action\" VALUE=\"delete\">\n");
	echo("<input type=\"hidden\" name=\"la\" value=\"$la\">\n");
        echo("</form><br>\n");

	if ($bemerkung_datei_admin) {
		$bem_file = "";
		if (file_exists("$path/.bem_$entries[$i]")) {
			$fd = fopen("$path/.bem_$entries[$i]", "r");
			$bem_file = fread ($fd, filesize("$path/.bem_$entries[$i]"));
			fclose($fd);
		}
		echo("<form action=\"$PHP_SELF\" method=\"POST\">\n");	
		echo("<br>Bemerkung zu $entries[$i]: \n");
		echo("<INPUT TYPE = \"text\" NAME=\"bem_file\" VALUE=\"$bem_file\" size=\"30\">\n");
		echo("<INPUT TYPE = hidden NAME=\"bem_pathname\" VALUE=\"$path/.bem_$entries[$i]\">\n");
		echo("<INPUT TYPE = \"hidden\" NAME=\"action\" VALUE=\"bem_aendern\">\n");
		echo("$spaces<INPUT TYPE = submit  VALUE=\"Bemerkung zu $entries[$i] &auml;ndern\">\n");
		echo("<INPUT TYPE = hidden NAME=\"creator_name\" VALUE=\"$creator_name\">\n");
		echo("<INPUT TYPE = hidden NAME=\"title\" VALUE = \"$title\">\n");
		echo("<INPUT TYPE = hidden NAME=\"source_opus\" VALUE=\"$source_opus\">\n");
		echo("<INPUT TYPE = hidden NAME=\"jahr\" VALUE=\"$jahr\">\n");
		echo("<input type=\"hidden\" name=\"la\" value=\"$la\">\n");
		echo("</form><p>\n");
	  }
	}
      echo("\n");
    }
  }
  closedir($dir);
  if ($level > 0) {echo("<hr width=\"50%\" align=\"left\"");}
}

function getFormats() {
global $opus, $db;
$res = array();
print("<FONT COLOR=red>");
$sock = $opus->connect();
if ($sock < 0 ) {
       	echo ("Error: $ERRMSG\n");
}

if ($opus->select_db($db)  < 0 ) {
       	echo ("Error: $ERRMSG\n");
}
print("</FONT>");

$res = $opus->query("SELECT name, diss_format, extension FROM format" );
$num = $opus->num_rows($res);
if ( $num == 0 ) {
	echo("Tabelle \"format\" in \"".$opustable."\" ist leer!");
	return(FALSE);
}

$i = 0;
while ($i < $num) {
	$i++;
        $mrow[] = $opus->fetch_row($res);
}
return($mrow);
}

function isValidFormat($format){
$validformats = getFormats();
$valid = 0;
foreach($validformats as $vformat){
	if ($format == $vformat[2]) $valid = 1;
}
if ($valid == 0){
	echo("\"$format\" ist kein g&uuml;ltiges Format!<br>");
	return(FALSE);
}
return(TRUE);
}

// SICHERHEIT: Teste Gltigkeit der geposteten Argumente ($jahr 1000-2999, $source_opus > 0)

if (!preg_match("/^[1-9]\d*$/", $source_opus) || !preg_match("/^[12]\d{3}$/", $jahr)){
	echo("Invalid Arguments. Exiting.");
	exit();
}

// Switch ACTION:

$title = htmlspecialchars(stripslashes($title));
switch ($action) {
  // alte Dateien loeschen
  case 'delete':
    echo("<font color=\"red\">Datei '$pathname' wurde gel&ouml;scht. Bitte Indexdatei neu erzeugen.</font><hr>\n");
    unlink($pathname);
    if (file_exists($bem_pathname)) {
	 unlink($bem_pathname);
    } 
  break;

  case 'bem_aendern':
   if ($bem_file == "") {
	unlink($bem_pathname);
   }
   else {
	$fd = fopen("$bem_pathname", "w");
	fwrite ($fd, "$bem_file");
	fclose($fd);
   }
    
  break;

  // neue Dateien hochladen
  case 'upload':
    if ($anz_files > 0) {
      $dateiname = urldecode($userfile['name']);
      $dateiname = $opus->reduce_iso($dateiname);
      if (file_exists("$pathname/$dateiname")) {
	echo "<font color=\"red\">Datei '$dateiname' existiert bereits. Wenn Sie die Datei ersetzen
m&ouml;chten, bitte zuerst die Datei l&ouml;schen und dann neu hochladen.</font><hr>\n";
      }
      else {
        move_uploaded_file($userfile['tmp_name'], "$pathname/$dateiname");
	if ($bem_userfile != "") {
		$fd = fopen("$pathname/.bem_$dateiname", "w");
	        fwrite ($fd, "$bem_userfile");
	        fclose($fd);
	}
        echo("<font color=\"red\">Datei '$dateiname' wurde hochgeladen. Bitte Indexdatei neu erzeugen.</font>\n");
      }
      echo("<hr>\n");
    }
    else {
      echo "<font color=\"red\">Hochladen der Datei fehlgeschlagen.</font><hr>\n";
    }
  break;

  // neue Indexdatei
  case 'create_index':
    echo("<font color=\"red\">Indexdatei wurde aktualisiert.</font><hr>\n");
    $ind = fopen(INCOMING."/$jahr/$source_opus/index.html",'w');
    fwrite($ind, "<HTML>\n<HEAD></HEAD>\n<BODY BGCOLOR=FFFFFF ALINK=FFFF00 VLINK=FF0000>\n");
    fwrite($ind, "<FONT SIZE=-1><A HREF=\"../doku/urheberrecht.html\">Hinweis zum Urheberrecht</A></FONT>\n<HR>\n");
    fwrite($ind, "<P>\n<B>$creator_name</B>\n<H3>$title</H3>\n\n<HR>\n\n");
    fwrite($ind, "<P>Dieses Dokument liegt in folgenden Teildokumenten vor: <P>\n");
    $subdirs = getSubdirs(INCOMING."/$jahr/$source_opus");
    for ($i=0; $i<count($subdirs); $i++) {
      $urlpath = INCOMING_URL."/$jahr/$source_opus/$subdirs[$i]";
      fwrite($ind, "<CENTER>\n<TABLE BORDER=1>\n<TR>\n");
      $k=1;
      $files = getFiles(INCOMING."/$jahr/$source_opus/$subdirs[$i]");
      for ($j=0; $j<count($files); $j++) {
        if ($k>3) {
	  fwrite($ind, "</TR>\n<TR>\n");
	  $k = 1;
	}
	$ext = substr(strrchr($files[$j], "."), 1);
        $entry_enc = urlencode($files[$j]);
        $entry_enc = htmlentities($entry_enc);
        $entry_enc = ereg_replace("\+","%20",$entry_enc);
	$docnum = $j+1;

	/* Dateien, die mit .bem_ beginnen sind Bemerkungen zu den Dateien,    */
	/* daher werden nur Dateien, die nicht mit .bem_ anfangen aufgelistet, */
	/* Falls die Bermerkungsdatei vorhanden ist, wird ihr Inhalt ausgegeben*/
	if (ereg("^.bem_*", $files[$j]) != 1) {
		fwrite($ind, "<TD><A HREF=\"$urlpath/$entry_enc\">$files[$j]</A>&nbsp;&nbsp;&nbsp;\n");
		$bem_datei = INCOMING."/$jahr/$source_opus/$subdirs[$i]/.bem_$files[$j]";
                if (file_exists($bem_datei)) {
			$fd = fopen("$bem_datei", "r");
			$bemerkung = fread ($fd, filesize("$bem_datei"));
			fclose($fd);
			fwrite($ind, "$bemerkung\n");
		}

		/* A. Maile, 15.6.05, einfuegen von pdfinfo, falls in opus.conf gesetzt */
		$use_pdfinfo = $conf->value("pdfinfo_active");
		if ( $use_pdfinfo ) {
			$datei = INCOMING."/$jahr/$source_opus/$subdirs[$i]/$files[$j]";
			$pdfinfopath = $conf->value("pdfinfo_path");
			$pdfinfo_inc = $conf->value("pdfinfo_inc");
			include $pdfinfo_inc;
		}
	}

	fwrite($ind, "</TD>\n");

	$k++;
      }
      fwrite($ind, "\n</TR>\n</TABLE> \n");
    }
    fwrite($ind, "<HR>\n<CENTER><A HREF=\"../admin/\">Home</A>\n<CENTER>\n</BODY>\n</HTML>\n");
    fclose($ind);
  break;

  // erzeuge ordner
  case 'create_directory':

  echo("<font color=red>");
  
  if (isValidFormat($dir_format) && !is_dir(INCOMING."/$jahr/$source_opus/$dir_format")){ 
  	echo("<b>'$dir_format' - Ordner wurde erzeugt.</b><br><br>");
  	//echo("mkdir (\"".INCOMING."/$jahr/$source_opus/$dir_format\", 0755) <br><br>\n");
  	mkdir(INCOMING."/$jahr/$source_opus/$dir_format", 0755);
  }
  else echo("Der \"$dir_format\" Ordner existiert bereits.<br><br>");

  echo("</font>");
  break;
  
  // loesche ordner (wenn leer - sonst warnen)
  case 'delete_directory':
  
  echo("<font color=red>");
  if (isValidFormat($dir_format) && is_dir(INCOMING."/$jahr/$source_opus/$dir_format") && count(getFiles(INCOMING."/$jahr/$source_opus/$dir_format")) == 0){
  	echo("<b>'$dir_format' - Ordner wurde gel&ouml;scht.</b><br><br>");
  	//echo("rmdir ".INCOMING."/$jahr/$source_opus/$dir_format<br><br>\n");
  	rmdir(INCOMING."/$jahr/$source_opus/$dir_format");
  }
  else echo("Der \"$dir_format\" Ordner ist nicht leer! L&ouml;schen Sie bitte zuerst alle Dateien in diesem Ordner.<br><br>");
  echo("</font>");
  break;
}

// Dokumenttitel, Autor anzeigen

echo("<b>$creator_name</b>\n<h3>$title</h3><hr>\n");

// Aufforderung, Ordner anzulegen, falls keine vorhanden	

if ((is_dir(INCOMING."/$jahr/$source_opus")) && (count(getSubdirs(INCOMING."/$jahr/$source_opus")) == 0)) {
		echo("F&uuml;r dieses Dokument (ID: $source_opus) existieren keine Unterordner.<br>Bitte w&auml;hlen Sie die Formate aus, f&uuml;r die Ordner erzeugt werden sollen.<br><br>\n");
}


// Dateidialog nur anzeigen, wenn Unterverz. existieren: ---------------------+

if ((is_dir(INCOMING."/$jahr/$source_opus")) && (count(getSubdirs(INCOMING."/$jahr/$source_opus")) > 0)) {
 
// Link & Button fuer Indexdatei

echo("<br><form action=\"$PHP_SELF\" method=\"POST\">\n");
if (file_exists(INCOMING."/$jahr/$source_opus/index.html")) {
	echo("<a href=\"".INCOMING_URL."/$jahr/$source_opus/index.html\">index.html</a> ");
}
echo("<INPUT TYPE = submit  VALUE=\"Neue Indexdatei erzeugen\">\n");
echo("<INPUT TYPE = hidden NAME=\"creator_name\" VALUE=\"$creator_name\">\n");
echo("<INPUT TYPE = hidden NAME=\"title\" VALUE = \"$title\">\n");
echo("<INPUT TYPE = hidden NAME=\"source_opus\" VALUE=\"$source_opus\">\n");
echo("<INPUT TYPE = hidden NAME=\"jahr\" VALUE=\"$jahr\">\n");
echo("<INPUT TYPE = hidden NAME=\"action\" VALUE=\"create_index\">\n");
echo("<input type=\"hidden\" name=\"la\" value=\"$la\">\n");
echo("</form><br><br>\n");

// Link zurueck zu den Metadaten und der Adminseite

echo("<a href=\"aendern.php?suchfeld=source_opus&suchwert=$source_opus&table=$table\">Zur&uuml;ck zum aktualisierten Datensatz</a><br><br>\n");
echo("<a href=\"index.php\">Zur&uuml;ck zur Adminseite</a><br><br>\n");

// Dateien des Dokuments

echo("<hr><b><i>Dateien:</i></b><hr>");

getDirList(INCOMING."/$jahr/$source_opus");

} // -------------------------------------------------------------------------+

// Ordner des Dokuments (immer anzeigen)

echo("<hr><b><i>Ordner:</i></b><hr>");
echo("<table border=1>\n");

if ($res = getFormats()){
	foreach($res as $format){
		echo("<tr><td><form action=\"$PHP_SELF\" method=\"POST\">\n");
		echo("<INPUT TYPE = hidden NAME=\"source_opus\" VALUE=\"$source_opus\">\n");
        	echo("<INPUT TYPE = hidden NAME=\"jahr\" VALUE=\"$jahr\">\n");
        	echo("<INPUT TYPE = hidden NAME=\"creator_name\" VALUE=\"$creator_name\">\n");
        	echo("<INPUT TYPE = hidden NAME=\"title\" VALUE = \"$title\">\n");
		echo("<INPUT TYPE = hidden NAME=\"dir_format\" VALUE=\"$format[2]\">\n");

		if ($format[1] == 1) echo("<u>");

		if (is_dir(INCOMING."/$jahr/$source_opus/$format[2]")){

			echo("<b>".$format[0]."</b>");
			if ($format[1] == 1) echo("</u>");

			echo("</td><td>");
			echo("<INPUT TYPE = submit VALUE=\"$format[2] Ordner l&ouml;schen\">\n");
			echo("<INPUT TYPE = hidden NAME=\"action\" VALUE=\"delete_directory\">\n");
		}
		else {

			echo("<i>".$format[0]."</i>");
			if ($format[1] == 1) echo("</u>");

			echo("</td><td>");
			echo("<INPUT TYPE = submit VALUE=\"$format[2] Ordner erzeugen\">\n");
			echo("<INPUT TYPE = hidden NAME=\"action\" VALUE=\"create_directory\">\n");
		}
        	echo("<input type=\"hidden\" name=\"la\" value=\"$la\">\n");	
		echo("</form></td></tr> \n");
	}
}
else {
	echo ("Formattabelle leer!");
}

echo("</table>\n");
echo("<br><br> (<b>Fett:</b> Ordner existiert - <i>Kursiv:</i> Ordner existiert nicht - <u>Unterstrichen:</u> Pflichtformat)");
// Ende Ordner

$design->foot("dateimanager.$php", $la);
?>
