<?
#############################################################
#
# Funktion: admin/indexfile.php
#           Erstllung statische Indexdatei fuer Suchmaschinen 
# letzte Aenderung:
#
# 22.4.2005, Annette Maile, UB Stuttgart
# Auslagerung Design in lib/design.php
# In Abhaengigkeit von $la kann das entsprechende Design eingelesen werden.
#
# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
#
# 29.7.2005, Annette Maile, UB Stuttgart
# Einfuegen Lizenzvertrag
#
#############################################################

include ("../../lib/class.configFile.php");
$conf = new configFile ("../../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");

include ("../../lib/class.opus_$dbms.$php");
$opus = new opus;

$db = $conf->value("db");
$table = $conf->value("opus_table");
$url = $conf->value("url");
$url_anzeigen = $conf->value("url_anzeigen");
$urn_anzeigen = $conf->value("urn_anzeigen");
$volltext_pfad = $conf->value("volltext_pfad");
$volltext_url = $conf->value("volltext_url") ;
$lic_active = $conf->value("license_active");
$projekt = $conf->value("projekt");
$doku_pfad = $conf->value("doku_pfad");
$email = $conf->value("email");
$home = $conf->value("home");
$ort = $conf->value("ort");
$ddb_idn = $conf->value("ddb_idn");
$ddb_email = $conf->value("ddb_email");
$tar_pfad = $conf->value("tar_pfad");
$gzip_pfad = $conf->value("gzip_pfad");
$titel = $conf->value("titel_indexfile");
$ueberschrift = $conf->value("ueberschrift_indexfile");
$statistik = $conf->value("statistik");
$awstats_url = $conf->value("awstats_url");
$awstats_config = $conf->value("awstats_config");
$empfehlen = $conf->value("empfehlen");

// Anfang Collections
$coll_anzeigen = $conf->value( "coll_anzeigen" );
// Ende Collections

include ("../../lib/stringValidation.php");
$von = $_REQUEST['von'];
if (! _is_valid($von,0,10,"[0-9]*")) {die ("Fehler in Parameter von");}
$bis = $_REQUEST['bis'];
if (! _is_valid($bis,0,10,"[0-9]*")) {die ("Fehler in Parameter bis");}
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# A.Maile 10.2.05: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}

# Annette Maile, 22.4.05 Design aus lib/design.php einlesen
require ("../../lib/design.$php");
$design = new design;
$design->head_titel($titel);
$design->head_ueberschrift($ueberschrift, $la);

print("<FONT COLOR=red>");
$sock = $opus->connect();
if ($sock < 0 ) {
	echo ("Error: $ERRMSG\n");
}
if ($opus->select_db($db) < 0 ) {
	echo ("Error: $ERRMSG\n");
}
print("</FONT>");
$a = $von;
$bis = $bis;

while ($a <= $bis) {
	$res = $opus->query("SELECT * FROM $table WHERE source_opus = $a ");
        $num = $opus->num_rows($res);

        if ($num != 0) {
		$mrow = $opus->fetch_row($res);
		$title  = $mrow[0];
		$creator_corporate = $mrow[1];
		$subject_swd = $mrow[2];
		$description = $mrow[3];
		$publisher_university = $mrow[4];
		$contributors_name = $mrow[5];
		$contributors_corporate = $mrow[6];
		$date_year = $mrow[7];
		$date_creation = $mrow[8];
		$date_modified_old = $mrow[9];
		$type = $mrow[10];
		$source_opus = $mrow[11];
		$source_title = $mrow[12];
		$source_swb = $mrow[13];
		$language = $mrow[14];
		$verification= $mrow[15];
		$subject_uncontrolled_german = $mrow[16];
		$subject_uncontrolled_english= $mrow[17];
		$title_en = $mrow[18];
		$description2 = $mrow[19];
		$subject_type = $mrow[20];
		$date_valid = $mrow[21];
		$description_lang = $mrow[22];
		$description2_lang = $mrow[23];
		$sachgruppe_ddc = $mrow[24];
		$urn = $mrow[25];
		$bereich_id = $mrow[26];
		if ($lic_active >= 2) { 
			$lic = $mrow[27]; 
		}
		$isbn = $mrow[28];
		$bem_extern = $mrow[30];

		$opus->free_result($res); 

		/***** Schriftenreihe Start *****/	
		$table_sr = $table . "_schriftenreihe";
		$res = $opus->query("SELECT * FROM $table_sr WHERE source_opus = $source_opus ");
		$num_res = $opus->num_rows($res);
		if ($num_res > 0) {
		        $mrow = $opus->fetch_row($res);
		        $sr_id   = $mrow[1];
		        $sr_band = $mrow[2];
		        $res = $opus->query("select name from schriftenreihen where sr_id = '$sr_id' ");
		        $mrow = $opus->fetch_row($res);
		        $sr_name = $mrow[0];
		        $opus->free_result($res);
		}
		/***** Schriftenreihe Stop *****/	

		/* Bei Dissertation (type 8) und Habilitation (type 24) zusaetzlich */
		/* Tag der muendlichen Pruefung (bzw. des Kolloquiums) und Hauptberichter anzeigen */
		/* und Fakulaet aus der Tabelle opus_diss nehmen */
		if ($type == "8" || $type == "24") {
			$table_diss = $table . "_diss";
			$res = $opus->query("SELECT * FROM $table_diss WHERE source_opus = $source_opus");
			$anz = $opus->num_rows($res);
			if ( $anz  > 0 ) {
				$mrow = $opus->fetch_row($res);
				$date_accepted = $mrow[1];
				$advisor = $mrow[2];
				$title_de = $mrow[3];
				$fak_nr = $mrow[4];
			}
			$opus->free_result($res);

			$res = $opus->query("select fakultaet from faculty_$la where nr = '$fak_nr' ");
			$mrow = $opus->fetch_row($res);
			$fakultaet_diss = $mrow[0];
			$opus->free_result($res);
		}
		else {
			$date_accepted = "";
			$advisor = "";
			$title_de = "";
			$fakultaet_diss = "";
		}

		$jahr = date("Y", $date_creation);

		$res = $opus->query("SELECT sprache FROM language_$la WHERE code='$language'");
		$mrow = $opus->fetch_row($res);
		$sprache=$mrow[0];
		$opus->free_result($res);

		$res = $opus->query("SELECT sprache FROM language_$la WHERE code='$description_lang'");
		$mrow = $opus->fetch_row($res);
		$sprache_description=$mrow[0];
		$opus->free_result($res);

		if ($description2_lang != "") {
			$res = $opus->query("SELECT sprache FROM language_$la WHERE code='$description2_lang'");
			$mrow = $opus->fetch_row($res);
			$sprache_description2=$mrow[0];
			$opus->free_result($res);
		}

		$res = $opus->query("SELECT type, dokumentart FROM resource_type_$la WHERE typeid='$type'");
		$mrow = $opus->fetch_row($res);
		$typename=$mrow[0];
		$dokumentart=$mrow[1];
		$opus->free_result($res);

		if ($lic_active >= 2) {
			$res = $opus->query("SELECT longname, link, logo, desc_text, desc_html FROM license_$la WHERE shortname='$lic'");
			$licnum = $opus->num_rows($res);
			if ($licnum == 1) {
				$mrow = $opus->fetch_row($res);
				$licname=$mrow[0]; 
				$liclink=$mrow[1]; 
				$liclogo=$mrow[2]; 
				$licdesc=$mrow[3]; 
				$licdesc_html=$mrow[4];
			}
			$opus->free_result($res);
			$liclink_head = "<a href=\"".$liclink."\" target=\"_blank\">Lizenz</a><p />";
		} 
		else {
			$liclink_head = "<a href=\"".$doku_pfad."/urheberrecht.php\">Urheberrechtshinweis / Copyright notice</a><p />";
		}

		if ($subject_type != "") {
			$table_subject_type = $table . "_$subject_type";
			$res = $opus->query("SELECT class from $table_subject_type where source_opus = $source_opus ");
			$num = $opus->num_rows($res);
			if ($num > 0) {
				$mrow = $opus->fetch_row($res);
				$subject_value = $mrow[0];
				$i = 1;
				while ($i < $num) {
					$i++;
					$mrow = $opus->fetch_row($res);
					$subject_value = "$subject_value , $mrow[0]";
				}
				$opus->free_result($res);
				$res = $opus->query("SELECT name, scheme from klassifikation_$la where table_name = '$subject_type' ");
				$mrow = $opus->fetch_row($res);
				$class_name = $mrow[0];
				$class_scheme = $mrow[1];
			}
			$opus->free_result($res);
		}

		# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
		# Falls in Altbestaenden (< Opus 3.0) kein Bereich angegeben ist,
		# wird bereich_id auf 1 gesetzt = freier Zugriff auf die Dokumente,
		# sonst kommt eine Fehlermeldung der Datenbank
		if ($bereich_id == "" || $bereich_id == 0) {
		        $bereich_id = 1;
		}

		$res = $opus->query("SELECT volltext_pfad, volltext_url FROM bereich_$la WHERE bereich_id = $bereich_id");
		$num = $opus->num_rows($res);
		if ($num > 0) {
			$mrow = $opus->fetch_row($res);
			$volltext_pfad = $mrow[0];
			$volltext_url = $mrow[1];
			$opus->free_result($res);
		}
		# Ende Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche

		if (file_exists("$volltext_pfad/$jahr/$source_opus")) {
			$fd = fopen("$volltext_pfad/$jahr/$source_opus/index.html","w");
			if ($fd == 0){
				echo("Error: $ERRMSG <BR>\n");
			}
			else {
				fwrite($fd, "<HTML>\n<HEAD>\n");
				
				/* zusaetzliche Meta-Tags bei Dissertation und Habilitation */
				if ($type == "8" || $type == "24") {
					fwrite($fd, "<META NAME=\"DC.Publisher.CorporateName\" CONTENT=\"Universit&auml;tsbibliothek\">\n");
					fwrite($fd, "<META NAME=\"DC.Publisher.CorporateName.Address\" CONTENT=\"$ort\">\n");
					$contributor = "$publisher_university, $fakultaet_diss";
					$contributor = htmlspecialchars($contributor);
					fwrite($fd, "<META NAME=\"DC.Contributor.CorporateName\" CONTENT=\"$contributor\">\n");
					$date_accepted_iso8601 = $opus->dateiso8601($date_accepted);
					fwrite($fd, "<META NAME=\"DC.Date.Accepted\" SCHEME=\"ISO8601\" CONTENT=\"$date_accepted_iso8601\">\n");
					$advisor = htmlspecialchars($advisor);
					fwrite($fd, "<META NAME=\"DC.Contributor.Advisor\" CONTENT=\"$advisor\">\n");
				}

				if ($publisher_university!= ""){
					$publisher_university=htmlspecialchars($publisher_university);
					fwrite($fd, "<META NAME=\"DC.Publisher\" CONTENT=\"$publisher_university\">\n");
				}

				$inst = $opus->query("select i.name, f.fakultaet from institute_$la i, faculty_$la f, opus_inst oi where oi.source_opus = $source_opus and i.nr = oi.inst_nr and f.nr = i.fakultaet ");
				$anzahl_inst = $opus->num_rows($inst);
				$i = 0;
				while ($i < $anzahl_inst) {
					$mrow = $opus->fetch_row($inst);
					$publisher_inst = $mrow[0];
					$fakultaet = $mrow[1];
					$fakultaet = htmlspecialchars($fakultaet);
					fwrite($fd, "<META NAME=\"DC.Publisher\" CONTENT=\"$fakultaet\">\n");
					$publisher_inst = htmlspecialchars($publisher_inst);
					fwrite($fd, "<META NAME=\"DC.Publisher\" CONTENT=\"$publisher_inst\">\n");
					$i++;
				}

				if ($title != ""){
					$title=htmlspecialchars($title);
					fwrite($fd, "<META NAME=\"DC.Title\" LANG=\"$language\" CONTENT=\"$title\">\n");
					$search_title = $title;
				}

				if ($title_en != ""){
					$title_en=htmlspecialchars($title_en);
					fwrite($fd, "<META NAME=\"DC.Title.Translated\" LANG=\"eng\" CONTENT=\"$title_en\">\n");
					$search_title.= " - $title_en";
				}

				if ($title_de != ""){
					$title_de=htmlspecialchars($title_de);
					fwrite($fd, "<META NAME=\"DC.Title.Translated\" LANG=\"ger\" CONTENT=\"$title_de\">\n");
					$search_title.= " - $title_de";
				}
				fwrite($fd, "<meta name=\"title\" content=\"$search_title\">\n");

				$table_autor = $table . "_autor";
				$autor = $opus->query("SELECT creator_name, reihenfolge FROM $table_autor WHERE source_opus = $source_opus order by reihenfolge");
				$anzahl_creator_name = $opus->num_rows($autor);
				$i = 0;
				if ($anzahl_creator_name > 0) {
					while ($i < $anzahl_creator_name) {
						$mrow = $opus->fetch_row($autor);
						$creator_name=$mrow[0];
						$creator_name=htmlspecialchars($creator_name);
						fwrite($fd, "<META NAME=\"DC.Creator.PersonalName\" CONTENT=\"$creator_name\">\n");	
						$search_creator.= " ; ".$creator_name;
						$i++;
					}
					fwrite($fd, "<meta name=\"author\" content=\"".substr($search_creator,3)."\">\n");
				}
				
// Anfang Collections
				if( $coll_anzeigen == "true" ) {
                                        $search_creator = "";
					$table_coll = $table . "_coll";
					$coll = $opus->query( "SELECT b.coll_id, b.coll_name FROM $table_coll AS a, collections AS b WHERE a.coll_id = b.coll_id AND a.source_opus = $source_opus" );
					$anzahl_coll = $opus->num_rows( $coll );
					$i = 0;
					if( $anzahl_coll > 0 ) {
						while( $i < $anzahl_coll ) {
							$mrow = $opus->fetch_row( $coll );
							$collection = $mrow[1];
							$collection = htmlspecialchars( $collection );
							fwrite( $fd, "<META NAME=\"DC.Relation.isPartOf\" CONTENT=\"$collection\" \n");
							$i++;
						}
					}
				}
// Ende Collections

				if ($creator_corporate!= ""){
					$creator_corporate=htmlspecialchars($creator_corporate);
					fwrite($fd, "<META NAME=\"DC.Creator.CorporateName\" CONTENT=\"$creator_corporate\">\n");
				}

				if ($subject_swd!= ""){
					$subject_swd=htmlspecialchars($subject_swd);
					fwrite($fd, "<META NAME=\"DC.Subject\" SCHEME=\"SWD\" CONTENT=\"$subject_swd\">\n");
					$search_keys = $subject_swd;
				}
				if ($sachgruppe_ddc != "" && $sachgruppe_ddc != "no") {
					fwrite($fd, "<META NAME=\"DC.Subject\" SCHEME=\"DDC-Sachgruppe\" CONTENT=\"$sachgruppe_ddc\">\n");
				}
				if ($subject_type != "") {
					$subject_value = htmlspecialchars($subject_value);
					fwrite($fd, "<META NAME=\"DC.Subject\" SCHEME=\"$class_scheme\" CONTENT=\"$subject_value\">\n");
				}

				if ($subject_uncontrolled_german != "") {
					$subject_uncontrolled_german = htmlspecialchars($subject_uncontrolled_german);
					fwrite($fd, "<META NAME=\"DC.Subject\" LANG=\"ger\" CONTENT=\"$subject_uncontrolled_german\"> \n");
					$search_keys.= " , $subject_uncontrolled_german";
				}

				if ($subject_uncontrolled_english != "") {
					$subject_uncontrolled_english = htmlspecialchars($subject_uncontrolled_english);
					fwrite($fd, "<META NAME=\"DC.Subject\" LANG=\"eng\" CONTENT=\"$subject_uncontrolled_english\"> \n");
					$search_keys.= " , $subject_uncontrolled_english";
				}
				fwrite($fd, "<meta name=\"keywords\" content=\"$search_keys\"> \n");

				if ($contributors_name!= ""){
					$contributors_name=htmlspecialchars($contributors_name);
					fwrite($fd, "<META NAME=\"DC.Contributor.PersonalName\" CONTENT=\"$contributors_name\">\n");
				}

				if ($contributors_corporate!= ""){
					$contributors_corporate=htmlspecialchars($contributors_corporate);
					fwrite($fd, "<META NAME=\"DC.Contributor.CorporateName\" CONTENT=\"$contributors_corporate\">\n");
				}

				if ($date_year!= ""){
					fwrite($fd, "<META NAME=\"DC.Date.Creation_of_intellectual_content\" CONTENT=\"$date_year\">\n");
				}

				if ($date_creation!= ""){
					$date_creation_iso8601 = $opus->dateiso8601($date_creation);
					fwrite($fd, "<META NAME=\"DC.Date.Creation_of_present_form\" SCHEME=\"ISO8601\" CONTENT=\"$date_creation_iso8601\">\n");
				}

				if ($typename!= ""){
					fwrite($fd, "<META NAME=\"DC.Type\" CONTENT=\"$typename\">\n");
				}

				if ($lic_active >= 2) {
					if ($licname!= ""){
						fwrite($fd, "<meta name=\"DC.Rights\" scheme=\"DCTERMS.URI\" content=\"".$liclink."\">\n");
						fwrite($fd, "<meta name=\"DC.Rights\" content=\"".$licname."\">\n");
					}
				}

				$res = $opus->query("SELECT extension, mime_type FROM format WHERE name <> 'Originalformat'");
				$anz = $opus->num_rows($res);
				$i = 0;
				while ( $anz  > $i ) {
					$i++;
					$mrow = $opus->fetch_row($res);
					$ext = $mrow[0];
					$format = $mrow[1];
					if (file_exists("$volltext_pfad/$jahr/$source_opus/$ext") == 1) {
						fwrite($fd, "<META NAME=\"DC.Format\" SCHEME=\"IMT\" CONTENT=\"$format\">\n");
					}
				}
				$opus->free_result($res);

				if ($urn != ""){
					fwrite($fd, "<META NAME=\"DC.Identifier\" SCHEME=\"urn:nbn:de\" CONTENT=\"$urn\">\n");
				}
				fwrite($fd, "<META NAME=\"DC.Identifier\" SCHEME=\"URL\" CONTENT=\"$volltext_url/$jahr/$source_opus/\">\n");
				if ($isbn != "") {
					fwrite($fd, "<META NAME=\"DC.Identifier\" SCHEME=\"ISBN\" CONTENT=\"$isbn\">\n");
				}

				if ($source_title!= ""){
					$source_title=htmlspecialchars($source_title);
					fwrite($fd, "<META NAME=\"DC.Source\" CONTENT=\"$source_title\">\n");
				}

				if ($source_swb!= ""){
					fwrite($fd, "<META NAME=\"DC.Source\" CONTENT=\"SWB-IDNR/$source_swb\">\n");
				}

				if ($source_opus!= ""){
					fwrite($fd, "<META NAME=\"DC.Source\" CONTENT=\"$projekt-IDN/$source_opus\">\n");
				}

				if ($language!= ""){
					fwrite($fd, "<META NAME=\"DC.Language\" SCHEME=\"ISO639-2\" CONTENT=\"$language\">\n");
				}

				if ($description!= ""){
					$description=htmlspecialchars($description);
					fwrite($fd, "<META NAME=\"DC.Description\" LANG=\"$description_lang\" CONTENT=\"$description\">\n");
					$search_description = $description;
				}

				if ($description2!= ""){
					$description2=htmlspecialchars($description2);
					fwrite($fd, "<META NAME=\"DC.Description\" LANG=\"$description2_lang\" CONTENT=\"$description2\">\n");
					$search_description.= "\n$description2";
				}
				fwrite($fd, "<meta name=\"description\" content=\"$search_description\">\n");

				fwrite($fd, "<TITLE>$projekt - $title</TITLE>");
				$opus->file2file("../../lib/body_$la.html",$fd);
				fwrite ($fd, "Eingang zum Volltext");
				$opus->file2file("../../lib/ueberschriftende_$la.html",$fd);
				fwrite($fd, "<FONT SIZE=-1>$liclink_head \n");
				fwrite($fd, "Bitte beziehen Sie sich beim Zitieren dieses Dokumentes immer auf folgende<BR>\n"); 
				# Wenn Urn vorhanden und urn_anzeigen auf 1 gesetzt ist, wird die Urn angezeigt.
				# Wenn keine Urn vorhanden ist und url_anzeigen auf 2 gesetzt ist, dann Url anzeigen.
				# Wenn url_anzeigen auf 1 gesetzt ist, dann immer Url anzeigen.
				if ($urn && $urn_anzeigen) {
					fwrite($fd, "URN: <a href=\"http://nbn-resolving.de/urn/resolver.pl?urn=$urn\"><B>$urn</B></a><BR>\n");
				}
				else {
					if ($url_anzeigen == 2) {
						fwrite($fd, "URL: <a href=\"$volltext_url/$jahr/$source_opus/\"><B>$volltext_url/$jahr/$source_opus/</a></B> \n");
					}
				}	
				if ($url_anzeigen == 1) {
					fwrite($fd, "URL: <a href=\"$volltext_url/$jahr/$source_opus/\"><B>$volltext_url/$jahr/$source_opus/</a></B> \n");
				}
				fwrite($fd, "</FONT>\n<HR>\n");
				$opus->file2file("../../lib/font.html",$fd);

				if ($anzahl_creator_name > 0) {
					$link = "$url/ergebnis.$php?suchart=teil&Lines_Displayed=10&sort=o.date_year+DESC%2C+o.title&suchfeld1=freitext&suchwert1=&opt1=AND&opt2=AND&suchfeld3=date_year&suchwert3=&startindex=0&page=0&dir=2&suche=&suchfeld2=oa.person&suchwert2=";

					$opus->data_seek ($autor, 0);
					$i = 0;	
					while ($i < $anzahl_creator_name) {
						$i++;
						$mrow = $opus->fetch_row($autor);
						$creator_name=$mrow[0];
						$person = htmlspecialchars(rawurlencode($creator_name));
						$creator_name=stripslashes(htmlspecialchars($creator_name));
						
						if ($i > 1) {
							fwrite($fd, " ; \n<B><A HREF=\"$link$person\">$creator_name</A></B>");
							$pod_creator_names.= " ; ".$person;
						}
						else {
							fwrite($fd, "<B><A HREF=\"$link$person\">$creator_name</A></B>");
							$verfasser = $creator_name;
							$pod_creator_names = $person;
						}
					}
					fwrite($fd, "\n");
				}
				$opus->free_result($autor);

				if ($contributors_name != "") {
					fwrite($fd, "\n<BR>Weitere Beteiligte (Hrsg. etc.): $contributors_name");
				}

				if ($creator_corporate != "") {
					fwrite($fd, "\n<BR>$creator_corporate");
				}

				if ($contributors_corporate != "") {
					fwrite($fd, "\n<BR>$contributors_corporate");
				}

				fwrite($fd, "\n</B><P>\n");
				fwrite($fd, "<H3>$title</H3>\n");

				if ($title_en != "") {
					fwrite($fd, "<H3>$title_en</H3>\n");
				}                       
                        
				if ($title_de != "") {  
					fwrite($fd, "<H3>$title_de</H3>\n");
				}    

				/* Es werden die Formate, die in der Tabelle Format im Feld extension stehen */
				/* in der Frontdoor angezeigt. Es wird geschaut, ob das jeweilige Directory  */
				/* exisitiert und die darin enthaltenen Dateien in einer Tabelle ausgegeben  */
				fwrite($fd, "<TABLE> \n");

				$format = $opus->query("select extension from format where name <> 'Originalformat' ");
				$num_format = $opus->num_rows($format);
				$f = 0;
				$j = 1;
				while ($f < $num_format) {
					$f++;
					$mrow = $opus->fetch_row($format);
					$ext = $mrow[0];
					if (file_exists("$volltext_pfad/$jahr/$source_opus/$ext") == 1) {
						$startfile = "";
						$handle = opendir("$volltext_pfad/$jahr/$source_opus/$ext");
						while ($file = readdir($handle)) {
							if (ereg(".*.anzeigen", $file) == 1) {
								$startfile = $file;
							}
						}
						closedir($handle);

			               		if ($startfile != "") {
				                        /* fuehrenden Punkt und .anzeigen entfernen = Startfile des html-Dokuments */
				                        $startfile = str_replace(".anzeigen", "", $startfile);
				                        $startfile = substr($startfile, 1);
							fwrite($fd, "<TR><TD>");
							$opus->file2file("../../lib/font.html",$fd);
							fwrite($fd, "$ext-Format: </TD>\n");
				                        fwrite($fd, "\n<TD><TABLE BORDER=3 CELLPADDING=4 CELLSPACING=4>\n<TR>\n<TD>");
							$opus->file2file("../../lib/font.html",$fd);
				                        fwrite($fd, "<A HREF=\"$volltext_url/$jahr/$source_opus/$ext/$startfile\">Dokument1.$ext </A>\n</TD>\n");
							fwrite($fd, "</TR>\n</TABLE>\n");
							fwrite($fd, "</TD>\n</TR>\n");
				                }
					        else {
							$i = 1;
							$j = 1;
							$handle = opendir("$volltext_pfad/$jahr/$source_opus/$ext");
							while ($line = readdir($handle)) {
								if ($line != "." && $line != "..") {
									/* Dateien, die mit .bem_ beginnen sind Bemerkungen */
									/* zu den Dateien, daher werden nur Dateien, die nicht*/
									/* mit .bem_ anfangen in der Indexseite aufgelistet.  */
									/* Gepackte Dateien werden separat aufgelistet */
									if (ereg("^.bem_*", $line) != 1 && eregi(".*.zip", $line) != 1 && eregi(".*.gz", $line) != 1) {
										$dir_array[count($dir_array)] = $line;
									}
								}
							}
							closedir($handle);
							sort($dir_array);
							$k = 0;
							$num = count($dir_array);
							if ($num > 0) {
								fwrite($fd, "<TR><TD>");
								$opus->file2file("../../lib/font.html",$fd);
								fwrite($fd, "$ext-Format: </TD>\n");
								fwrite($fd, "\n<TD><TABLE BORDER=3 CELLPADDING=4 CELLSPACING=4>\n<TR>\n");
							}

							while ($k < $num) {
								$line = array_shift($dir_array);
								$bem_file = "";
								if (file_exists("$volltext_pfad/$jahr/$source_opus/$ext/.bem_$line")) {
									$fd3 = fopen("$volltext_pfad/$jahr/$source_opus/$ext/.bem_$line", "r");
									$bem_file = fread ($fd3, filesize("$volltext_pfad/$jahr/$source_opus/$ext/.bem_$line"));
									fclose($fd3);
								}

								$file = "$volltext_pfad/$jahr/$source_opus/$ext/$line";
						        	$array = explode(".", $line);
								$last = count($array)-1; 
								$ext2 = strtolower($array[$last]);
							        $size = stat($file);
							        $filesize = $size[7];
								$filesize = $filesize/1024;
							        if ($filesize < 1) {
							        	$filesize = number_format($filesize, 1);
						        	}
					                	else {
									$filesize = number_format($filesize);
								}
								$format2 = $opus->query("select extension from format where extension like '$ext2%' ");
								$num_format2 = $opus->num_rows($format2);
								if ($num_format2 > 0) {
									if ($i > 3) {
										fwrite($fd, "\n</TR>\n<TR>");
										$i = 1;
									}
						                        fwrite($fd, "\n<TD>");
									$opus->file2file("../../lib/font.html",$fd);
									fwrite($fd, "<A HREF=\"$volltext_url/$jahr/$source_opus/$ext/$line\">Dokument $j.$ext2 ($filesize KB) </A> ");
									if ($bem_file != "") {
										fwrite($fd, "($bem_file)");
									}
									fwrite($fd, "\n</TD>\n");
									$i++;
									$j++;
								}
								$k++;
							}
							if ($num > 0) {
								fwrite($fd, "</TR>\n</TABLE>\n");
								fwrite($fd, "</TD>\n</TR>\n");
							}
						}

						/* gezipptes File mit Endung zip bzw. gz einlesen */
						$g = 0;
						while ($g < 2) {
							$g++;
							if ($g == 1) {
								$z = "zip";
							}
							if ($g == 2) {
								$z = "gz";
							}
							$handle = opendir("$volltext_pfad/$jahr/$source_opus/$ext");
								while ($file = readdir($handle)) {
								if (eregi(".*" . $z, $file) == 1) {
									if (eregi("^.bem_*", $file) != 1) {
										$line = "$volltext_pfad/$jahr/$source_opus/$ext/$file";
										$size = stat($line);
										$filesize = $size[7];
										$filesize = $filesize/1024;
										if ($filesize < 1) {
											$filesize = number_format($filesize, 1);;
										}
										else {
											$filesize = number_format($filesize);
										}
										$bem_file = "";
										if (file_exists("$volltext_pfad/$jahr/$source_opus/$ext/.bem_$file")) {
											$fd4 = fopen("$volltext_pfad/$jahr/$source_opus/$ext/.bem_$file", "r");
											$bem_file = fread ($fd4, filesize("$volltext_pfad/$jahr/$source_opus/$ext/.bem_$file"));
											fclose($fd4);
										}
										fwrite($fd, "\n<TR>\n<TD>");
										$opus->file2file("../../lib/font.html",$fd);
										fwrite($fd, "$ext gepackt: \n</TD>\n");
										fwrite($fd, "\n<TD><TABLE BORDER=3 CELLPADDING=4 CELLSPACING=4>\n<TR>\n");
										fwrite($fd, "<TD>");
										$opus->file2file("../../lib/font.html",$fd);	
										fwrite($fd, "<A HREF=\"$volltext_url/$jahr/$source_opus/$ext/$file\">Dokument1.$z ($filesize KB) </A> ");
										if ($bem_file != "") {
											fwrite($fd, "($bem_file)");
										}
										fwrite($fd, "\n</TD>\n");	
										fwrite($fd, "\n</TR>\n</TABLE>\n");
										fwrite($fd, "</TD></TR>\n");
									}
								}
							}
							closedir($handle);
						}

						/* Falls das Dokument aus mehreren Dateien besteht muss fuer die DB */
						/* eine Navigationsdatei mit dem Namen "_index.htm" erstellt werden */
						/* Die Dokumentdateien und _index.html werden zusammen in ein File  */
						/* container.tgz gepackt. 					    */
						if ($j > 2 && ($type == "8" || $type == "24")) {
							if (file_exists("$volltext_pfad/$jahr/$source_opus/container.tgz") == 0) {
	                                                	$handle = opendir("$volltext_pfad/$jahr/$source_opus/$ext");
								$fd2 = fopen("$volltext_pfad/$jahr/$source_opus/$ext/_index.htm", "w");
								if ($fd2 < 0){
									echo("Error: $ERRMSG\n");
								}
								fwrite($fd2, "
<HTML>
<HEAD>
<TITLE>_INDEX.HTM</TITLE>
<META NAME=\"DC.Creator.PersonalName\" CONTENT=\"$creator_name\">
<META NAME=\"DC.Title\" CONTENT=\"$title\">
<META NAME=\"DC.Identifier\" SCHEME=\"URL\" CONTENT=\"$volltext_url/$jahr/$source_opus/container.tgz\">
<META HTTP-EQUIV=\"content-type\" CONTENT=\"text/html; charset=iso-8859-1\">
</HEAD>
<BODY>
<TABLE WIDTH=\"100%%\">
<TR>
<TD WIDTH=10></TD>
<TD>
<H2>Indexdatei</H2>
<TABLE CELLPADDING=0 CELLSPACING=0>
<TR>
<TD VALIGN=\"top\" ALIGN=\"right\">Autor:&nbsp;</TD>
<TD>$creator_name</TD>
</TR>
<TR>
<TD VALIGN=\"top\" ALIGN=\"right\">Titel:&nbsp;</TD>
<TD>$title</TD>
</TR>
</TABLE>
<HR>");

								while ($line = readdir($handle)) {
									if ($line != "." && $line != ".." && $line != "_index.htm") {
										$array = explode(".", $line);
										$last = count($array)-1;
										$ext2 = strtolower($array[$last]);
										$res = $opus->query("SELECT extension, mime_type FROM format WHERE extension like '$ext2%'");
										$anz = $opus->num_rows($res);
										if ($anz > 0) {
											$mrow = $opus->fetch_row($res);
											$mime_type = $mrow[1];
											fwrite($fd2, "
<TABLE CELLPADDING=0 CELLSPACING=0>
<TR>
<TD VALIGN=\"top\" ALIGN=\"right\">Inhalt:&nbsp;</TD>
<TD></TD>
</TR>
<TR>
<TD VALIGN=\"top\" ALIGN=\"right\">Datei:&nbsp;</TD>
<TD><A HREF=\"$line\">$line</A></TD>
</TR>
<TR>
<TD VALIGN=\"top\" ALIGN=\"right\">Format:&nbsp;</TD>
<TD>$mime_type</TD>
</TR>
<TR>
<TD VALIGN=\"top\" ALIGN=\"right\">Kommentar:&nbsp;</TD>
<TD></TD>
</TR>
</TABLE>
<HR>");

										}
										$opus->free_result($res);
									}
								}
								fwrite($fd2, "
</TD>
</TR>
</TABLE>
</BODY>
</HTML>");
								fclose($fd2);
								$opus->system("cd $volltext_pfad/$jahr/$source_opus/$ext; $tar_pfad/tar cf - * | $gzip_pfad/gzip - > $volltext_pfad/$jahr/$source_opus/container.tgz");
								$opus->system("rm $volltext_pfad/$jahr/$source_opus/$ext/_index.htm");
							} 
						}
					}
				}
				$opus->free_result($format);

				# Start Lizenzvertrag
				if ($lic_active >= 1) {
					$pod_active = $conf->value("pod_active");
					if ( $pod_active > 0 ) {        // check, ob lic pod erlaubt
						$res = $opus->query("SELECT pod_allowed FROM license_$la WHERE shortname='$lic'");
						$podnum = $opus->num_rows($res);
						if ($podnum == 1) {
							$mrow = $opus->fetch_row($res);
							if ( $mrow[0] == 1 ) {
								$pod_linkname_1 = $conf->value("pod_linkname_1");
								$pod_linkname_2 = $conf->value("pod_linkname_2");
								fwrite($fd, "<TR> \n<TD>");
								$opus->file2file("../../lib/font.html",$fd);
								fwrite($fd, $pod_linkname_1."</TD> \n");
								fwrite($fd, "<TD>\n<table border=\"3\"><tr><td>\n");
								$opus->file2file("../../lib/font.html",$fd);
								$pod_info = $conf->value("pod_info");
								$tmp_url = $volltext_url."/".$jahr."/".$source_opus."/";
								$podlink = $pod_info."?urn=".urlencode($urn)."&docurl=".urlencode($tmp_url)."&lic=".$lic."&aut=".$pod_creator_names."&tit=".htmlspecialchars(rawurlencode($title));
								fwrite($fd, "<a href=\"$podlink\" target=\"_blank\">");
								fwrite($fd, $pod_linkname_2."</a> \n</td>\n</tr>\n</table>\n</TD>\n");
								fwrite($fd, "</TR> \n");
							}
						}
						$opus->free_result($res);
					}
				}
				# Ende Lizenzvertrag

				fwrite($fd, "</TABLE>\n<BR>\n");


				# UH, 20.05.05: Link zur Dokumentempfehlung
				if ($empfehlen == 1) {
					fwrite($fd, "<img src=\"$url/Icons/blind.gif\" width=\"2\" height=\"1\" border=\"0\"><A HREF=$url/mailform.php?jahr=$jahr&source_opus=$source_opus title=\"Recommend this document\"><img src=\"$url/Icons/hand.jpg\" border=\"0\"></a>\n");
                                }

				# BD/UH, 14.04.05: Anzeige der Zugriffsstatistik mit awstats
				if ($statistik == 1) {
					fwrite($fd, "<img src=\"$url/Icons/blind.gif\" width=\"2\" height=\"1\" border=\"0\"><A HREF=$awstats_url?month=all&year=all&urlfilter=/$source_opus/&urlfilterex=&output=urldetail&config=$awstats_config&lang=de TARGET=_blank title=\"Hits \"><img src=\"$url/Icons/statistik.jpg\" border=\"0\"></a>\n");
                                }

				fwrite($fd, "<P>\n<HR>\n");

				fwrite($fd, "\n<H3>Kurzfassung in $sprache_description</H3>\n");
				$description = nl2br($description);
				fwrite($fd, "$description \n");
				fwrite($fd, "<HR><P> \n");
				if ($description2 != "") {
					fwrite($fd, "<H3>Kurzfassung in $sprache_description2</H3>\n");
					$description2 = nl2br($description2);
					fwrite($fd, "$description2 \n");
					fwrite($fd, "<HR><P> \n");
				}
				fwrite($fd, "<TABLE BORDER=0> \n");

				if ($subject_swd != ""){
					fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
					$opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "<B>SWD-Schlagw&ouml;rter:</B></TD> \n");
					fwrite($fd, "<TD></TD><TD>");
					$opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "$subject_swd </TD>\n");
					fwrite($fd, "</TR> \n");
				}

				if ($subject_uncontrolled_german != ""){
					fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
					$opus->file2file("../../lib/font.html",$fd);	
					fwrite($fd, "<B>Freie Schlagw&ouml;rter (deutsch):</B></TD> \n");
					fwrite($fd, "<TD></TD><TD>");
					$opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "$subject_uncontrolled_german </TD>\n");
					fwrite($fd, "</TR> \n");
				}

				if ($subject_uncontrolled_english != ""){
					fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
					$opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "<B>Freie Schlagw&ouml;rter (englisch):</B></TD> \n");
					fwrite($fd, "<TD></TD><TD>");
					$opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "$subject_uncontrolled_english </TD>\n");
					fwrite($fd, "</TR> \n");
				}

				if ($subject_type != ""){
					fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
					$opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "<B>$class_name</B></TD> \n");
					$subject_value = str_replace ("<", "&lt;", $subject_value);
					$subject_value = str_replace (">", "&gt;", $subject_value);
					fwrite($fd, "<TD></TD><TD>");
	                                $opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "$subject_value </TD>\n");
					fwrite($fd, "</TR> \n");
				}

// Anfang Collections
					if( $coll_anzeigen == "true" ) {
						if( $anzahl_coll > 0 ) {
							$opus->data_seek( $coll, 0 );
							$i = 0;
							while( $i < $anzahl_coll ) {
								$i++;
								fwrite( $fd, "<tr> \n<td valign=top>");
								$opus->file2file( "../../lib/font.html", $fd);
								if( $anzahl_coll > 1 ) {
									fwrite( $fd, "<b> Collection $i</b></td>\n" );
								} else {
									fwrite( $fd, "<b> Collection</b></td>\n" );
								}
								fwrite( $fd, "<td></td><td>");
								$opus->file2file("../../lib/font.html", $fd);
								$mrow = $opus->fetch_row( $coll );
								$coll_id = $mrow[0];
								$collection = $mrow[1];
								
								// Nun finden wir die Hierarchie nach oben heraus
								
								$query_eltern = "SELECT a.coll_name, (a.rgt - a.lft ) AS height
													FROM collections AS a, collections AS b
													WHERE b.lft BETWEEN a.lft AND a.rgt
													AND b.coll_id = '$coll_id'
													ORDER BY height DESC;";
													
								$res_eltern = $opus->query( $query_eltern );
								$num_eltern = $opus->num_rows( $res_eltern );
								
								$m = 0;
								while( $m < $num_eltern ) {
									
									$mrow_eltern = $opus->fetch_row( $res_eltern );
									$coll_name = $mrow_eltern[0];
									if( $coll_name != $collection ) {
										$coll_name = htmlspecialchars( $coll_name );
										fwrite( $fd, "$coll_name / " );
									} else {
										$coll_name = htmlspecialchars( $coll_name );
										fwrite( $fd, "$coll_name </td>\n" );
									}
									$m++;
								}
								fwrite( $fd, "</tr> \n" );
							}
						}
						$opus->free_result( $coll );
					}
// Ende Collections
				$opus->data_seek($inst,0);
				$i = 0;
				while ($i < $anzahl_inst) {
					$i++;
					fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
					$opus->file2file("../../lib/font.html",$fd);
					if ($anzahl_inst > 1) {
						fwrite($fd, "<B>Institut $i:</B></TD>\n");
					}
					else {
						fwrite($fd, "<B>Institut:</B></TD>\n");
					}
					fwrite($fd, "<TD></TD><TD>");
					$opus->file2file("../../lib/font.html",$fd);
					$mrow = $opus->fetch_row($inst);
					$publisher_inst=$mrow[0];
					$publisher_inst=htmlspecialchars($publisher_inst);
					fwrite($fd, "$publisher_inst \n");
					fwrite($fd, "</TR> \n");
                               	}
				$opus->free_result($inst);

				if ($fakultaet_diss != "") {
					$fakultaet_diss = htmlspecialchars($fakultaet_diss);
					fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
					$opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "<B>Fakult&auml;t:</B></TD> \n");
					fwrite($fd, "<TD></TD><TD>");
					$opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "$fakultaet_diss</TD>\n");
					fwrite($fd, "</TR> \n");
				}

				if ($sachgruppe_ddc != "" && $sachgruppe_ddc != "no") {
					$res = $opus->query ("SELECT sachgruppe FROM sachgruppe_ddc_$la where nr = '$sachgruppe_ddc'");
					$num = $opus->num_rows($res);
					if ($num > 0) {
						$mrow = $opus->fetch_row($res);
						$sachgruppe_ddc_name = $mrow[0];
					}
					$opus->free_result($res);
					fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
					$opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "<B>DDC-Sachgruppe:</B></TD> \n");
					fwrite($fd, "<TD></TD><TD>");
					$opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "$sachgruppe_ddc_name</TD>\n");
					fwrite($fd, "</TR> \n");
				}

		
				fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
				$opus->file2file("../../lib/font.html",$fd);
				fwrite($fd, "<B>Dokumentart:</B></TD> \n");
				fwrite($fd, "<TD></TD><TD>");
				$opus->file2file("../../lib/font.html",$fd);
				fwrite($fd, "$dokumentart </TD>\n");
				fwrite($fd, "</TR> \n");

				/***** Schriftenreihe Start *****/
				if ($sr_id != "" && $sr_band != "") {
					fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
					$opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "<B>Schriftenreihe:</B></TD> \n");
					fwrite($fd, "<TD></TD><TD>");
					$opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "$sr_name </TD>\n");
					fwrite($fd, "</TR> \n");
                                        fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
                                        $opus->file2file("../../lib/font.html",$fd);
                                        fwrite($fd, "<B>Band Nummer:</B></TD> \n");
                                        fwrite($fd, "<TD></TD><TD>");
                                        $opus->file2file("../../lib/font.html",$fd);
                                        fwrite($fd, "$sr_band </TD>\n");
                                        fwrite($fd, "</TR> \n");
				}
				/***** Schriftenreihe Stop *****/

				if ($advisor != "") {
					fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
	                                $opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "<B>Hauptberichter:</B></TD> \n");
					fwrite($fd, "<TD></TD><TD>");
					$opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "$advisor </TD>\n");
					fwrite($fd, "</TR> \n");
				}

                                if ($isbn != "") {
                                        fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
                                        $opus->file2file("../../lib/font.html",$fd);
                                        fwrite($fd, "<B>ISBN:</B></TD> \n");
                                        fwrite($fd, "<TD></TD><TD>");
                                        $opus->file2file("../../lib/font.html",$fd);
                                        fwrite($fd, "$isbn </TD>\n");
                                        fwrite($fd, "</TR> \n");
                                }


				if ($source_title != "") {
					fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
	                                $opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "<B>Quelle:</B></TD> \n");
					fwrite($fd, "<TD></TD><TD>");
	                                $opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "$source_title </TD>\n");
					fwrite($fd, "</TR> \n");
				}

				fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
				$opus->file2file("../../lib/font.html",$fd);
				fwrite($fd, "<B>Sprache:</B></TD> \n");
				fwrite($fd, "<TD></TD><TD>");
				$opus->file2file("../../lib/font.html",$fd);
				fwrite($fd, "$sprache </TD>\n");
				fwrite($fd, "</TR> \n");

				if ($date_accepted != "") {
		                        fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
       		 	                $opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "<B>Tag der m&uuml;ndlichen Pr&uuml;fung:</B></TD> \n");
					fwrite($fd, "<TD></TD><TD>");
	                                $opus->file2file("../../lib/font.html",$fd);
					$date_accepted_format = strftime("%d.%m.%Y", $date_accepted);
					fwrite($fd, "$date_accepted_format </TD>\n");
					fwrite($fd, "</TR> \n");
				}

				fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
				$opus->file2file("../../lib/font.html",$fd);
				fwrite($fd, "<B>Erstellungsjahr:</B></TD> \n");
				fwrite($fd, "<TD></TD><TD>");
				$opus->file2file("../../lib/font.html",$fd);
				fwrite($fd, "$date_year </TD>\n");
				fwrite($fd, "</TR> \n");

				fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
				$opus->file2file("../../lib/font.html",$fd);
				fwrite($fd, "<B>Publikationsdatum:</B></TD> \n");
				fwrite($fd, "<TD></TD><TD>");
				$opus->file2file("../../lib/font.html",$fd);
				$date_creation_format = strftime("%d.%m.%Y", $date_creation);
				fwrite($fd, "$date_creation_format </TD>\n");
				fwrite($fd, "</TR> \n");

				if ($date_valid != 0) {
					fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
					$opus->file2file("../../lib/font.html",$fd);
					fwrite($fd, "<B>G&uuml;ltig bis:</B></TD> \n");
					fwrite($fd, "<TD></TD><TD>");
					$opus->file2file("../../lib/font.html",$fd);
					$date_valid_format = strftime("%d.%m.%Y", $date_valid);
					fwrite($fd, "$date_valid_format </TD>\n");
					fwrite($fd, "</TR> \n");
				}

                                if ($bem_extern != "") {
                                        fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
                                        $opus->file2file("../../lib/font.html",$fd);
                                        fwrite($fd, "<B>Bemerkung:</B></TD> \n");
                                        fwrite($fd, "<TD></TD><TD>");
                                        $opus->file2file("../../lib/font.html",$fd);
                                        fwrite($fd, "$bem_extern </TD>\n");
                                        fwrite($fd, "</TR> \n");
                                }

				# Start Lizenzvertrag
				if ($lic_active >= 2) {
					if ( $licname != "" ) {
						fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
						$opus->file2file("../../lib/font.html",$fd);
						fwrite($fd, "<B>Lizenz:</B></TD> \n");
						fwrite($fd, "<TD></TD>\n<TD>");
						$opus->file2file("../../lib/font.html",$fd);
						if ( strlen(trim($licdesc_html)) > 0 ) {
							fwrite($fd,"\n".$licdesc_html."\n");
						}
						$lic_uselogos = $conf->value("license_uselogos");
						if ( ( $lic_uselogos ) AND ( strlen($liclogo) > 0 ) ) {
							$liclogo_width = $conf->value("license_logo_width");
							$liclogo_height = $conf->value("license_logo_height");
							$liclogo_wh = "";
							if ( $liclogo_width ) { 
								$liclogo_wh.= " width=\"".$liclogo_width."\""; 
							}
							if ( $liclogo_height ) { 
								$liclogo_wh.= " height=\"".$liclogo_height."\""; 
							}
							fwrite($fd, "<a href=\"$liclink\" target=\"_blank\">\n");
							fwrite($fd, "<img src=\"".$liclogo."\" alt=\"Lizenz-Logo\" border=\"0\"".$liclogo_wh.">");
							fwrite($fd, "</a>&nbsp;\n");
						}
						fwrite($fd, "<a href=\"$liclink\" target=\"_blank\">\n");
						fwrite($fd, "$licname</a> \n</td>\n");
						fwrite($fd, "</tr> \n");
					}
				}

	                        if ( $pod_active > 0 ) {        // check, ob lic pod erlaubt
        	                        $res = $opus->query("SELECT pod_allowed FROM license_$la WHERE shortname='$lic'");
                	                $podnum = $opus->num_rows($res);
                        	        if ($podnum == 1) {
                                	        $mrow = $opus->fetch_row($res);
                                        	if ( $mrow[0] == 1 ) {
	                                                $pod_linkname_1 = $conf->value("pod_linkname_1");
        	                                        $pod_linkname_2 = $conf->value("pod_linkname_2");
                	                                fwrite($fd, "<TR> \n<TD VALIGN=TOP>");
                        	                        $opus->file2file("../../lib/font.html",$fd);
                                	                fwrite($fd, "<B>".$pod_linkname_1."</B></TD> \n");
                                        	        fwrite($fd, "<TD></TD>\n<TD>");
                                                	$opus->file2file("../../lib/font.html",$fd);
	                                                $pod_info = $conf->value("pod_info");
        	                                        $tmp_url = $volltext_url."/".$jahr."/".$source_opus."/";
                	                                $podlink = $pod_info."?urn=".urlencode($urn)."&docurl=".urlencode($tmp_url)."&lic=".$lic."&aut=".$pod_creator_names."&tit=".htmlspecialchars(rawurlencode($title));
                        	                        $pod_uselogos = $conf->value("pod_uselogos");
                                	                $pod_partner_logo = $conf->value("pod_partner_logo");
                                        	        if ( ( $pod_uselogos ) AND ( strlen($pod_partner_logo) > 0 ) ) {
	                                                        $podlogo_width = $conf->value("pod_logo_width");
        	                                                $podlogo_height = $conf->value("pod_logo_height");
                	                                        $podlogo_wh = "";
                        	                                if ( $podlogo_width ) { $podlogo_wh.= " width=\"".$podlogo_width."\""; }
                                	                        if ( $podlogo_height ) { $podlogo_wh.= " height=\"".$podlogo_height."\""; }
                                        	                fwrite($fd, "<a href=\"$podlink\" target=\"_blank\">\n");
                                                	        fwrite($fd, "<img src=\"".$pod_partner_logo."\" alt=\"POD-Logo\" border=\"0\"".$podlogo_wh.">");
                                                        	fwrite($fd, "</a>&nbsp;\n");
	                                                }
							fwrite($fd, "<a href=\"$podlink\" target=\"_blank\">\n");
	                                                fwrite($fd, $pod_linkname_2."</a> </td>\n");
        	                                        fwrite($fd, "</tr> \n");
                	                        }
                        	        }
                                	$opus->free_result($res);
                        	}
				# Ende Lizenzvertrag

				fwrite($fd, "</TABLE> \n");
				$opus->file2file("../../lib/textende.html",$fd);

				fwrite($fd, "</tr>\n</table>\n</BODY>\n</HTML>");
				fclose($fd);
				print("Indexdatei zu Dokument $source_opus wurde in die Datei <a href=\"$volltext_url/$jahr/$source_opus/index.html\">index.html</a> geschrieben.<P> \n");
			}
		}
		else {
			print("$volltext_pfad/$jahr/$source_opus nicht vorhanden.<BR> \n");
		}
	}
	else {
		print("$projekt-IDN $a nicht vorhanden.<BR> \n");
	}
	$a++;
}

if ($type == "8" || $type == "24") {
	print("<FORM METHOD=\"POST\" ACTION=\"$url/admin/ddb_email.php\"> \n");
	print("<INPUT TYPE=hidden NAME=\"source_opus\" VALUE =\"$source_opus\"> \n");
	print("<INPUT TYPE=hidden NAME=\"ddb_email\" VALUE =\"$ddb_email\"> \n");
	print("<INPUT TYPE=hidden NAME=\"email\" VALUE =\"$email\"> \n");
	print("<INPUT TYPE=hidden NAME=\"subject\" VALUE =\"$ddb_idn/HS/$verfasser/$sachgruppe_ddc\"> \n");
	print("<INPUT TYPE=hidden NAME=\"link_index\" VALUE =\"$volltext_url/$jahr/$source_opus/index.html\"> \n");
	/* Bei Mehrdateiendokument Link auf Containerdatei mitschicken */
	if ($j > 2) {
		print("<INPUT TYPE = hidden NAME = \"link_container\" VALUE =\"$volltext_url/$jahr/$source_opus/container.tgz\"> \n");
	}
	print("<INPUT TYPE = submit  VALUE=\"Dokument der DDB melden\"> \n");
	print("<input type=\"hidden\" name=\"la\" value=\"$la\"> \n");
	print("</FORM> \n<P> \n");
	print("Falls das Dokument schon gemeldet wurde bzw. nicht gemeldet werden soll:");
}
print("<P><A HREF=\"$home/admin/\">Adminseite</A>");

$opus->close($sock);
$design->foot("indexfile.$php", $la);
?>

