<?
#############################################################
# browsen_sachgruppe.php - Browsen nach DDC-Sachgruppe 
#
# letzte nderung:
# 18.3.2005, Annette Maile, UB Stuttgart
# Auslagerung Design in lib/design.php
# In Abhaengigkeit von $la kann das entsprechende Design eingelesen werden.
#
# 11.6.2005, Birgit Dressler, SULB Saarbrcken
# Einfhrung der Mehrsprachigkeit (Variable $la)
# Textdatei: texte/$la/browsen_sachgruppe.conf
#
#############################################################

include ("../lib/class.configFile.php");
$conf = new configFile ("../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");

include ("../lib/class.opus_$dbms.$php");
$opus = new opus;

$db = $conf->value("db");
$opustable = $conf->value("opus_table"); 
$url = $conf->value("url");
$sachgruppe_alle_anzeigen = $conf->value("sachgruppe_alle_anzeigen");
$titel = $conf->value("titel_browsen_sachgruppe");
$ueberschrift = $conf->value("ueberschrift_browsen_sachgruppe");

include ("../lib/stringValidation.php");
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# A.Maile 10.2.05: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}

# BDressler Texte aus Textdatei in Programmvariablen fllen 
$texte = new configFile ("../texte/$la/browsen_sachgruppe.conf");
$titel = $texte->value("titel");
$ueberschrift = $texte->value("ueberschrift");

# Annette Maile, 18.3.05 Design aus lib/design.php einlesen
require ("../lib/design.$php");
$design = new design;
$design->head_titel($titel);
$design->head_ueberschrift($ueberschrift, $la);

$sock = $opus->connect();
if ( $sock < 0 ) {
        fatal ("Error: $ERRMSG\n");
}
if ( $opus->select_db("$db") < 0 ) {
        fatal ("Error: $ERRMSG\n");
}

$res = $opus->query ("SELECT * FROM sachgruppe_ddc_$la order by nr");
 
$num = $opus->num_rows($res);
if ($num > 0) {
	print("<UL> \n");
        $i = 0;
        while ($i < $num) {
                $i++;
                $mrow = $opus->fetch_row($res);
		$nr = $mrow[0];
		$sachgruppe = $mrow[1];
		$res2 = $opus->query ("SELECT source_opus from $opustable where sachgruppe_ddc = '$nr' ");
		$anzahl = $opus->num_rows($res2);
		if ($sachgruppe_alle_anzeigen) {
			print ("<LI><A HREF=\"$url/ergebnis.$php?suchart=exakt&Lines_Displayed=10&sort=o.date_year+DESC%2C+o.title&suchfeld1=o.sachgruppe_ddc&suchwert1=$nr&opt1=AND&suchfeld2=person&suchwert2=&opt2=AND&suchfeld3=date_year&suchwert3=&startindex=0&page=0&dir=2&suche=&la=$la\">$nr $sachgruppe</A> <FONT SIZE=2>( $anzahl Dok. )</FONT> \n");
		}
		else {
	                if ($anzahl > 0) {
				print("<LI><A HREF=\"$url/ergebnis.$php?suchart=exakt&Lines_Displayed=10&sort=o.date_year+DESC%2C+o.title&suchfeld1=o.sachgruppe_ddc&suchwert1=$nr&opt1=AND&suchfeld2=person&suchwert2=&opt2=AND&suchfeld3=date_year&suchwert3=&startindex=0&page=0&dir=2&suche=&la=$la\">$nr $sachgruppe</A> <FONT SIZE=2>( $anzahl Dok. )</FONT> \n");
			} 
		}
		$opus->free_result($res2);
        }
        $opus->free_result($res);
	print("</UL> \n");
}

$design->foot("browsen_sachgruppe.$php", $la);
?>

