<?
#############################################################
# ergebnis.php - Kurztitelliste der Ergebnisse aus Suchen/Browsen 
#
# letzte nderung:
# 18.3.2005, Annette Maile, UB Stuttgart
# Auslagerung Design in lib/design.php
# In Abhaengigkeit von $la kann das entsprechende Design eingelesen werden.
# 
# 10.6.05, Annette Maile, UB Stuttgart
# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# in Abhaengigkeit der IP-Adresse des Nutzers und der 
# Variablen $alle_doks_anzeigen wird die Suche generiert
#
# 16.9.2005, Birgit Dressler, SULB Saarbruecken
# Einfuehrung der Mehrsprachigkeit (Variable $la)
# Textdatei: texte/$la/ergebnis.conf
#
#############################################################

include ("../lib/class.configFile.php");
$conf = new configFile ("../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");

include ("../lib/class.opus_$dbms.$php");
$opus = new opus;

$db = $conf->value("db");
$opustable = $conf->value("opus_table");
$url = $conf->value("url");
$url_volltextsuche =  $conf->value("url_volltextsuche");
$alle_doks_anzeigen = $conf->value("alle_doks_anzeigen");

# BD steht nun in der Textdatei ergebnis.conf
#$titel = $conf->value("titel_ergebnis");;
#$ueberschrift = $conf->value("ueberschrift_ergebnis");

$opustable_autor = $opustable . "_autor";
$select = "distinct o.title, o.source_opus, o.date_year"; 
$from = "$opustable o";

include ("../lib/stringValidation.php");
$suchart = $_REQUEST['suchart'];
if (! _is_valid($suchart,1,10,"[a-z]+")) {die ("Fehler in Parameter suchart");}
$startindex = $_REQUEST['startindex'];
if (! _is_valid($startindex,0,10,"[0-9]*")) {die ("Fehler in Parameter startindex");}
$dir = $_REQUEST['dir'];
if (! _is_valid($dir,0,10,"[0-9]*")) {die ("Fehler in Parameter dir");}
$page = $_REQUEST['page'];
if (! _is_valid($page,0,10,"[0-9]*")) {die ("Fehler in Parameter page");}
$suchfeld1 = $_REQUEST['suchfeld1'];
if (! _is_valid($suchfeld1,0,30,"[a-z0-9\.\_]*")) {die ("Fehler in Parameter suchfeld1");}
$suchfeld2 = $_REQUEST['suchfeld2'];
if (! _is_valid($suchfeld2,0,30,"[a-z0-9\.\_]*")) {die ("Fehler in Parameter suchfeld2");}
$suchfeld3 = $_REQUEST['suchfeld3'];
if (! _is_valid($suchfeld3,0,30,"[a-z0-9\.\_]*")) {die ("Fehler in Parameter suchfeld3");}
$suchwert1 = $_REQUEST['suchwert1'];
$suchwert1 = eregi_replace("[`\n\r]","",$suchwert1);
$suchwert2 = $_REQUEST['suchwert2'];
$suchwert2 = eregi_replace("[`\n\r]","",$suchwert2);
$suchwert3 = $_REQUEST['suchwert3'];
$suchwert3 = eregi_replace("[`\n\r]","",$suchwert3);
$opt1 = $_REQUEST['opt1'];
if (! _is_valid($opt1,0,3,"[A-Z]*")) {die ("Fehler in Parameter opt1");}
$opt2 = $_REQUEST['opt2'];
if (! _is_valid($opt2,0,3,"[A-Z]*")) {die ("Fehler in Parameter opt2");}
$sort = $_REQUEST['sort'];
if (! _is_valid($sort,0,50,"[A-Za-z0-9\.\_\,\ ]*")) {die ("Fehler in Parameter sort");}
$sprache = $_REQUEST['sprache'];
if (! _is_valid($sprache,0,10,"[a-z]*")) {die ("Fehler in Parameter sprache");}
$Lines_Displayed = $_REQUEST['Lines_Displayed'];
if (! _is_valid($Lines_Displayed,0,30,"[0-9]*")) {die ("Fehler in Parameter Lines_Displayed");}
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# A.Maile 10.2.05: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}

# BDressler Texte aus Textdatei in Programmvariablen fuellen
$texte = new configFile ("../texte/$la/ergebnis.conf");
$titel = $texte->value("titel");
$ueberschrift = $texte->value("ueberschrift");
$t_nummer = $texte->value("t_nummer");
$t_titel = $texte->value("t_titel");
$t_autor = $texte->value("t_autor");
$t_jahr = $texte->value("t_jahr");
$t_text1 = $texte->value("t_text1");
$t_text2 = $texte->value("t_text2");
$t_text3 = $texte->value("t_text3");
$akt_seite = $texte->value("akt_seite");
$anz_dok = $texte->value("anz_dok");
$anz_seite = $texte->value("anz_seite");
$t_text4 = $texte->value("t_text4");
$t_text5 = $texte->value("t_text5");
$t_text6 = $texte->value("t_text6");
$t_text7 = $texte->value("t_text7");
$t_text8 = $texte->value("t_text8");
$t_text9 = $texte->value("t_text9");
$t_text10 = $texte->value("t_text10");

# Annette Maile, 18.3.05 Design aus lib/design.php einlesen
require ("../lib/design.$php");
$design = new design;
$design->head_titel($titel);
$design->head_ueberschrift($ueberschrift, $la);

$DEBUG = 0;

if ($Lines_Displayed == "") {
	$Lines_Displayed = 10;
}
else {
	$Lines_Displayed = $Lines_Displayed;
}
if ( $page <= 0 ) {
	$count = 0;		/* Startbedingung */
	$startindex = 0;
	$dir = 2;
}

if ( $startindex <= 0 ) { 
	$dir = 0;
	$page = 1;
}

print("<FONT COLOR=red>");
$sock = $opus->connect();
if ( $sock < 0 ) { 
	echo ("Error: $ERRMSG\n"); 
} 

if ( $opus->select_db("$db")  < 0 ) {
	echo ("Error: $ERRMSG\n"); 
}
print("</FONT>");

$suchfeld[1] = $suchfeld1;
$suchwert[1] = $suchwert1;
$suchfeld[2] = $suchfeld2;
$suchwert[2] = $suchwert2;
$suchfeld[3] = $suchfeld3;
$suchwert[3] = $suchwert3;

$teilsuche[1]=""; 
$i = 1;

/*********************************************************************************/
/* Die Formularinhalte werden auf Art und Inhalt ueberprueft und entsprechend    */
/* wird ein Teilsuchstring zusammengesetzt.                                      */
/* Wenn das Suchfeld "Fakultaet" und der Suchwert alphanumerisch ist,            */
/* wird in der Tabelle faculty nach der Fakultaetsnummer gesucht und mit dieser  */
/* Nr. eine Institutssuche angestossen, die zu dieser Fakultaet gehoeren.        */
/* Wenn das Suchfeld "Institut" und der Suchwert alphanumerisch ist, wird in     */
/* in der Tabelle institute nach den zugehoerigen Institutsnr. gesucht           */
// Anfang Collections
/* Wenn das Suchfeld "Collections" und der Suchwert alphanumerisch ist, wird in  */
/* der Tabelle collections nach der zugehoerigen coll_id gesucht.
// Ende Collections
/* Wenn das Suchfeld "person" ist wird der Teilsuchstring so aufgebaut, dass in  */
/* allen Autorenfeldern rechts trunkiert gesucht wird.                           */
/* Wenn das Suchfeld "freitext" ist wird der Teilsuchstring so aufgebaut,        */
/* dass im Titel, Abstract und Schlagwoertern  gesucht wird.                     */
/* Wenn Suchfeld "type" ist und der Suchwert ein String (keine Zahl) ist, werden */
/* in der Tabelle resource_type rechts-/linkstrunkiert nach den zugehoerigen     */
/* typeid gesucht. Wenn mehr als eine typeid gefunden wird, wird die Suche mit   */
/* or verknuepft aufgebaut. Wenn aber der Suchwert eine Zahl ist, wird nur nach  */
/* Dokumenten mit der entsprechenden Dokumentart gesucht.                        */
/* Wenn Suchart "exakt" ist wird nur rechts trunkiert.                           */
/* Ansonsten wird rechts und links trunkiert.                                    */
/*********************************************************************************/
while ($i <= 3) {
	if ($suchwert[$i] != "") {
		if ( $suchfeld[$i] == "o.publisher_faculty" ) {
			if ($suchwert[$i] >= "A") {
				$res = $opus->query("SELECT nr FROM faculty_$la WHERE fakultaet LIKE '%$suchwert[$i]%'");
				$num = $opus->num_rows($res);
				if ($num > 0) {
					$mrow = $opus->fetch_row($res);
					$fak_nr = $mrow[0];
					$query = "SELECT nr from institute_$la WHERE fakultaet = '$fak_nr'";
					if ($num >1) {
						$j=1;
						 while ($j < $num) {
							$j++;
							$mrow = $opus->fetch_row($res);
							$fak_nr = $mrow[0];
							$query = $query . " or fakultaet = '$fak_nr'";
						}
					}
				}
				else {
					$query = "SELECT nr from institute_$la WHERE fakultaet = ''";
				}	
				$opus->free_result($res);
			}
			else {
				$query = "SELECT nr from institute_$la WHERE fakultaet = '$suchwert[$i]'";
			}
			$inst = $opus->query($query);
			$num_inst = $opus->num_rows($inst);
	                if ($num_inst > 0) {
	                	$mrow = $opus->fetch_row($inst);
				$teilsuche[$i] = "(oi.inst_nr = '$mrow[0]'";
			}
			else {
				/* wenn keine Inst.-Nr. zum Suchbegriff gefunden wird, */
				/* dann inst_nr auf '' setzen. (sonst kommt Fehlermeldung) */
				$teilsuche[$i] = "(oi.inst_nr = ''";
			}
	                if ($num_inst > 1) {
				$j = 1;
				while ($j < $num_inst) {
					$j++;
					$mrow = $opus->fetch_row($inst);
					$teilsuche[$i] = $teilsuche[$i] . " or oi.inst_nr = '$mrow[0]'";
				}
			}
			$opus->free_result($inst);
	                $teilsuche[$i] = $teilsuche[$i] . ") and oi.source_opus = o.source_opus";
	                $from = $from . "," . $opustable . "_inst oi";
		}
		else {
		if ( $suchfeld[$i] == "oi.inst_nr" ) {
	       		if ($suchwert[$i] >= "A") {
					$res = $opus->query("SELECT nr FROM institute_$la WHERE name LIKE '%$suchwert[$i]%'");
			}
			else {
				$res = $opus->query("SELECT nr from institute_$la WHERE nr LIKE '$suchwert[$i]'");
			}
			$num = $opus->num_rows($res);
			if ($num > 0) {
				$mrow = $opus->fetch_row($res);
				$teilsuche[$i] = "($suchfeld[$i] = '$mrow[0]'";
			}
			else {
				/* wenn keine Inst.-Nr. zum Suchbegriff gefunden wird, */
				/* dann inst_nr auf '' setzen. (sonst kommt Fehlermeldung) */
				$teilsuche[$i] = "($suchfeld[$i] = ''";
			}
			if ($num > 1) {
				$j = 1;
				while ($j < $num) {
					$j++;
					$mrow = $opus->fetch_row($res);
					$teilsuche[$i] = $teilsuche[$i] . " or $suchfeld[$i] = '$mrow[0]'"; 
				}
			}
			$opus->free_result($res);
			$teilsuche[$i] = $teilsuche[$i] . ") and oi.source_opus = o.source_opus";
			$from = $from . "," . $opustable . "_inst oi";
		}
		else {
// Anfang Collections
			if( $suchfeld[$i] == "oc.coll_id" ) {
//				if( $suchwert[$i] >= "A" ) {
				if( !ereg( "^[0-9]+$", $suchwert[$i] )) {
					$res = $opus->query( "SELECT coll_id FROM collections WHERE coll_name LIKE '%$suchwert[$i]%'");
				}
				else {
					$res = $opus->query( "SELECT coll_id FROM collections WHERE coll_id LIKE '$suchwert[$i]'");
				}
				$num = $opus->num_rows( $res );
				if( $num > 0 ) {
					$mrow = $opus->fetch_row( $res );
					$teilsuche[$i] = "($suchfeld[$i] = '$mrow[0]'";
				}
				else {
					/* wenn keine Coll-ID zum Suchbegriff gefunden wird, */
					/* dann coll_id auf '' setzen. (sonst kommt Fehlermeldung) */
					$teilsuche[$i] = "($suchfeld[$i] = ''";
				}
				if( $num > 1 ) {
					$j = 1;
					while( $j < $num ) {
						$j++;
						$mrow = $opus->fetch_row( $res );
						$teilsuche[$i] = $teilsuche[$i] . " or $suchfeld[$i] = '$mrow[0]'";
					}
				}
				$opus->free_result( $res );
				$teilsuche[$i] = $teilsuche[$i] . ") and oc.source_opus = o.source_opus";
				$from = $from . "," . $opustable . "_coll oc";
			}
			else {
// Ende Collections
# BD, 8.9.06, Herausgeber eines Buches soll auch im Feld Autor gesucht werden knnen
				if ($suchfeld[$i] == "oa.person") {
					$teilsuche[$i] = "(o.source_opus = oa.source_opus and o.contributors_name LIKE '% " . $suchwert[$i] . "%' and o.type like \"55\") or o.source_opus = oa.source_opus and oa.creator_name LIKE '" . $suchwert[$i] . "%' ";
					#$teilsuche[$i] = "o.source_opus = oa.source_opus and ((o.contributors_name LIKE '% " . $suchwert[$i] . "%' and o.type like \"55\") or  oa.creator_name LIKE '" . $suchwert[$i] . "%')";
				# alte Abfrage: $teilsuche[$i] = "o.source_opus = oa.source_opus and oa.creator_name LIKE '" . $suchwert[$i] . "%' ";
					$from = $from . ", $opustable_autor oa";
					/* wenn Suchfeld Person ist, wird in allen Autoren rechts trunkiert gesucht */
				}
				else {
					if ($suchfeld[$i] == "o.freitext") {
						if ($suchart == "exakt" ) {
							$teilsuche[$i] = "((o.title  LIKE '" . $suchwert[$i] . "%' or o.description  LIKE '" . $suchwert[$i] . "%' or o.subject_swd  LIKE '" . $suchwert[$i] . "%' or o.subject_uncontrolled_german LIKE '" . $suchwert[$i] . "%' or o.subject_uncontrolled_english LIKE '" . $suchwert[$i] . "%') OR " . "(o.title  LIKE '% " . $suchwert[$i] . "%' or o.description  LIKE '% " . $suchwert[$i] . "%' or o.subject_swd  LIKE '% " . $suchwert[$i] . "%' or o.subject_uncontrolled_german LIKE '% " . $suchwert[$i] . "%' or o.subject_uncontrolled_english LIKE '% " . $suchwert[$i] . "%'))";
						}
						else {
							$teilsuche[$i] = "(o.title  LIKE '%" . $suchwert[$i] . "%' or o.description  LIKE '%" . $suchwert[$i] . "%' or o.subject_swd  LIKE '%" . $suchwert[$i] . "%' or o.subject_uncontrolled_german LIKE '%" . $suchwert[$i] . "%' or o.subject_uncontrolled_english LIKE '%" . $suchwert[$i] . "%')";
						}
						/* wenn Suchfeld Freitext ist, wird in Titel, Abstract und Schlagwoertern gesucht */
					}
					else {
						if ($suchfeld[$i] == "o.subject_swd") {
							$teilsuche[$i] = "(o.subject_swd  LIKE '%" . $suchwert[$i] . "%' or o.subject_uncontrolled_german LIKE '%" . $suchwert[$i] . "%' or o.subject_uncontrolled_english LIKE '%" . $suchwert[$i] . "%')";
							/* wenn Suchfeld Schlagwort ist, wird in Schlagwort-SWD, Schlagwort unkontrolliert deutsch und englisch links/rechts trunkiert gesucht */
						}
						else {
							if ( $suchfeld[$i] == "o.type" ) {
								if ($suchwert[$i] >= "A") {
									$res = $opus->query("SELECT typeid FROM resource_type_$la WHERE dokumentart LIKE '%$suchwert[$i]%'");
									$num = $opus->num_rows($res);
									$mrow = $opus->fetch_row($res);
									$type[$i] = $mrow[0];
									$teilsuche[$i] = $suchfeld[$i] . " LIKE '" . $type[$i] . "'";
									if ($num > 1) {
										$teilsuche[$i] = "(" . $teilsuche[$i];
										$j = 1;
										while ($j < $num) {
											$mrow = $opus->fetch_row($res);
											$type[$i] = $mrow[0];
											$teilsuche[$i] = $teilsuche[$i] . " or " . $suchfeld[$i] . " LIKE '" . $type[$i] . "'";
											$j = $j + 1;
										}
										$teilsuche[$i] = $teilsuche[$i] . ")";
									}
									$opus->free_result($res);
								}
								else {
									$teilsuche[$i] = $suchfeld[$i] . " = '" . $suchwert[$i] . "'";
								}
								/* wenn Suchfeld[$i] Dokumenart ist, wird in der Tabelle "resource_type nach der zugehoerigen Typ-ID gesucht */
							}
							else {
							   if ($suchfeld[$i] == "o.sachgruppe_ddc") {
									$teilsuche[$i] = $suchfeld[$i] . " = " . $suchwert[$i];
								}
							   else {
if (substr($suchfeld[$i],0,5) == "class") {
	$classtable[$i] = str_replace("class","$opustable",$suchfeld[$i]);
	$teilsuche[$i] = "oc.class  LIKE '" . $suchwert[$i] . "' and o.source_opus = oc.source_opus"; 
	$from = $from . ", " . $classtable[$i] . " oc";
}
else {
							if ($suchart == "exakt" ) {
								$teilsuche[$i] = "(".$suchfeld[$i] . " LIKE '" . $suchwert[$i] . "%' ". " OR " .$suchfeld[$i] . " LIKE '% " . $suchwert[$i] . "%')";
								/*  wenn Suchfeld[$i] nicht Fakultaet ist und Suchart exakt, wird Suchwert$i nur rechts trunkiert */ 
							}
							else {
								$teilsuche[$i] = $suchfeld[$i] . " LIKE '%" . $suchwert[$i] . "%'";
								/* ansonsten wird links und rechts trunkiert */
							}
}
						   } 
						}
					}
				}
			}
		}
	}
// Anfang Collections
	}
// Ende Collections
	}
	$i++;
}

/* Die Suchwerte werden ueberprueft und je nachdem welche belegt sind, wird der endgueltige Suchstring aus den Teilsuchstrings zusammengesetzt. */

$from = str_replace(", opus_autor oa, opus_autor oa, opus_autor oa", ", opus_autor oa", $from);
$from = str_replace(", opus_autor oa, opus_autor oa", ", opus_autor oa", $from); 

# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# Es wird die IP des Nutzers ermittelt. 
# Wenn alle_doks_anzeigen = 0 gesetzt ist:
# Es wird auf jeden Fall im Bereich 1 = freier Zugriff gesucht
# Falls in Altbestaenden (< Opus 3.0) kein Bereich angegeben ist,
# wird auch nach bereich_id = 0 und null gesucht
# Dann wird in der Tabelle ip_bereich nach den Bereichen gesucht, 
# in deren IP-Range die IP liegt.
# Wenn alle_doks_anzeigen = 1 gesetzt ist:
# Es wird in allen Bereichen gesucht

$ip = $_SERVER['REMOTE_ADDR'];

if ($alle_doks_anzeigen == 0) {
	$bereichsgrenze = "(o.bereich_id = 1 or o.bereich_id = 0 or o.bereich_id is NULL";
	$res = $opus->query("SELECT bereich_id, ip_range FROM ip_bereich");
	$num = $opus->num_rows($res);
	if ($num > 0) {
		$i = 0;
		while ($i < $num) {
			$mrow = $opus->fetch_row($res);
			$bereich_id = $mrow[0];
			$ip_range = $mrow[1];
			if (ereg("^$ip_range", "$ip")) {		
				$bereichsgrenze = $bereichsgrenze . " OR o.bereich_id = $bereich_id";
			}
			$i++;
		}
		$opus->free_result($res);
		$bereichsgrenze = $bereichsgrenze . ")";	
	}
}
else {
	# Es wird in allen Bereichen gesucht
	$bereichsgrenze = "(o.bereich_id is not null or o.bereich_id is null)";
}
# Ende Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche

if ( $suchwert1 == "" && $suchwert2 == "" && $suchwert3 == "" ) {
	if ($sprache == "") {
		$res = $opus->query("SELECT   $select 
				FROM      $from
				WHERE $bereichsgrenze
				ORDER BY  $sort" );
	}
	else {
		$res = $opus->query("SELECT  $select 
		FROM      $from
		WHERE o.language = '$sprache' AND $bereichsgrenze
		ORDER BY  $sort" );
	}
}
else {
	if ( $suchwert3 == "" ) {
		if ($suchwert2 == "" ) {
			/* nur suchfeld1 belegt */		
			$suche = $teilsuche[1] ;
		}
		else {
			if ($suchwert1 == "") {
				/* nur suchfeld2 belegt */
			 	$suche = $teilsuche[2] ;
	     		}
			else {
				/* suchfeld1 und suchfeld2 belegt */
			  	$suche = $teilsuche[1] . " "  . $opt1 . " " . $teilsuche[2] ;  
			}
		}
	}
	else {
		/* suchwert3 belegt */
		if ($suchwert1 == "" ) {
			if ($suchwert2 == "" ) {
				/* nur suchwert 3 belegt */
				$suche = $teilsuche[3] ;
			}
			else {
				/* suchwert2 und suchwert3 belegt */
				$suche = $teilsuche[2]  . " " . $opt2 . " " . $teilsuche[3] ; 
			}
		}
		else {
			/* mind. suchwert3 und suchwert1 belegt */
			if ($suchwert2 == "" ) {
				/* nur suchwert1 und suchwert3 belegt */ 
				$suche = $teilsuche[1] . " "  . $opt1 . " " . $teilsuche[3] ;
			}
			else {
				/* suchwert1 und suchwert2 und suchwert3 belegt */	
				$suche = $teilsuche[1] . " " . $opt1 . " " . $teilsuche[2] . " " . $opt2 . " " . $teilsuche[3] ;
			}
		}
	}

	if ($sprache != "") {
		$suche = $suche . " and o.language = '$sprache'";
	}

        $res = $opus->query("SELECT    $select 
                           FROM    $from
	    	          WHERE    $suche AND $bereichsgrenze
		       ORDER BY    $sort" );
}

$num = $opus->num_rows($res);

if ( $num > 0) {
	print("<TABLE BORDER=1> \n");
	print("<TH VALIGN=TOP>$t_nummer </TH>\n");
	print("<TH VALIGN=TOP>$t_titel </TH>\n");
	print("<TH VALIGN=TOP>$t_autor </TH>\n");
        print("<TH VALIGN=TOP>$t_jahr </TH>\n");
	print("<TR> \n");

	print("<!-- RESULT LIST START --> \n");

	if ( $DEBUG > 0 ) {
		print("<TD>startindex</TD>");
		print("<TD>dir</TD>");
		print("<TD>page</TD>");
		print("<TR>\n");
	   
		print("<TD>$startindex</TD>");
		print("<TD>$dir</TD>");
		print("<TD>$page</TD>");
		print("<TR>\n");
	}

	if ( $num > 0 ) {
		$anzahl = $num;
		$anzahl--;
		if ( $Lines_Displayed == 0 ) {
			$Lines_Displayed = $num;
		}
		$MaxPage = sprintf("%5d",($anzahl/$Lines_Displayed) + 1);
	}
	else {
		$num = 0;
	}

	if ( $page > $MaxPage ) {
		$page = $MaxPage;
	}
	if ( $page < 0 ) {
		$page = 1;
	}

	if ( $dir == 2 ) {
		$page++;
		if ( $page > $MaxPage ) {
			$page = $MaxPage;
		}
	}
	else { 
		if ( $dir == 1 ) {
			$page--;
			if ( $page < 1 ) {
				$page = 1;
			}
		}
	}

	$Minindex   = $Lines_Displayed * ($page - 1);
	$startindex = $Minindex;

	if ( $DEBUG > 0 ) {
		print("<TD>$startindex</TD>");
		print("<TD>$dir</TD>");
		print("<TD>$page</TD>");
		print("<TR>\n");
	}

	$opus->data_seek ( $res, $startindex);	
	
	$i     = 0;
	$count = 1;

	$actpos = $startindex;

	while ( $i < $num  ) {
	    $i++;
	    if ( $i > $actpos && $count <= $Lines_Displayed  ) {
	        $mrow = $opus->fetch_row($res);
	    	$count++;

		print("<TD VALIGN=MIDDLE>$i</TD>\n");
		print("<TD VALIGN=TOP>");
		print("<!-- RESULT ITEM START -->\n");
		$titel = $mrow[0] ;
		$source_opus = $mrow[1];
		$date_year = $mrow[2];
		$creator_name = "&nbsp;";
		$autor = $opus->query("SELECT creator_name, reihenfolge from $opustable_autor where source_opus = $source_opus ORDER BY reihenfolge");
		$num_autor = $opus->num_rows($autor);
		if ($num_autor > 0) {
			$mrow_autor = $opus->fetch_row($autor);
			$creator_name = $mrow_autor[0];
		}
		if ($num_autor > 1) {
			$creator_name = $creator_name . " et al.";
		}

		print( "<A HREF=\"$url/frontdoor.$php?source_opus=$source_opus&la=$la\">$titel</A></TD>\n");
		$opus->free_result($autor);
		if ($creator_name == "") {
			$creator_name = "&nbsp;";
		}
		print( "<TD VALIGN=TOP>$creator_name</TD>\n");
		print( "<TD VALIGN=TOP>$date_year</TD>\n");
		print("<!-- RESULT ITEM END -->\n");
		print( "</TR>\n<TR>\n" );
	    }
	}


	print("<!-- RESULT LIST END -->\n");	
	print("</TR>\n</TABLE>\n");

	print("<TABLE BORDER=0> ");
	$suchwert1 = stripslashes(htmlspecialchars($suchwert1));
	$suchwert2 = stripslashes(htmlspecialchars($suchwert2));

	$startindex = $Lines_Displayed * $page;

	if ($page > 1) {
		print("<TD VALIGN=top> \n");
		print("<FORM METHOD=\"POST\" ACTION=\"$url/ergebnis.$php\"> \n");
	        print("<INPUT TYPE=submit   NAME=\"Back\"     VALUE=\"$t_text1\"> \n");
		print("<INPUT TYPE=hidden   NAME=\"startindex\"  VALUE=\"$startindex\" > \n");
		print("<INPUT TYPE=hidden   NAME=\"dir\"         VALUE=1               > \n");
		print("<INPUT TYPE=hidden   NAME=\"page\"        VALUE=\"$page\"       > \n");
		print("<INPUT TYPE=hidden   NAME=\"suchfeld1\"    VALUE=\"$suchfeld1\"   > \n");
		print("<INPUT TYPE=hidden   NAME=\"suchwert1\"    VALUE=\"$suchwert1\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"suchfeld2\"    VALUE=\"$suchfeld2\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"suchwert2\"    VALUE=\"$suchwert2\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"suchfeld3\"    VALUE=\"$suchfeld3\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"suchwert3\"    VALUE=\"$suchwert3\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"opt1\"    VALUE=\"$opt1\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"opt2\"    VALUE=\"$opt2\"   > \n");
		print("<INPUT TYPE=hidden   NAME=\"suchart\"    VALUE=\"$suchart\"   > \n");
		print("<INPUT TYPE=hidden   NAME=\"sort\"    VALUE=\"$sort\"   > \n");
		print("<INPUT TYPE=hidden   NAME=\"sprache\"    VALUE=\"$sprache\"   > \n");
		print("<INPUT TYPE=hidden   NAME=\"Lines_Displayed\"    VALUE=\"$Lines_Displayed\"   > \n");
		print("<INPUT TYPE=hidden   NAME=\"la\"	VALUE=\"$la\"   > \n");
		print("</FORM>");
		print("</TD>");
	}
	if ($page < $MaxPage) {
		print("<TD VALIGN=top> \n");
		print("<FORM METHOD=\"POST\" ACTION=\"$url/ergebnis.$php\"> \n");
		print("<INPUT TYPE=submit   NAME=\"Forward\"     VALUE=\"$t_text2\"> \n");
		print("<INPUT TYPE=hidden   NAME=\"startindex\"  VALUE=\"$startindex\" > \n");
		print("<INPUT TYPE=hidden   NAME=\"dir\"         VALUE=2               > \n");
		print("<INPUT TYPE=hidden   NAME=\"page\"        VALUE=\"$page\"       > \n");
	        print("<INPUT TYPE=hidden   NAME=\"suchfeld1\"    VALUE=\"$suchfeld1\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"suchwert1\"    VALUE=\"$suchwert1\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"suchfeld2\"    VALUE=\"$suchfeld2\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"suchwert2\"    VALUE=\"$suchwert2\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"suchfeld3\"    VALUE=\"$suchfeld3\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"suchwert3\"    VALUE=\"$suchwert3\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"opt1\"    VALUE=\"$opt1\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"opt2\"    VALUE=\"$opt2\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"suchart\"    VALUE=\"$suchart\"   > \n");
	        print("<INPUT TYPE=hidden   NAME=\"sort\"    VALUE=\"$sort\"   > \n");
		print("<INPUT TYPE=hidden   NAME=\"sprache\"    VALUE=\"$sprache\"   > \n");
		print("<INPUT TYPE=hidden   NAME=\"Lines_Displayed\"    VALUE=\"$Lines_Displayed\"   > \n");
		print("<INPUT TYPE=hidden   NAME=\"la\" VALUE=\"$la\"   > \n");
		print("</FORM>");
		print("</TD>");
	}

	/* Folgende Zeile ist nur fuer den KVVK notwendig */	
	print("\n<a href=\"$url/ergebnis.$php?startindex=$startindex&dir=2&page=$page&suchfeld1=$suchfeld1&suchwert1=$suchwert1&suchfeld2=$suchfeld2&suchwert2&suchfeld3=$suchfeld3&suchwert3=$suchwert3&opt1=$opt1&opt2=$opt2&suchart=$suchart\"></a> \n");

	if ( $suchwert1 != "" ||  $suchwert2 != "" ||  $suchwert3 != "" ) {
	print("<TD VALIGN=top> \n");
	print("<FORM METHOD=\"POST\" ACTION=\"$url/ergebnis.$php\"> \n");
	print("<INPUT TYPE=submit   NAME=\"new\"     VALUE=\"$t_text3\"          > \n");
	print("<INPUT TYPE=hidden   NAME=\"startindex\"  VALUE=0 > \n");
	print("<INPUT TYPE=hidden   NAME=\"dir\"         VALUE=2               > \n");
	print("<INPUT TYPE=hidden   NAME=\"page\"        VALUE=0       > \n");
        print("<INPUT TYPE=hidden   NAME=\"suchfeld1\"    VALUE=\"$suchfeld1\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"suchwert1\"    VALUE=\"\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"suchfeld2\"    VALUE=\"$suchfeld2\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"suchwert2\"    VALUE=\"\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"suchfeld3\"    VALUE=\"$suchfeld3\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"suchwert3\"    VALUE=\"\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"opt1\"    VALUE=\"$opt1\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"opt2\"    VALUE=\"$opt2\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"suchart\"    VALUE=\"$suchart\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"sort\"    VALUE=\"$sort\"   > \n");
	print("<INPUT TYPE=hidden   NAME=\"Lines_Displayed\"    VALUE=\"$Lines_Displayed\"   > \n");
	print("<INPUT TYPE=hidden   NAME=\"la\" VALUE=\"$la\"   > \n");
	print("</FORM>");
	print("</TD>");
	}
	print("<TR>");

	print("</TABLE> \n");

	print("<TABLE BORDER=0> ");
	print("<TD VALIGN=top> \n");
	print("<FORM METHOD=\"POST\" ACTION=\"$url/ergebnis.$php\"> \n");
	print("<B>$akt_seite: </B>");
	print("<INPUT NAME=\"page\"                      VALUE=\"$page\" SIZE=\"5\"> \n"); 
	print("<INPUT TYPE=hidden   NAME=\"startindex\"  VALUE=\"$startindex\"     > \n");
        print("<INPUT TYPE=hidden   NAME=\"suchfeld1\"    VALUE=\"$suchfeld1\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"suchwert1\"    VALUE=\"$suchwert1\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"suchfeld2\"    VALUE=\"$suchfeld2\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"suchwert2\"    VALUE=\"$suchwert2\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"suchfeld3\"    VALUE=\"$suchfeld3\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"suchwert3\"    VALUE=\"$suchwert3\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"opt1\"    VALUE=\"$opt1\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"opt2\"    VALUE=\"$opt2\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"suchart\"    VALUE=\"$suchart\"   > \n");
        print("<INPUT TYPE=hidden   NAME=\"sort\"    VALUE=\"$sort\"   > \n");
	print("<INPUT TYPE=hidden   NAME=\"Lines_Displayed\"    VALUE=\"$Lines_Displayed\"   > \n");
	print("<INPUT TYPE=hidden   NAME=\"la\" VALUE=\"$la\"   > \n");
	print("</FORM>");
	print("<TR>");

	printf("<TD>$anz_seite: <TD><B> %5d </B> <TR>", $MaxPage );
	printf("<TD>$anz_dok: <TD> <B> %5d </B> <TR>", $num );


	print("</TABLE> \n");

    }

    else {
	#print ("Keine Datens&auml;tze gefunden.\n");
	print ("$t_text4\n");
	$suche = "";
	if ($suchwert1 != "") {
		$suche = $suchwert1;
	}
	if ($suchwert2 != "") {
		$suche = $suche . "+$suchwert2";
	}
	if ($suchwert3 != "") {
		$suche = $suche . "+$suchwert3";
	}
	if ($opt1 == "AND") {
		$opt1 = "%3B";
	}
	else {
		if ($opt1 == "OR") {
			$opt1 = "%2C";
		}
	}
	#print ("<P>M&ouml;chten Sie eine <A HREF=$url_volltextsuche?method=and&format=builtin-long&sort=score&config=htdig&restrict=&exclude=html&words=$suche>Volltextsuche</A> durchf&uuml;hren?\n");
	print ("<P>$t_text5 <A HREF=$url_volltextsuche?method=and&format=builtin-long&sort=score&config=htdig&restrict=&exclude=html&words=$suche>$t_text6</A>$t_text7\n");

	#print ("<P>Haben Sie schon unsere <A HREF=\"abfrage_suchen.$php#Tips\">Tipps zur Suche</A> gelesen?\n");
	print ("<P>$t_text8 <A HREF=\"abfrage_suchen.$php?la=$la#Tips\">$t_text9 </A> $t_text10\n");
    }

   $opus->free_result($res);
   $opus->close($sock);
   $design->foot("ergebnis.$php", $la);
?>

