<script language="php">
//==============================================================
//
//  email.php
//
//  Send an email to the authors collective or the verification 
//  address, with a message from the OPUS user. Austhors adresses are 
//  not exposed to the user.
//
//  Requires PHPMailer to send email
//
//  $Id: $
//
//  Last change: <Tue, 2006/04/25 10:16:25 arwagner wubi101>
//
//  Author     : Alexander Wagner
//  Language   : PHP 4, HTML 4.01
//
//----------------------------------------------------------------
//
//    Copyright (C) 2006 by Universitaetsbibliothek Wuerzburg
//
//    This is free software; you can redistribute it and/or modify it
//    under the terms of the GNU Genereal Public License as published
//    by the Free Software Foundation; either version 2, or (at your
//    option) any later version.
//
//    This program is distributed in the hope that it will be usefull,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//    General Public License for more details.
//
//    You should have recieved a copy of the GNU General Public 
//    License along with this program; if not, write to the 
//    Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 
//    02139, USA.
//
//============================================================== -->

// This file is allowed to be called from the user -->
define('APPLICATION', true);
//
//----------------------------------------------------------------------
// GetDocumentDescription():
//    Get the title, abstract and urn of the paper
//
//    $source_opus = document ID
//----------------------------------------------------------------------
   function GetDocumentDescription($source_opus) {

      global $opus, $title, $desc, $urn;

      // Get some information about the document for the author to make 
      // it easier to answer the request
      $sqlstring = "SELECT title, description, urn FROM opus WHERE source_opus = $source_opus;";

      $res = $opus->query($sqlstring);
      $mrow = $opus->fetch_row($res);
      $title = $mrow[0];
      $desc  = $mrow[1];
      $urn   = $mrow[2];
   }

//----------------------------------------------------------------------
// GetDocumentVerification():
//    Get the document's verification address from opus 
//
//    $source_opus = document ID
//----------------------------------------------------------------------
   function GetDocumentVerification($source_opus) {

      global $opus, $creator_name, $toaddress;

      $sqlstring = "SELECT verification FROM opus WHERE source_opus = $source_opus";
      $res = $opus->query($sqlstring);
      $num = $opus->num_rows($res);
      $mrow = $opus->fetch_row($res);
      $toaddress[0] = $mrow[0];

   }

//======================================================================
// main()
//======================================================================
error_reporting(E_ALL);
require_once "./include/opusinterface.inc";
require_once "./include/variables.inc";
require_once "./lib/htmlfunctions.php";
require_once "./lib/phpmailer/class.phpmailer.php";

$titel = "e-Mail";
$ueberschrift = $titel;

require_once "./include/createpage.inc";

$source_opus = $_REQUEST['source_opus'];

// for OPUS Classic use the following line
GetDocumentVerification($source_opus);

GetDocumentDescription($source_opus);

if (isset($_REQUEST['doit'])) {

   $mail = new PHPMailer();



   //------------------------------------------------------------
   // Create the email itself
   //------------------------------------------------------------
   $fromaddress = $_REQUEST['fromaddress'];
   $fromname    = $_REQUEST['fromname'];

   $mail->From     = $fromaddress;
   $mail->Sender   = $fromaddress;
   $mail->FromName = $fromname;

   // If using a smarthost:
   if ($phpemail['smtp_mode'] == 'enabled') {
      $mail->Host     = $phpemail['smtp_host'];
      $mail->Port     = $phpemail['smtp_port'];
      $mail->Username = $phpemail['smtp_username'];
      $mail->Mailer   = "smtp";
   }

   $mail->Subject = $phpemail['subject'];

   $desc = wordwrap($desc, 70);
   $body        = $phpemail['autotext'];
   $body       .= $_REQUEST['body'];
   $body       .= $phpemail['autotext'];
   $body       .= "\n";
   $body       .= $phpemail['line'];
   $body       .= "\n";
   $body       .= $phpemail['refersto'];
#   $body       .= "\n   (http://nbn-resolving.de/$urn)\n";
#   $body       .= $phpemail['line'];
   $body       .= "\n\n";
   $body       .= "Title   : $title\n\n";
   $body       .= "Abstract:\n";
   $body       .= "   $desc";
   $body       .= "\n";
   $body       .= $phpemail['line'];
   $body       .= "\n";

   $mail->Body = $body;
   $mail->AddAddress($toaddress[0], $creator_name[0]);

   for ($i = 1; $i < count($toaddress); $i++) {
      // There seems a bug in PHP's mail() so Cc: does not work, so 
      // AddCC does not work in phpmailer either... :(
      //
      // $mail->AddCC($toaddress[$i], $creator_name[$i]);

      // Resort to the dumb idea of using To: with multiple names 
      // instead. That _IS_ ugly but well...
      $mail->AddAddress($toaddress[$i], $creator_name[$i]);
   }

   if(!$mail->Send())
   {
     echo 'There was a problem sending this mail!';
   }
   else
   {
      print("<pre>\n");
      print("From    : \"$fromname\" < $fromaddress >\n");
      print("Subject : ". $phpemail['subject']. "\n");
      print($body);

      print("</pre>\n");
   } 
}
else {
   // Who is requesting information?
   $fromname    = "";
   $fromaddress = "";

   // Message body
   $body = "";
   print("<h4>$askabouttext</h4>");
   print("<p><b>$title</b></p>\n");
   print("<p>$desc</p>\n");

   print("<form name=\"dcform\" method=\"post\" action=\"\">");

   SetTextField("", "FromName", $frommailnametitle, "",
                $fromname, "fromname", "");
   SetTextField("", "fromAddress", $frommailaddrtitle, "",
                $fromaddress, "fromaddress", "");
   SetTextArea("", "Body", $mailbodytitle, "" , $body, "body", 80, 15);

   // If the submit button was pressed no dialog should show up
   print("<input type=\"hidden\" name=\"doit\" value=\"1\">\n");

   print("
   <input type=\"submit\" name=\"Submit\" value=\"Submit\">
   &nbsp;&nbsp;&nbsp;
   <input type=\"reset\" value=\"Reset\">");

   print("</form>\n");
}

include "./include/footer.inc";
</script>
