<script language="php">
//==============================================================
//
//  htmlfunctions.php
//
//  Functions to place some html elements and related stuff.
//
//  $Id: htmlfunctions.php,v 1.13 2006/04/10 14:37:32 arwagner Exp $
//
//  Last change: <Tue, 2006/04/25 10:19:59 arwagner wubi101>
//
//  Author     : Alexander Wagner
//  Language   : PHP 4, HTML 4.01
//
//----------------------------------------------------------------
//
//    Copyright (C) 2006 by Universitaetsbibliothek Wuerzburg
//
//    This is free software; you can redistribute it and/or modify it
//    under the terms of the GNU Genereal Public License as published
//    by the Free Software Foundation; either version 2, or (at your
//    option) any later version.
//
//    This program is distributed in the hope that it will be usefull,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//    General Public License for more details.
//
//    You should have recieved a copy of the GNU General Public 
//    License along with this program; if not, write to the 
//    Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 
//    02139, USA.
//
//==============================================================
   // This is an include file. Do not allow stand alone call -->
   if (!defined('APPLICATION')) exit;

//----------------------------------------------------------------------
// SubmitFormHeadline()
// For OPUS file upload dialog, set a headline of the form in the
// usual layout.
//
// $ico       : Icon to display, normally only set for required fields
// $helpform  : The form to call for help-requests
// $la        : language
// $tag       : Tag to jump to in help document
// $headline  : The headline text acting as the link anchor
// $text      : Textual description beyond the anchor. 
//              NOTE: This can be a form element...
//
// NOTE: This function unlike the others does NOT place a paragraph
//       enviroment arrount the line!
//----------------------------------------------------------------------
function SetFormHeadline($ico, $helpform, $la, $tag, $headline, $text="")
{
   print("$ico\n");
   print("<b><a href=\"$helpform?la=$la#$tag\">$headline</a>$text</b><br>");
}

//----------------------------------------------------------------------
// SetTextArea()
// Set up a text area input for use in this form
//
// $ico       : Icon to display, normally only set for required fields
// $tag       : Tag to jump to in help document
// $helptitle : Text for the Help-Link
// $text      : Textual description
// $textpreset: Current input in the textarea
// $areaname  : Name of the form-element
// $cols      : number of clumns
// $rows      : number of rows
//----------------------------------------------------------------------
function SetTextArea($ico, $tag, $helptitle, $text,
                     $textpreset, $areaname, $cols=80, $rows=2 )
{
   global $la;
   global $doku_pfad;

   print("   <p>$ico
      <b>
      <a href=\"$doku_pfad/hilfe_formular.php?la=$la#$tag\">$helptitle</a>
      $text
      </b>
      <br>\n");
   // The text in textareas has to be enclosed tightly in > and <
   // otherwise one will collect useless spaces here!
   print("         <textarea name=\"$areaname\" cols=\"$cols\" rows=\"$rows\">$textpreset</textarea>\n");
   print("      <br>
   </p>\n\n"
   );
}

//----------------------------------------------------------------------
// SetTextField()
// Set up a text field for the current form
// $ico       : Icon to display, normally only set for required fields
// $tag       : Tag to jump to in help document
// $helptitle : Text for the Help-Link
// $text      : Textual description
// $fieldvalue: Current value of the textfield
// $fieldname : Name of the form-element
// $endtext   : Text to place after the field (eg some buttons)
// $width     : width of the field
// $maxlength : maximum entry lenth
//----------------------------------------------------------------------
function SetTextField($ico, $tag, $helptitle, $text, 
                      $fieldvalue, $fieldname,
                      $endtext="",
                      $width=80, $maxlength=100
                   )
{
   global $la;
   global $doku_pfad;

   print("<p>
      $ico
      <b> 
         <a href=\"$doku_pfad/hilfe_formular.php?la=$la#$tag\">$helptitle</a>
      </b> 
      $text\n");
   if ($width > 40) { print("   <br>\n"); }
   print("   <input type=\"text\" name=\"$fieldname\" value=\"$fieldvalue\" size=\"$width\" maxlength=\"$maxlength\">\n");
   print("$endtext\n");
   print("</p>\n\n");
}

//vim: ft=php
</script>
