<?
#############################################################
# frontdoor.php - Frontdoor 
#
# letzte Aenderung:
#
# Auslagerung Design in lib/design.php
# In Abhaengigkeit von $la kann das entsprechende Design eingelesen werden.
#
# 27.4.2005, Annette Maile, UB Stuttgart
# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
#
# 29.7.2005, Annette Maile, UB Stuttgart
# Einfuegen Lizenzvertrag
#
# 16.9.2005, Birgit Dressler, SULB Saarbruecken
# Einfuehrung der Mehrsprachigkeit (Variable $la)
# Textdatei: texte/$la/frontdoor.conf
#
# 11.10.2005, Annette Maile, UB Stuttgart
# neue Variablen $statistik: 1 - Statistik anzeigen, 0 - nicht anzeigen
#                $statistik_pfad - Aufruf des Statistikprogramms awstats
#                $empfehlen: 1 - Dokument per email weiterempfehlen,
#                            0 - nicht anzeigen
#
#############################################################

include ("../lib/class.configFile.php");
$conf = new configFile ("../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");

include ("../lib/class.opus_$dbms.$php");
$opus = new opus;

$db = $conf->value("db");
$opustable = $conf->value("opus_table");
$url = $conf->value("url");
$url_anzeigen = $conf->value("url_anzeigen");
$urn_anzeigen = $conf->value("urn_anzeigen");
$lic_active = $conf->value("license_active");
$doku_pfad = $conf->value("doku_pfad");
$statistik = $conf->value("statistik");
$awstats_url = $conf->value("awstats_url");
$awstats_config = $conf->value("awstats_config");
$empfehlen = $conf->value("empfehlen");


# BD, 16.9.05: steht nun in frontdoor.conf
# $titel = $conf->value("titel_frontdoor");
# $ueberschrift = $conf->value("ueberschrift_frontdoor");

// Anfang Collections
$coll_anzeigen = $conf->value( "coll_anzeigen" );
// Ende Collections


$opustable_inst = $opustable . "_inst";
$opustable_diss = $opustable . "_diss";
$opustable_subject_type = $opustable . "_subject_type";
$opustable_sr = $opustable . "_schriftenreihe";

// Anfang Collections
$opustable_coll = $opustable . "_coll";
// Ende Collections

include ("../lib/stringValidation.php");
$source_opus = $_REQUEST['source_opus'];
if (! _is_valid($source_opus,1,10,"[0-9]+")) {die ("Fehler in Parameter source_opus");}
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# A.Maile 10.2.05: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}

/* <hatop@ub.uni-marburg.de> start: */
$sock = $opus->connect();
$done = 0;
if ( $sock >= 0 ) {
if ( $opus->select_db($db) >= 0 ) {
$res = $opus->query("SELECT url FROM $opustable WHERE source_opus = $source_opus ");
$mrow = $opus->fetch_row($res);
$archiv_url  = htmlspecialchars($mrow[0]);
	  if ( @readfile("$archiv_url/index.html") >0 ) {
	       $done++;
	  }
}
$opus->close($sock);
}
if ( $done > 0 ) {
  return; /* we made it */
}
/* <hatop@ub.uni-marburg.de> end */

# BDressler Texte aus Textdatei in Programmvariablen füllen
$texte = new configFile ("../texte/$la/frontdoor.conf");
$titel = $texte->value("titel");
$ueberschrift = $texte->value("ueberschrift");
$lizenz = $texte->value("lizenz");
$text1 = $texte->value("text1");
$text2 = $texte->value("text2");
$t_weitere_beteiligte = $texte->value("t_weitere_beteiligte");
$t_empfehlen = $texte->value("t_empfehlen");
$t_statistik = $texte->value("t_statistik");
$text3 = $texte->value("text3");
$text4 = $texte->value("text4");
$t_format = $texte->value("t_format");
$pod_linkname_1 = $texte->value("pod_linkname_1");
$pod_linkname_2 = $texte->value("pod_linkname_2");
$schlagwoerter_swd = $texte->value("schlagwoerter_swd");
$schlagwoerter_frei = $texte->value("schlagwoerter_frei");
$schlagwoerter_engl = $texte->value("schlagwoerter_engl");
$t_collection = $texte->value("t_collection");
$t_institut = $texte->value("t_institut");
$t_fakultaet = $texte->value("t_fakultaet");
$t_university = $texte->value("t_university");
$ddc_sachgruppe = $texte->value("ddc_sachgruppe");
$sonstige_institution = $texte->value("sonstige_institution");
$t_dokumentart = $texte->value("t_dokumentart");
$t_schriftenreihe = $texte->value("t_schriftenreihe");
$t_bandnr = $texte->value("t_bandnr");
$t_hauptberichter = $texte->value("t_hauptberichter");
$t_isbn = $texte->value("t_isbn");
$t_quelle = $texte->value("t_quelle");
$t_sprache = $texte->value("t_sprache");
$t_pruefung_muendlich = $texte->value("t_pruefung_muendlich");
$t_erstellungsjahr = $texte->value("t_erstellungsjahr");
$t_publikationsdatum = $texte->value("t_publikationsdatum");
$text6 = $texte->value("text6");
$t_bemerkung = $texte->value("t_bemerkung");
$text7 = $texte->value("text7");
$text8 = $texte->value("text8");
$text9 = $texte->value("text9");
$text10 = $texte->value("text10");
$text11 = $texte->value("text11");

$patent_titel = $texte->value("patent_titel");
$patent_applikation = $texte->value("patent_applikation");
$patent_erfinder = $texte->value("patent_erfinder");
$patent_erfinder2 = $texte->value("patent_erfinder2");
$patent_anmelder = $texte->value("patent_anmelder");
$patent_anmeldejahr = $texte->value("patent_anmeldejahr");
$patent_erteilung = $texte->value("patent_erteilung");
$patent_laender = $texte->value("patent_laender");
$patent_nummer = $texte->value("patent_nummer");

# Annette Maile, 18.3.05 Design aus lib/design.php einlesen
require ("../lib/design.$php");
$design = new design;
$design->head_titel($titel);
$design->head_ueberschrift($ueberschrift, $la);

print("<FONT COLOR=red>");
$sock = $opus->connect();
if ( $sock < 0 ) {
	echo ("Error: $ERRMSG\n");
}

if ( $opus->select_db($db) < 0 ) {
	echo ("Error: $ERRMSG\n");
}
print("</FONT> \n");

$res = $opus->query("SELECT * FROM $opustable WHERE source_opus = $source_opus ");

$num_res = $opus->num_rows($res);
if ($num_res > 0) {
$mrow = $opus->fetch_row($res);

$title  = htmlspecialchars($mrow[0]);
$creator_corporate = $mrow[1];
$subject_swd = htmlspecialchars($mrow[2]);
#$description = htmlspecialchars($mrow[3]);
$description = $mrow[3];
$publisher_university = $mrow[4];
$contributors_name = $mrow[5];
$contributors_corporate = $mrow[6];
$date_year = $mrow[7];
$date_creation = $mrow[8];
$date_modified_old = $mrow[9];
$type = $mrow[10];
$source_opus = $mrow[11];
$source_title = htmlspecialchars($mrow[12]);
$source_swb = $mrow[13];
$language = $mrow[14];
$verification= $mrow[15];
$subject_uncontrolled_german = htmlspecialchars($mrow[16]);
$subject_uncontrolled_english= htmlspecialchars($mrow[17]);
$title_en = $mrow[18];
#$description2 = htmlspecialchars($mrow[19]);
$description2 = $mrow[19];
$subject_type = $mrow[20];
$date_valid = $mrow[21];
$description_lang = $mrow[22];
$description2_lang = $mrow[23];
$sachgruppe_ddc = $mrow[24];
$urn = $mrow[25];
$bereich_id = $mrow[26];
if ($lic_active >= 2) {
	$lic = $mrow[27];
}
$isbn = $mrow[28];
$bem_extern = $mrow[30];

$opus->free_result($res); 

# BD/UH, 11/2005
# wenn Dokumenttyp = 56 = Patent, besetzt man die Variablen mit den 
# Werten der Patentvariablen um, damit z.B. statt Verfasser Erfinder erscheint
if ($type == "56") 
{
  $text3 = $patent_applikation;
  $text4 = $patent_laender;
  $text9 = "";
  $t_weitere_beteiligte = $patent_anmelder;
  $t_erstellungsjahr = $patent_anmeldejahr;
  $schlagwoerter_engl = $patent_erteilung;
  $t_quelle = $patent_nummer;
}

/***** Schriftenreihe Start *****/
$res = $opus->query("SELECT * FROM $opustable_sr WHERE source_opus = $source_opus ");
$num_res = $opus->num_rows($res);

if ($num_res > 0) {
        $mrow = $opus->fetch_row($res);
        $sr_id   = $mrow[1];
        $sr_band = $mrow[2];

        $res = $opus->query("select name from schriftenreihen where sr_id = '$sr_id' ");
        $mrow = $opus->fetch_row($res);
        $sr_name = $mrow[0];
        $opus->free_result($res);
}
/***** Schriftenreihe Stop *****/

/* Bei Dissertation (type 8) und Habilitation (type 24) zusaetzlich */
/* Tag der muendlichen Pruefung (bzw. des Kollquiums) und Hauptberichter anzeigen */
if ($type == "8" || $type == "24") {
	$res = $opus->query("SELECT date_accepted, advisor, publisher_faculty, title_de FROM $opustable_diss WHERE source_opus = $source_opus");
	$anz = $opus->num_rows($res);
	if ( $anz  > 0 ) {
		$mrow = $opus->fetch_row($res);
		$date_accepted = $mrow[0];
		$advisor = htmlspecialchars($mrow[1]);
		$faculty_nr = $mrow[2];
		$title_de = $mrow[3];
	}
	$opus->free_result($res);
	$res = $opus->query("SELECT fakultaet from faculty_$la where nr = '$faculty_nr'");
	$mrow = $opus->fetch_row($res);
	$publisher_faculty = $mrow[0];
	$opus->free_result($res);	
}

$jahr = date("Y", $date_creation);

$res = $opus->query("SELECT name FROM institute_$la i, $opustable_inst oi WHERE i.nr=oi.inst_nr and oi.source_opus = '$source_opus'");
$instnum = $opus->num_rows($res);
        $i = 0;
        while ($i < $instnum) {
            $i++;
            $mrow = $opus->fetch_row($res);
            $inst[$i] = $mrow[0];
        }
$opus->free_result($res);

// Anfang Collections
if( $coll_anzeigen == "true" ) {
	$res = $opus->query( "SELECT c.coll_id FROM collections as c, $opustable_coll as oc WHERE c.coll_id = oc.coll_id and oc.source_opus = '$source_opus'");
	$collnum = $opus->num_rows( $res );
	$i = 0;
	while( $i < $collnum ) {
		$i++;
		$mrow = $opus->fetch_row( $res );
		$coll[$i] = $mrow[0];
	}
	$opus->free_result( $res );
}
// Ende Collections

$res = $opus->query("SELECT sprache FROM language_$la WHERE code='$language'");
$mrow = $opus->fetch_row($res);
$sprache=$mrow[0];
$opus->free_result($res);

$res = $opus->query("SELECT sprache FROM language_$la WHERE code='$description_lang'");
$mrow = $opus->fetch_row($res);
$sprache_description=$mrow[0];
$opus->free_result($res);

if ($description2_lang != "") {
	$res = $opus->query("SELECT sprache FROM language_$la WHERE code='$description2_lang'");
	$mrow = $opus->fetch_row($res);
	$sprache_description2=$mrow[0];
	$opus->free_result($res);
}

$res = $opus->query("SELECT dokumentart FROM resource_type_$la WHERE typeid='$type'");
$mrow = $opus->fetch_row($res);
$dokumentart=$mrow[0];
$opus->free_result($res);

# Start Lizenzvertrag
if ($lic_active >= 2) {
	$res = $opus->query("SELECT longname, link, logo, desc_text, desc_html FROM license_$la WHERE shortname='$lic'");
	$licnum = $opus->num_rows($res);
	if ($licnum == 1) {
		$mrow = $opus->fetch_row($res);
		$licname=$mrow[0];
		$liclink=$mrow[1];
		$liclogo=$mrow[2];
		$licdesc=$mrow[3];
		$licdesc_html=$mrow[4];
	}
	$opus->free_result($res);
	$liclink_head = "<a href=\"".$liclink."\" target=\"_blank\">$lizenz</a><p />";
}
else {
	$liclink_head = "<a href=\"".$doku_pfad."/urheberrecht.php?la=$la\">$text1</a><p />";
}
# Ende Lizenzvertrag

# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# Falls in Altbestaenden (< Opus 3.0) kein Bereich angegeben ist,
# wird bereich_id auf 1 gesetzt = freier Zugriff auf die Dokumente,
# sonst kommt eine Fehlermeldung der Datenbank
if ($bereich_id == "" || $bereich_id == 0) {
	$bereich_id = 1;
}

$res = $opus->query("SELECT bereich, volltext_pfad, volltext_url FROM bereich_$la WHERE bereich_id = $bereich_id");
$num = $opus->num_rows($res);
if ($num > 0) {
	$mrow = $opus->fetch_row($res);
	$bereich = $mrow[0];
	$volltext_pfad = $mrow[1];
	$volltext_url = $mrow[2];
	$opus->free_result($res);
}
# Ende Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche

print("<FONT SIZE=2>$liclink_head \n");
# print("Bitte beziehen Sie sich beim Zitieren dieses Dokumentes immer auf folgende<BR>\n");
print("$text2");

# Wenn Urn vorhanden und urn_anzeigen auf 1 gesetzt ist, wird die Urn angezeigt.
# Wenn keine Urn vorhanden ist und url_anzeigen auf 2 gesetzt ist, dann Url anzeigen.
# Wenn url_anzeigen auf 1 gesetzt ist, dann immer Url anzeigen.
if ($urn && $urn_anzeigen) {
	print("URN: <a href=\"http://nbn-resolving.de/urn/resolver.pl?urn=$urn\"><B>$urn</B></a><BR>\n");
}
else {
	if ($url_anzeigen == 2) {
		print("URL: <a href=\"$volltext_url/$jahr/$source_opus/\"><B>$volltext_url/$jahr/$source_opus/</B></a><BR>\n");
	}
}

if ($url_anzeigen == 1) {
	print("URL: <a href=\"$volltext_url/$jahr/$source_opus/\"><B>$volltext_url/$jahr/$source_opus/</B></a><BR>\n");
}
print("</FONT><HR>");

print("<P> \n");
include("../lib/font.html");
$link="ergebnis.$php?suchart=teil&Lines_Displayed=10&sort=o.date_year+DESC%2C+o.title&suchfeld1=freitext&suchwert1=&opt1=AND&opt2=AND&suchfeld3=date_year&suchwert3=&startindex=0&page=0&dir=2&suche=&suchfeld2=oa.person&suchwert2=";


$res = $opus->query("SELECT creator_name, reihenfolge from opus_autor where source_opus = $source_opus order by reihenfolge ");
$num = $opus->num_rows($res);
if ($num > 0) {
	$mrow = $opus->fetch_row($res);
	$creator_name = $mrow[0];
	$person = htmlspecialchars(rawurlencode($creator_name));
        #TL, 19.03.2007 - Ersten Autor speichern fr Google Scholar        
        $first_creator = $creator_name;
        
	print("<B><A HREF=\"$link$person\">$creator_name</A></B>");
	$pod_creator_names = $person;
	if ($num > 1) {
		$i = 1;
		while ($i < $num) {
			$i++;
			$mrow = $opus->fetch_row($res);
			$creator_name = $mrow[0];
			$person = htmlspecialchars(rawurlencode($creator_name));
			print(" ; \n<B><A HREF=\"$link$person\">$creator_name</A></B>");
			$pod_creator_names.= " ; ".$person;
		}
	}
}


#$res = $opus->query("SELECT creator_name, reihenfolge from opus_autor where source_opus = $source_opus order by reihenfolge ");
#$num = $opus->num_rows($res);
#if ($num > 0) {
#	$mrow = $opus->fetch_row($res);
#	$creator_name = $mrow[0];
#	$person = htmlspecialchars(rawurlencode($creator_name));
#	print("<B><A HREF=\"$link$person\">$creator_name</A></B>");
#	$pod_creator_names = $person;
#	if ($num > 1) {
#		$i = 1;
#		while ($i < $num) {
#			$i++;
#			$mrow = $opus->fetch_row($res);
#			$creator_name = $mrow[0];
#			$person = htmlspecialchars(rawurlencode($creator_name));
#			print(" ; \n<B><A HREF=\"$link$person\">$creator_name</A></B>");
#			$pod_creator_names.= " ; ".$person;
#		}
#	}
#}

$opus->free_result($res);


if ($contributors_name != "") {
	 print("<BR>$contributors_name \n"); 
	# print("<BR>Weitere Beteiligte (Hrsg. etc.): $contributors_name \n"); 
	# print("<BR>$t_weitere_beteiligte $contributors_name \n");
}

if ($creator_corporate != "") {
        print("<BR>$creator_corporate \n");
}

print("</B> \n");
print("<P>\n");
print("<H3>$title</H3>\n");

if ($title_en != "") {
	print("<H3>$title_en</H3>\n");
}

if ($title_de != "") {
        print("<H3>$title_de</H3>\n");
}

/* Es werden die Formate, die in der Tabelle Format im Feld extension stehen */
/* in der Frontdoor angezeigt. Es wird geschaut, ob das jeweilige Directory  */
/* exisitiert und die darin enthaltenen Dateien in einer Tabelle ausgegeben  */
print("<TABLE> \n");

$format = $opus->query("select extension from format where name <> 'Originalformat' ");
$num_format = $opus->num_rows($format);
$f = 0;
while ($f < $num_format) {
	$f++;
	$mrow = $opus->fetch_row($format);
	$ext = $mrow[0];
	if (file_exists("$volltext_pfad/$jahr/$source_opus/$ext") == 1) {
		/* Falls Startfile .*.anzeigen vorhanden, dann nur dieses anzeigen */
		/* hauptsaechlich bei html */
		$handle = opendir("$volltext_pfad/$jahr/$source_opus/$ext");
		while ($file = readdir($handle)) {
			if (ereg(".*.anzeigen", $file) == 1) {
				$startfile = $file;
			}
		}
		closedir($handle);

		if ($startfile != "") {
			/* fuehrenden Punkt und .anzeigen entfernen = Startfile des html-Dokuments */
			$startfile = str_replace(".anzeigen", "", $startfile);
			$startfile = substr($startfile, 1);
			print("<TR>\n<TD>");
			include("../lib/font.html");
			print("$ext-$t_format: \n</TD>\n");
			print("\n<TD><TABLE BORDER=3 CELLPADDING=4 CELLSPACING=4>\n<TR>\n");
			print("<TD>");
			include("../lib/font.html");
			print("<A HREF=\"$volltext_url/$jahr/$source_opus/$ext/$startfile\">Dokument1.$ext </A>\n</TD>\n");
	                print("\n</TR>\n</TABLE>\n");
	                print("</TD></TR>\n");

		}
		else {
			$i = 1;
			$j = 1;
			/* Verzeichnis in Array einlesen und sortieren */
			$handle = opendir("$volltext_pfad/$jahr/$source_opus/$ext");
			while ($file = readdir($handle)) {
				if ($file != "." && $file != "..") {
					/* Dateien, die mit .bem_ beginnen sind Bemerkungen zu den Dateien, */ 
					/* daher werden nur Dateien, die nicht mit .bem_ anfangen in der    */
					/* Frontdoor aufgelistet. Gepackte Dateien werden separat aufgelistet                                    	    */
					if (ereg("^.bem_*", $file) != 1 && eregi(".*.zip", $file) != 1 && eregi(".*.gz", $file) != 1) {
						$dir_array[count($dir_array)] = $file;

					}
				}
			}
			closedir($handle);
			sort($dir_array);
			$k = 0;
			$num = count($dir_array);
			if ($num > 0) {
				print("<TR>\n<TD>");
				include("../lib/font.html");
				print("$ext-$t_format: \n</TD>\n");
				print("\n<TD><TABLE BORDER=3 CELLPADDING=4 CELLSPACING=4>\n<TR>\n");
			}
			while($k < $num) {	
				$filename = array_shift($dir_array);
				$bem_file = "";
				if (file_exists("$volltext_pfad/$jahr/$source_opus/$ext/.bem_$filename")) {
					$fd = fopen("$volltext_pfad/$jahr/$source_opus/$ext/.bem_$filename", "r");
					$bem_file = fread ($fd, filesize("$volltext_pfad/$jahr/$source_opus/$ext/.bem_$filename"));
					fclose($fd);
				}	
				$file = "$volltext_pfad/$jahr/$source_opus/$ext/$filename";
				$array = explode(".", $filename);
				$last = count($array)-1;
				$ext2 = strtolower($array[$last]);
				$size = stat($file);
				$filesize = $size[7];
			   	$filesize = $filesize/1024;
				if ($filesize < 1) {
					$filesize = number_format($filesize, 1);
				}
				else {
					$filesize = number_format($filesize);
				}

				$format2 = $opus->query("select extension from format where extension like '$ext2%' ");
				$num_format2 = $opus->num_rows($format2);
				if ($num_format2 > 0) {
		                        if ($i > 3) {
		               	                print("\n</TR>\n<TR>\n");
		                       	        $i = 1;
               		       		}
					print("<TD>");
					include("../lib/font.html");
					print("<A HREF=\"$volltext_url/$jahr/$source_opus/$ext/$filename\" target=\"new\">Dokument $j.$ext2 ($filesize KB) </A> ");
					if ($bem_file != "") {
						print("($bem_file)");
					}
					print("\n</TD>\n");
					$i++;
					$j++;
				}
				$k++;
			}
			if ($num > 0) {
		                print("\n</TR>\n</TABLE>\n");
			        print("</TD></TR>\n");
			}
		}
		/* gezipptes File mit Endung zip bzw. gz einlesen */
		$g = 0;
		while ($g < 2) {
			$g++;
		        if ($g == 1) {
		                $z = "zip";
		        }
		        if ($g == 2) {
		                $z = "gz";
		        }
			$handle = opendir("$volltext_pfad/$jahr/$source_opus/$ext");
			while ($file = readdir($handle)) {
				if (eregi(".*" . $z, $file) == 1) {
					if (eregi("^.bem_*", $file) != 1) {
						$line = "$volltext_pfad/$jahr/$source_opus/$ext/$file";
        	                                $size = stat($line);
                	                        $filesize = $size[7];
                        	                $filesize = $filesize/1024;
                                	        if ($filesize < 1) {
                                        	        $filesize = number_format($filesize, 1);;
                                        	}
                                        	else {
							$filesize = number_format($filesize);
						}
						$bem_file = "";
						if (file_exists("$volltext_pfad/$jahr/$source_opus/$ext/.bem_$file")) {
							$fd = fopen("$volltext_pfad/$jahr/$source_opus/$ext/.bem_$file", "r");
							$bem_file = fread ($fd, filesize("$volltext_pfad/$jahr/$source_opus/$ext/.bem_$file"));
							fclose($fd);
						}
						print("<TR>\n<TD>");
						include("../lib/font.html");
						print("$ext gepackt: \n</TD>\n");
		        	                print("\n<TD><TABLE BORDER=3 CELLPADDING=4 CELLSPACING=4>\n<TR>\n");
		                	        print("<TD>");
		                        	include("../lib/font.html");
			                        print("<A HREF=\"$volltext_url/$jahr/$source_opus/$ext/$file\">Dokument1.$z ($filesize KB) </A> ");
        	                                if ($bem_file != "") {
                	                                print("($bem_file)");
                        	                }
                                	        print("\n</TD>\n");
						print("\n</TR>\n</TABLE>\n");
						print("</TD></TR>\n");	
					}
				}
			}
			closedir($handle);
		}
	}
}
$opus->free_result($format);

if ($lic_active >= 1) {
	$pod_active = $conf->value("pod_active");
	if ( $pod_active > 0 ) {        // check, ob lic pod erlaubt
		$res = $opus->query("SELECT pod_allowed FROM license_$la WHERE shortname='$lic'");
		$podnum = $opus->num_rows($res);
		if ($podnum == 1) {
			$mrow = $opus->fetch_row($res);
			if ( $mrow[0] == 1 ) {
				print("<TR> \n<TD>");
				include("../lib/font.html");
				print("$pod_linkname_1 </TD> \n");
				print("<TD>\n<table border=\"3\"><tr><td>\n");
				include("../lib/font.html");
				$pod_info = $conf->value("pod_info");
				$tmp_url = "$volltext_url/$jahr/$source_opus/";
				$podlink = $pod_info."?urn=".urlencode($urn)."&docurl=".urlencode($tmp_url)."&lic=".$lic."&aut=".$pod_creator_names."&tit=".htmlspecialchars(rawurlencode($title));
				print("<a href=\"$podlink\" target=\"_blank\">");
				print("$pod_linkname_2 </a> \n</td>\n</tr>\n</table>\n</TD>\n");
				print("</TR> \n");
							}
		}
		$opus->free_result($res);
	}
}

# BD/UH, 27.4.06 Wenn Volltext in SciDok vorhanden, URN zur Frontdoor einblenden
# SciDOk-Datenbank ffnen, um die URN zu lesen
$db_sci="scidok";
if ( $opus->select_db("$db_sci")  < 0 ) {
	echo ("Error: $ERRMSG\n"); 
}
$sci_opus = new opus;
# fuer die Dublettenabfrage muessen evtl. ' im Titel maskiert werden.
$title_select = str_replace("'","\'",$title);
$res = $sci_opus->query("select title, source_title, urn from opus where title='$title_select' ");
$mrow = $sci_opus->fetch_row($res);
$sci_title = $mrow[0];
$sci_source_title= $mrow[1];
$sci_urn= $mrow[2];

# BD, 15.9.2010: auch abprfen, ob die Quelle (source_title) gleich ist, da z.B. drei mal 
# der Titel Editorial in der Jahrbib vorkommt und dann falsch verlinkt wird

# Eintrag in SciDok vorhanden
if (($sci_title != "") && ($sci_source_title == $source_title)) {
    print($text11);
    print("<a href=\"http://nbn-resolving.de/urn/resolver.pl?urn=$sci_urn\"><B>$sci_urn</B></a><BR>"); 
}
else
{
    # kein Eintrag in SciDok vorhanden
    # UH, 26.4.06 Autor per email um Kopie des Dokuments bitten, wenn er es erlaubt hat ($verification enthlt email-Adresse)
    if ($verification !="" AND $source_opus > "261")  
    {
         print("<a href=\"/extern/email.php?la=$la&source_opus=$source_opus\">$text10</a>\n");
    }
}
print("</TABLE>\n");

# jahrbib-Datenbank wieder ffnen
if ( $opus->select_db("$db")  < 0 ) {
	echo ("Error: $ERRMSG\n"); 
}

# A. Maile 11.10.05: Link zur Dokumentempfehlung
print("<BR> \n");
if ($empfehlen == 1) {
	print("<img src= \"./Icons/blind.gif\" border=\"0\" width=\"2\" height=\"1\"><A HREF=./mailform.php?la=$la&jahr=$jahr&source_opus=$source_opus title=\"$t_empfehlen\"><img src=\"./Icons/hand.jpg\" border=\"0\"></a> \n");
}
# A. Maile 11.10.05: Link zur Statistik-Anzeige
if ($statistik == 1) {
	print("<img src= \"./Icons/blind.gif\" border=\"0\" width=\"2\" height=\"1\"><A HREF=\"$awstats_url?urlfilter=/$source_opus/&urlfilterex=&output=urldetail&config=$awstats_config&lang=de \" TARGET=_blank title=\"$t_statistik\"><img src=\"./Icons/statistik.jpg\" border=\"0\"></A> \n");
	#print("_open&lang=de \" TARGET=_blank title=\"Hits\"><img src=\"./Icons/statistik.jpg\" border=\"0\"></A>");
}

# UH / TL 13.03.07: Link zu Google Scholar
	$title_enc = (utf8_encode($title));
        $first_creator = utf8_encode($first_creator);
	print("<img src= \"./Icons/blind.gif\" border=\"0\" width=\"2\" height=\"1\"><A HREF=\"http://scholar.google.com/scholar?q=%22$title_enc%22&as_sauthors=%22$first_creator%22\" target=\"_blank\"><img src =\"./Icons/google_scholar_logo.jpg\" border=\"0\"></A> \n");
	
print("<P>\n");
print("<HR>\n");
include("../lib/font.html");

// UH 2005-11-10 Abstract ausblenden wenn leer, Sprache nicht anzeigen bei
// Dokumenttyp 56 = Patent
if ($type == "56") {$sprache_description = "";}
if ($description != "") {
print("<H3>$text3 $sprache_description</H3>\n");
print(nl2br($description));
print("<HR><P>\n");
}
#if ($description2 != "") {
#	print("<H3>$text4 $text9 $sprache_description2</H3>\n");
#	print(nl2br($description2));
#	print("<HR><P>\n");
#}

print("<TABLE BORDER=0>\n");
include("../lib/font.html");


// UH 2005-11-10 Anzeige der Hochschule Anfang
if ($publisher_university != "") {
	print("<TR> \n<TD>");
	include("../lib/font.html");
	print("<B>$t_university</B></TD> \n");
	print("<TD></TD><TD>");
	include("../lib/font.html");
	print("$publisher_university</TD>\n");
	print("</TR> \n");
}
// UH 2005-11-10 Anzeige der Hochschule Ende

$i = 0;
while ($i < $instnum) {
	$i++;
	print("<TR> \n<TD>");
	include("../lib/font.html");
	if ($instnum > 1) {
		print("<B>$t_institut $i:</B></TD> \n");
	}
	else {
		print("<B>$t_institut:</B></TD> \n");	
	}
	print("<TD></TD><TD>");
	include("../lib/font.html");
	print("$inst[$i]</TD>\n");
	print("</TR> \n");
}

if ($publisher_faculty != "") {
	print("<TR> \n<TD>");
	include("../lib/font.html");
	print("<B>$t_fakultaet</B></TD> \n");
	print("<TD></TD><TD>");
	include("../lib/font.html");
	print("$publisher_faculty </TD>\n");
	print("</TR> \n");
}





print("<TR> \n<TD>");
include("../lib/font.html");
print("<B>$t_dokumentart</B></TD> \n");
print("<TD></TD><TD>");
include("../lib/font.html");
print("$dokumentart </TD>\n");
print("</TR> \n");

/***** Schriftenreihe Start *****/
if ($sr_id != "" && $sr_band != "") {
        print("<TR> \n<TD>");
        include("../lib/font.html");
        print("<B>$t_schriftenreihe</B></TD> \n");
        print("<TD></TD><TD>");
        include("../lib/font.html");
        print("$sr_name </TD>\n");
        print("</TR> \n");
        print("<TR> \n<TD>");
        include("../lib/font.html");
        print("<B>$t_bandnr</B></TD> \n");
        print("<TD></TD><TD>");
        include("../lib/font.html");
        print("$sr_band </TD>\n");
        print("</TR> \n");

}
/***** Schriftenreihe Stop *****/

if ($advisor != "") {
	print("<TR> \n<TD>");
	include("../lib/font.html");
	print("<B>$t_hauptberichter</B></TD> \n");
	print("<TD></TD><TD>");
	include("../lib/font.html");
	print("$advisor </TD>\n");
	print("</TR> \n");
}

if ($isbn != "") {
        print("<TR> \n<TD>");
        include("../lib/font.html");
        print("<B>$t_isbn</B></TD> \n");
        print("<TD></TD><TD>");
        include("../lib/font.html");
        print("$isbn </TD>\n");
        print("</TR> \n");
}

# UH 2005-11-14 Bei Buchbeitrgen (Resourcetype 53) wird Herausgeber aus Feld contirubutorsname eingeblendet
if ($source_title != "") {
	if ($type != "53") {
       	print("<TR> \n<TD>");
	include("../lib/font.html");
   	print("<B>$t_quelle</B></TD> \n");
   	print("<TD></TD><TD>");
	include("../lib/font.html");
	print("$source_title </TD>\n");
	print("</TR> \n");
	}
	else {
       	print("<TR> \n<TD>");
	include("../lib/font.html");
   	print("<B>$t_quelle</B></TD> \n");
   	print("<TD></TD><TD>");
	include("../lib/font.html");
	print("In: $contributors_name: $source_title </TD>\n");
	print("</TR> \n");
	}
}



#print("<TR> \n<TD>");
#include("../lib/font.html");
#print("<B>$t_erstellungsjahr</B></TD> \n");
#print("<TD></TD><TD>");
#include("../lib/font.html");
#print("$date_year </TD>\n");
#print("</TR> \n");



// UH 2005-11-10 Anfang: Auszublendende Elemente

# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# Wenn Zugriffsbeschraenkung besteht ($bereich_id > 1)
# dann diese anzeigen.
if ($bereich_id > 1) {
	print("<TR> \n<TD>");
	include("../lib/font.html");
        # print("<B>Zugriffsbeschr&auml;nkung:</B></TD> \n");
	print("<B>$text4</B></TD> \n");
	print("<TD></TD><TD>");
	include("../lib/font.html");
	print("$bereich </TD>\n");
	print("</TR> \n");
}
# Ende Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche

if ($subject_swd != ""){
	print("<TR> \n<TD>");
	include("../lib/font.html");
	print("<B>$schlagwoerter_swd</B></TD> \n");
	print("<TD></TD><TD>");
	include("../lib/font.html");
	print("$subject_swd </TD>\n");
	print("</TR> \n");
}

if ($subject_uncontrolled_german != ""){
	print("<TR>\n<TD>");
	include("../lib/font.html");
        print("<B>$schlagwoerter_frei</B></TD> \n");
        print("<TD></TD><TD>");
	include("../lib/font.html");
	print("$subject_uncontrolled_german </TD>\n");
	print("</TR> \n");
}

if ($subject_uncontrolled_english != ""){
	print("<TR> \n<TD>");
	include("../lib/font.html");	
        print("<B>$schlagwoerter_engl</B></TD> \n");
        print("<TD></TD><TD>");
	include("../lib/font.html");
	print("$subject_uncontrolled_english </TD>\n");
	print("</TR> \n");
}

if ($text4 != ""){
	print("<TR> \n<TD>");
	include("../lib/font.html");	
        print("<B>$text4</B></TD> \n");
        print("<TD></TD><TD>");
	include("../lib/font.html");
	print("$description2</TD>\n");
	print("</TR> \n");
}

if ($subject_type != ""){
	$opustable_subject_type = $opustable . "_" . $subject_type;
        $res = $opus->query("SELECT class from $opustable_subject_type where source_opus = $source_opus");
        $num = $opus->num_rows($res);
        if ($num > 0) {
                $mrow = $opus->fetch_row($res);
                $class = $mrow[0];
                $i = 1;
                while ($i < $num) {
                        $i++;
                        $mrow = $opus->fetch_row($res);
                        $class = "$class , $mrow[0]";
                }
                $opus->free_result($res);
                $res = $opus->query("SELECT name from klassifikation_$la where table_name = '$subject_type' ");
                $mrow = $opus->fetch_row($res);
                $class_name = $mrow[0];
		$opus->free_result($res);
	
		print("<TR> \n<TD>");
		include("../lib/font.html");
       		print("<B>$class_name:</B></TD> \n");
	        print("<TD></TD><TD>");
		include("../lib/font.html");
		print("$class </TD>\n");
		print("</TR> \n");
	}
}

//Anfang Collections
if( $coll_anzeigen == "true" ) {
	$i = 0;
	while( $i < $collnum ) {
		$i++;
		
		// Wir finden den coll_name der Collection heraus
		
		$res_coll = $opus->query( "SELECT coll_name FROM collections WHERE coll_id = $coll[$i];" );
		$mrow_coll = $opus->fetch_row( $res_coll );
		$coll_name = $mrow_coll[0];
		
		// Wir finden den Namen und die ganze Hierarchie nach oben heraus
		
		$query_eltern = "SELECT a.coll_name, (a.rgt - a.lft ) AS height
							FROM collections AS a, collections AS b
							WHERE b.lft BETWEEN a.lft AND a.rgt
							AND b.coll_id = '$coll[$i]'
							ORDER BY height DESC;";
							
		$res_eltern = $opus->query( $query_eltern );
		$num_eltern = $opus->num_rows( $res_eltern );
		
		print( "<tr> \n<td>");
		include("../lib/font.html");
		if( $collnum > 1 ) {
			print( "<b>$t_collection $i:</b></td> \n" );
		} else {
			print("<b>$t_collection:</b></td>\n");
		}
		print("<td></td><td>");
		include( "../lib/font.html" );

		$m = 0;
		while( $m < $num_eltern ) {
			$mrow_eltern = $opus->fetch_row( $res_eltern );
			$coll_name_eltern = $mrow_eltern[0];
			if( $coll_name_eltern != $coll_name ) {
				echo "$coll_name_eltern / ";
			} else {
				echo "$coll_name_eltern";
			}
			$m++;
		}
		print("</tr> \n");
	}
}
// Ende Collections

if ($sachgruppe_ddc != "" && $sachgruppe_ddc != "no") {
	$res = $opus->query ("SELECT sachgruppe FROM sachgruppe_ddc_$la where nr = '$sachgruppe_ddc'");
	$num = $opus->num_rows($res);
	if ($num > 0) {
		$mrow = $opus->fetch_row($res);
		$sachgruppe_ddc = $mrow[0];
	}
	$opus->free_result($res);
        print("<TR> \n<TD>");
        include("../lib/font.html");
        print("<B>$ddc_sachgruppe</B></TD> \n");
        print("<TD></TD><TD>");
        include("../lib/font.html");
        print("$sachgruppe_ddc</TD>\n");
        print("</TR> \n");
}

#print("<TR> \n<TD>");
#include("../lib/font.html");
#print("<B>$t_publikationsdatum</B></TD> \n");
#print("<TD></TD><TD>");
#include("../lib/font.html");
#$date_creation_format = strftime("%d.%m.%Y", $date_creation);
#print("$date_creation_format </TD>\n");
#print("</TR> \n");

if ($date_valid != 0) {
	print("<TR> \n<TD>");
	include("../lib/font.html");
	#print("<B>G&uuml;ltig bis:</B></TD> \n");
	print("<B>$text6</B></TD> \n");
	print("<TD></TD><TD>");
	include("../lib/font.html");
	$date_valid_format = strftime("%d.%m.%Y", $date_valid);
	print("$date_valid_format </TD>\n");
	print("</TR> \n");
}


# Start Lizenzvertrag
if ($lic_active >= 2) {
	if ( $licname != "" ) {
		print("<TR> \n<TD VALIGN=TOP>");
		include("../lib/font.html");
		print("<B>$lizenz:</B></TD> \n");
		print("<TD></TD>\n<TD>");
		include("../lib/font.html");	
		if ( strlen(trim($licdesc_html)) > 0 ) {
			print("\n".$licdesc_html."\n");
		}
		$lic_uselogos = $conf->value("license_uselogos");
		if ( ( $lic_uselogos ) AND ( strlen($liclogo) > 0 ) ) {
			$liclogo_width = $conf->value("license_logo_width");
			$liclogo_height = $conf->value("license_logo_height");
			$liclogo_wh = "";
			if ( $liclogo_width ) {
				$liclogo_wh.= " width=\"".$liclogo_width."\"";
			}
			if ( $liclogo_height ) {
				$liclogo_wh.= " height=\"".$liclogo_height."\"";
			}
			print("<a href=\"$liclink\" target=\"_blank\">\n");
			print("<img src=\"".$liclogo."\" alt=\"Lizenz-Logo\" border=\"0\"".$liclogo_wh.">");
			print("</a>&nbsp;\n");
		}
		print("<a href=\"$liclink\" target=\"_blank\">\n");
		print("$licname</a> \n</td>\n");
		print("</tr> \n");
	}
}

if ( $pod_active > 0 ) {        // check, ob lic pod erlaubt
	$res = $opus->query("SELECT pod_allowed FROM license_$la WHERE shortname='$lic'");
	$podnum = $opus->num_rows($res);
	if ($podnum == 1) {
		$mrow = $opus->fetch_row($res);
		if ( $mrow[0] == 1 ) {
			print("<TR> \n<TD VALIGN=TOP>");
			include("../lib/font.html");	
			print("<B>".$pod_linkname_1."</B></TD> \n");
			print("<TD></TD>\n<TD>");
			include("../lib/font.html");
			$pod_info = $conf->value("pod_info");
			$tmp_url = $volltext_url."/".$jahr."/".$source_opus."/";
			$podlink = $pod_info."?urn=".urlencode($urn)."&docurl=".urlencode($tmp_url)."&lic=".$lic."&aut=".$pod_creator_names."&tit=".htmlspecialchars(rawurlencode($title));
			$pod_uselogos = $conf->value("pod_uselogos");
			$pod_partner_logo = $conf->value("pod_partner_logo");
			if ( ( $pod_uselogos ) AND ( strlen($pod_partner_logo) > 0 ) ) {
				$podlogo_width = $conf->value("pod_logo_width");
				$podlogo_height = $conf->value("pod_logo_height");
				$podlogo_wh = "";
				if ( $podlogo_width ) { $podlogo_wh.= " width=\"".$podlogo_width."\""; }
				if ( $podlogo_height ) { $podlogo_wh.= " height=\"".$podlogo_height."\""; }
				print("<a href=\"$podlink\" target=\"_blank\">\n");
				print("<img src=\"".$pod_partner_logo."\" alt=\"POD-Logo\" border=\"0\"".$podlogo_wh.">");
				print("</a>&nbsp;\n");
			}
			print("<a href=\"$podlink\" target=\"_blank\">\n");
			print($pod_linkname_2."</a> </td>\n");
			print("</tr> \n");
		}
	}
	$opus->free_result($res);
}
# Ende Lizenzvertrag

print("<TR> \n<TD>");
include("../lib/font.html");
print("<B>$t_sprache</B></TD> \n");
print("<TD></TD><TD>");
include("../lib/font.html");
print("$sprache </TD>\n");
print("</TR> \n");

if ($date_accepted != "") {
        print("<TR> \n<TD>");
	include("../lib/font.html");
        print("<B>$t_pruefung_muendlich</B></TD> \n");
        print("<TD></TD><TD>");
	include("../lib/font.html");
	$date_accepted_format = strftime("%d.%m.%Y", $date_accepted);
	print("$date_accepted_format </TD>\n");
        print("</TR> \n");
}

if ($contributors_corporate != "") {
	print("<TR> \n<TD>");
	include("../lib/font.html");
	print("<B>$sonstige_institution</B></TD> \n");
	print("<TD></TD><TD>");
	include("../lib/font.html");
        print("$contributors_corporate </TD>\n");
	print("</TR> \n");
}


/* BD/UH, 15.3.06, externe Bemerkungen in der Jahrebibliographie auch anzeigen */
print("<TR> \n<TD>");
include("../lib/font.html");
print("<B>$t_bemerkung</B></TD> \n");
print("<TD></TD><TD>");
include("../lib/font.html");
print("<BR>$bem_extern </TD>\n");
print("</TR> \n");

print("</TABLE> \n");

}
else {
	#print("IDN $source_opus nicht vorhanden.");
	print("$text7 $source_opus $text8 ");
}


$opus->close($sock);
$design->foot("frontdoor.$php", $la);
?>

