<?
#############################################################
# institut.php - Browsen nach Instituten 
#
# letzte nderung:
# 18.3.2005, Annette Maile, UB Stuttgart
# Auslagerung Design in lib/design.php
# In Abhaengigkeit von $la kann das entsprechende Design eingelesen werden.
#
# 9.6.2005, Birgit Dressler, SULB Saarbrcken
# Einfhrung der Mehrsprachigkeit (Variable $la)
# Textdatei: texte/$la/institut.conf
#
# 10.6.05, Annette Maile, UB Stuttgart
# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# in Abhaengigkeit der IP-Adresse des Nutzers und der 
# Variablen $alle_doks_anzeigen wird die Suche generiert
#
#############################################################

include ("../lib/class.configFile.php");
$conf = new configFile ("../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");

include ("../lib/class.opus_$dbms.$php");
$opus = new opus;

$db = $conf->value("db");
$opustable = $conf->value("opus_table");
$url = $conf->value("url");
$institut_alle_anzeigen = $conf->value("institut_alle_anzeigen");
$alle_doks_anzeigen = $conf->value("alle_doks_anzeigen");

#BD steht nun in der Textdatei
#$titel = $conf->value("titel_institut");;
#$ueberschrift = $conf->value("ueberschrift_institut");

$opustable_inst = $opustable . "_inst";

include ("../lib/stringValidation.php");
$fakultaet = $_REQUEST['fakultaet'];
if (! _is_valid($fakultaet,1,10,"[A-Za-z0-9\-]+")) {die ("Fehler in Parameter fakultaet");}
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# A.Maile 10.2.05: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}

# BDressler Texte aus Textdatei in Programmvariablen fllen 
$texte = new configFile ("../texte/$la/institut.conf");
$titel = $texte->value("titel");
$ueberschrift = $texte->value("ueberschrift");

# Annette Maile, 18.3.05 Design aus lib/design.php einlesen
require ("../lib/design.$php");
$design = new design;
$design->head_titel($titel);
$design->head_ueberschrift($ueberschrift, $la);

$sock = $opus->connect();
if ( $sock < 0 ) {
        echo ("Error: $ERRMSG\n");
}
if ( $opus->select_db($db) < 0 ) {
        echo ("Error: $ERRMSG\n");
}

# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# Es wird die IP des Nutzers ermittelt.
# Wenn alle_doks_anzeigen = 0 gesetzt ist:
# Es wird auf jeden Fall im Bereich 1 = freier Zugriff gesucht
# Falls in Altbestaenden (< Opus 3.0) kein Bereich angegeben ist,
# wird auch nach bereich_id = 0 und null gesucht
# Dann wird in der Tabelle ip_bereich nach den Bereichen gesucht,
# in deren IP-Range die IP liegt.
# Wenn alle_doks_anzeigen = 1 gesetzt ist:
# Es wird in allen Bereichen gesucht

$ip = $_SERVER['REMOTE_ADDR'];
if ($alle_doks_anzeigen == 0) {
        $bereichsgrenze = "(o.bereich_id = 1 or o.bereich_id = 0 or o.bereich_id is NULL";
        $res = $opus->query("SELECT bereich_id, ip_range FROM ip_bereich");
        $num = $opus->num_rows($res);
        if ($num > 0) {
                $i = 0;
                while ($i < $num) {
                        $mrow = $opus->fetch_row($res);
                        $bereich_id = $mrow[0];
                        $ip_range = $mrow[1];
                        if (ereg("^$ip_range", "$ip")) {
                                $bereichsgrenze = $bereichsgrenze . " OR o.bereich_id = $bereich_id";
                        }
                        $i++;
                }
                $opus->free_result($res);
                $bereichsgrenze = $bereichsgrenze . ")";
        }
}
else {
        # Es wird in allen Bereichen gesucht
        $bereichsgrenze = "(o.bereich_id is not null or o.bereich_id is null)";
}
# Ende Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche

$res = $opus->query("SELECT fakultaet FROM faculty_$la WHERE nr='$fakultaet'");
$mrow = $opus->fetch_row($res);
$fak_name=$mrow[0];
$opus->free_result($res);

print("<center><H2>$fak_name</H2></center> \n");
$res = $opus->query ("SELECT nr, name FROM institute_$la where fakultaet = '$fakultaet' ORDER BY nr");
$num = $opus->num_rows($res);
if ($num > 0) {
	print("<UL>");
        $i = 0;
        while ($i < $num) {
                $i++;
                $mrow = $opus->fetch_row($res);
		$nr = $mrow[0];
		$institut = $mrow[1];
		$res2 = $opus->query ("SELECT oi.source_opus from $opustable_inst oi, $opustable o where oi.inst_nr = '$nr' and oi.source_opus = o.source_opus and $bereichsgrenze");
		$anzahl = $opus->num_rows($res2); 
		if ($institut_alle_anzeigen) {
	                print("<LI><A HREF=\"$url/ergebnis.$php?suchart=teil&Lines_Displayed=10&sort=o.date_year+DESC%2C+o.title&suchfeld1=oi.inst_nr&suchwert1=$nr&opt1=AND&suchfeld2=person&suchwert2=&opt2=AND&suchfeld3=date_year&suchwert3=&startindex=0&page=0&dir=2&suche=&la=$la\">$institut</A> <FONT SIZE=2>( $anzahl Dok. )</FONT> \n");
		}
		else {
			if ($anzahl > 0) {
				print("<LI><A HREF=\"$url/ergebnis.$php?suchart=teil&Lines_Displayed=10&sort=o.date_year+DESC%2C+o.title&suchfeld1=oi.inst_nr&suchwert1=$nr&opt1=AND&suchfeld2=person&suchwert2=&opt2=AND&suchfeld3=date_year&suchwert3=&startindex=0&page=0&dir=2&suche=&la=$la\">$institut</A> <FONT SIZE=2>( $anzahl Dok. )</FONT> \n");
			}
		}
		$opus->free_result($res2);	
        }
        $opus->free_result($res);
	print("</UL>");
}

$design->foot("institut.$php", $la);
?>

