<?
/*
* +----------------------------------------------------------------------+
* | PHP Version 4                                                        |
* +----------------------------------------------------------------------+
* | Copyright (c) 2004-2005 Oliver Marahrens                             |
* |                                                                      |
* | record_xmetadiss.php -- Utilities for the OAI Data Provider          |
* |                                                                      |
* | This is free software; you can redistribute it and/or modify it under|
* | the terms of the GNU General Public License as published by the      |
* | Free Software Foundation; either version 2 of the License, or (at    |
* | your option) any later version.                                      |
* | This software is distributed in the hope that it will be useful, but |
* | WITHOUT  ANY WARRANTY; without even the implied warranty of          |
* | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         |
* | GNU General Public License for more details.                         |
* | You should have received a copy of the GNU General Public License    |
* | along with  software; if not, write to the Free Software Foundation, |
* | Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA         |
* |                                                                      |
* +----------------------------------------------------------------------+
* |                                                                      |
* | Written by Oliver Marahrens, TU Hamburg-Harburg, December 2004       |
* |            o.marahrens@tu-harburg.de                                 |
* |                                                                      |
* +----------------------------------------------------------------------+
*/

// Verknpfung mit der OPUS-Configdatei, aus der auch einige Daten genommen werden sollen
include_once ("../../lib/class.configFile.php");
$conf = new configFile ("../../lib/opus.conf");
$ddb_idn = $conf->value("ddb_idn");
$volltext_pfad = $conf->value("volltext_pfad");
$volltext_url = $conf->value("volltext_url");

// this handles XMetaDiss Records 

// please change to the according metadata prefix you use 
$prefix = 'xMetaDiss';

// you do need to change anything in the namespace and schema stuff
// the correct headers should be created automatically

// Opus-Metadaten mssen in XMetaDiss-Metadaten umgewandelt werden

if( $record[date_year] ) {
	$dc_date = $record[date_year];
}

$formatted_year = strftime("%Y", $record[date_creation]);
$epicur_url = getURL( $record[source_opus], $formatted_year );
$epicur_urn = $record[urn];
$epicur_format = "text/html";

$output .= 
'   <metadata>'."\n";

$output .= metadataHeader($prefix);

# Daten aus dem DB-Ergebnis ziehen und fr die Ausgabe umwandeln
$title = $record[title];
# Formale bibliographische Angaben
$output .= "      <dc:title xsi:type=\"ddb:titleISO639-2\" lang=\"".$record[language]."\">".utf8_encode($title)."</dc:title>\n"; # Titel erste Sprache
if ($record[language] != "ger") {
	$title2 = $record[title_de];
	$lang2 = "ger";
}
else {
	$lang2 = "eng";
	$title2 = $record[title_en];
}
if ($title2) {
	$output .= "      <dc:title xsi:type=\"ddb:titleISO639-2\" lang=\"".$lang2."\" ddb:type=\"translated\">".utf8_encode($title2)."</dc:title>\n"; # Titel zweite Sprache
}


# Setzen der Autoren-Variablen
$name = $record[creator_name];
$namearr = split(",", $name);
$email = "";
if (count($namearr) > 1) {
	$vorname = $namearr[1];
	$nachname = $namearr[0];
}
if (strstr($record[verification], "@")) {
	$email = $record[verification];
}

// optional; in OPUS nicht untersttzt: <dcterms:alternative xsi:type=\"ddb:talternativeISO639-2\" lang=\"".."\"></dcterms:alternative> # Untertitel
$output .= "      <dc:creator xsi:type=\"pc:MetaPers\">\n"; # Autor(en)
$output .= "      		<pc:person>\n"; # Einzelner Autor : Weitere Attribute mglich
$output .= "      			<pc:name type=\"nameUsedByThePerson\">\n"; # Autor Name : Weitere Attribute mglich
if (count($namearr) > 1) {
	$output .= "      				<pc:foreName>".utf8_encode($vorname)."</pc:foreName>\n"; # Autor Vorname
	$output .= "      				<pc:surName>".utf8_encode($nachname)."</pc:surName>\n"; # Autor Name
}
else {
	$output .= "      				<pc:personEnteredUnderGivenName>".utf8_encode($name)."</pc:personEnteredUnderGivenName>\n"; # Autor Name, wenn nicht Vor- und Nachname
}
$output .= "      			</pc:name>\n"; # Ende Autor Name
# optional, kann evtl. aus Institut geschlossen werden$output .= "      			<pc:fieldOfStudy>".$test."</pc:fieldOfStudy>\n"; # Autor Studienfach
if ($email) {
	$output .= "      			<pc:email>".utf8_encode($email)."</pc:email>\n"; # Autor Mailadresse
}
$output .= "      		</pc:person>\n"; # Ende Einzelner Autor
$output .= "      </dc:creator>\n"; # Ende Autor(en)

# Sacherschliessung in OPUS ber DDC, SWD und freie Schlagworte
if ($record[sachgruppe_ddc]) {
	$output .= "      <dc:subject xsi:type=\"xMetaDiss:DDC-SG\">".utf8_encode($record[sachgruppe_ddc])."</dc:subject>\n"; # Klassifikation nach DDC der DDB
}
if ($record[subject_swd]) {
	$output .= "      <dc:subject xsi:type=\"xMetaDiss:SWD\">".utf8_encode(htmlspecialchars($record[subject_swd]))."</dc:subject>\n"; # Schlagworte aus Schlagwort-Normdatei
}
if ($record[subject_uncontrolled_german] || $record[subject_uncontrolled_english]) {
	$output .= "      <dc:subject xsi:type=\"xMetaDiss:noScheme\">".utf8_encode($record[subject_uncontrolled_german]." ".$record[subject_uncontrolled_english])."</dc:subject>\n"; # freie Schlagworte deutsch und Englisch
}

# Weitere Klassifikationssysteme und Thesauri -- vorlufig nicht implementiert
# Deutsche Verbundklassifikationen
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:BK\">".$test."</dc:subject>\n"; # Klassifikation nach GBV-BK
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:RVK\">".$test."</dc:subject>\n"; # Klassifikation nach Regensburger Verbundklassifikation

# Internationale Klassifikationssysteme
#$output .= "      <dc:subject xsi:type=\"dcterms:DDC\">".$test."</dc:subject>\n"; # Klassifikation nach Dewey Decimal Classification
#$output .= "      <dc:subject xsi:type=\"dcterms:LCC\">".$test."</dc:subject>\n"; # Klassifikation nach LoC-Classification
#$output .= "      <dc:subject xsi:type=\"dcterms:UDC\">".$test."</dc:subject>\n"; # Klassifikation nach Universal Decimal Classification
#$output .= "      <dc:subject xsi:type=\"dcterms:NLM\">".$test."</dc:subject>\n"; # Klassifikation nach NLM (Amerikanische Medizin-Bibl.)
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:UMLS\">".$test."</dc:subject>\n"; # Klassifikation nach Unified Medical Language System
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:ZDM\">".$test."</dc:subject>\n"; # Klassifikation nach Didaktik der Mathematik

# Internationale Schlagwortdateien
#$output .= "      <dc:subject xsi:type=\"dcterms:LCSH\">".$test."</dc:subject>\n"; # Schlagworte aus LoC-Schlagwortdatei
#$output .= "      <dc:subject xsi:type=\"dcterms:MeSH\">".$test."</dc:subject>\n"; # Schlagworte aus Medizinischer Schlagwortdatei

# Internationale Thesauri
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:PACS2003\">".$test."</dc:subject>\n"; # Klassifikation nach PACS (Physik und Astronomie)
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:MCS1991\">".$test."</dc:subject>\n"; # Klassifikation nach MCS (Mathematik)
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:MCS2000\">".$test."</dc:subject>\n"; # Klassifikation nach MCS 2000 (Mathematik neue Version)
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:CCS1998\">".$test."</dc:subject>\n"; # Klassifikation nach CCS (ACM Computer)
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:BK\">".$test."</dc:subject>\n"; # Klassifikation nach GBV-BK

if ($record[description]) {
	// Sonderzeichen raus-exen
	$rec = strip_tags($record[description]);
	if (function_exists("html_entity_decode")) {
		$rec = html_entity_decode($rec);
	}
	else {
		// Umlaute manuell decodieren
		$rec = ereg_replace("&ouml;", ";", $rec);
		$rec = ereg_replace("&ouml;", ";", $rec);
		$rec = ereg_replace("&uuml;", ";", $rec);
		$rec = ereg_replace("&Uuml;", ";", $rec);
		$rec = ereg_replace("&auml;", ";", $rec);
		$rec = ereg_replace("&Auml;", ";", $rec);
		$rec = ereg_replace("&szlig;", ";", $rec);
	}
	$rec = ereg_replace("\&", "&amp;", $rec);
	$rec = ereg_replace("\>", "&gt;", $rec);
	$rec = ereg_replace("\<", "&lt;", $rec);
	$rec = ereg_replace("\'", "&apos;", $rec);
	$rec = ereg_replace("\"", "&quot;", $rec);
	$rec = utf8_encode($rec);
	$output .= "      <dcterms:abstract xsi:type=\"ddb:contentISO639-2\" lang=\"".utf8_encode($record[description_lang])."\" ddb:type=\"ddb:noScheme\">".$rec."</dcterms:abstract>\n"; # Abstract 1
}
if ($record[description2]) {
	$rec = strip_tags($record[description2]);
	if (function_exists("html_entity_decode")) {
		$rec = html_entity_decode($rec);
	}
	else {
		// Umlaute manuell decodieren
		$rec = ereg_replace("&ouml;", ";", $rec);
		$rec = ereg_replace("&ouml;", ";", $rec);
		$rec = ereg_replace("&uuml;", ";", $rec);
		$rec = ereg_replace("&Uuml;", ";", $rec);
		$rec = ereg_replace("&auml;", ";", $rec);
		$rec = ereg_replace("&Auml;", ";", $rec);
		$rec = ereg_replace("&szlig;", ";", $rec);
	}
	$rec = ereg_replace("\&", "&amp;", $rec);
	$rec = ereg_replace("\>", "&gt;", $rec);
	$rec = ereg_replace("\<", "&lt;", $rec);
	$rec = ereg_replace("\'", "&apos;", $rec);
	$rec = ereg_replace("\"", "&quot;", $rec);
	$rec = utf8_encode($rec);
	$output .= "      <dcterms:abstract xsi:type=\"ddb:contentISO639-2\" lang=\"".utf8_encode($record[description2_lang])."\" ddb:type=\"ddb:noScheme\">".$rec."</dcterms:abstract>\n"; # Abstract 2
}

# Weitere bibliographische Angaben: Publizierende Organisation
$output .= "      <dc:publisher xsi:type=\"cc:Publisher\">\n"; # Verbreitende Stelle(n)
$output .= "      	<cc:universityOrInstitution>\n"; # Verbreitende Stelle: Universitt
$output .= "      		<cc:name>".utf8_encode($instName)."</cc:name>\n"; # Name der verbreitenden Stelle
$output .= "      		<cc:place>".utf8_encode($univOrt)."</cc:place>\n"; # Ort der verbreitenden Stelle
$output .= "      	</cc:universityOrInstitution>\n"; # Verbreitende Stelle: Universitt
$output .= "      	<cc:address cc:Scheme=\"DIN5008\">".utf8_encode($univAdresse)."</cc:address>\n"; # Adresse der verbreitenden Stelle
$output .= "      </dc:publisher>\n"; # Ende Verbreitende Stelle(n)

# Setzen der Doktorvater-Variablen
$dname = $record[advisor];
// Titel rausfischen
$dvorname = "";
$dnachname = "";

$drarr = split("\(", $dname);
$dnamearr = split(",", $drarr[0]);
if (count($dnamearr) > 1) {
	$dvorname = $dnamearr[1];
	$dnachname = $dnamearr[0];
}
$drtitel = ereg_replace("\)", "", $drarr[1]);
// Wenn die Titelangaben leer sind mal nachgucken, ob Punkte im Namen auftauchen (evtl. Titel falsch angesetzt)
if ($dvorname || $dnachname) {
    $titelcountvn = 0;
    $titelcountnn = 0;
    $titelcountvn += substr_count($dvorname, ".");
    $titelcountnn += substr_count($dnachname, ".");
    if ($titelcountvn > 0) {
        $titelarr = split(" ", $dvorname);
        foreach ($titelarr as $item) {
	    if (ereg("\.$", $item)) {
    		if ($drtitel) $drtitel .= " ".$item;
    		else $drtitel .= $item;
    		$dvorname = ereg_replace($item, "", $dvorname);
    	    }
	}
	$dvorname = ereg_replace("\ $", "", $dvorname);
    }
    if ($titelcountnn > 0) {
	$titelarr = split(" ", $dnachname);
        foreach ($titelarr as $item) {
            if (ereg("\.$", $item)) {
                if ($drtitel) $drtitel .= " ".$item;
                else $drtitel .= $item;
                $dnachname = ereg_replace($item, "", $dnachname);
            }
        }
        $dnachname = ereg_replace("\ $", "", $dnachname);
    }
}
else {
    $titelarr = split(" ", $drarr[0]);
    foreach ($titelarr as $item) {
        if (ereg("\.$", $item)) {
            if ($drtitel) $drtitel .= " ".$item;
            else $drtitel .= $item;
            $drarr[0] = ereg_replace($item, "", $drarr[0]);
        }
    }
    $drarr[0] = ereg_replace("\ $", "", $drarr[0]);
}

# Bei Dissertationen (also alles, was mit XMetaDiss bermittelt werden soll?)
# Dissertations-Angaben
$output .= "      <dc:contributor xsi:type=\"pc:Contributor\" thesis:role=\"advisor\">\n"; # Doktorvater
$output .= "       <pc:person>\n"; # Wurzelelement Personenangaben
$output .= "      	<pc:name type=\"nameUsedByThePerson\">\n"; # Name des Doktorvaters
if (count($dnamearr) > 1) {
	$output .= "      		<pc:foreName>".utf8_encode(ereg_replace("\ $", "", ereg_replace("^\ ", "", $dvorname)))."</pc:foreName>\n"; # Doktorvater Vorname
	$output .= "      		<pc:surName>".utf8_encode(ereg_replace("\ $", "", ereg_replace("^\ ", "", $dnachname)))."</pc:surName>\n"; # Doktorvater Name
}
else {
	$output .= "      		<pc:personEnteredUnderGivenName>".utf8_encode(ereg_replace("\ $", "", ereg_replace("^\ ", "", $drarr[0])))."</pc:personEnteredUnderGivenName>\n"; # Doktorvater Name, wenn nicht Vor- und Nachname
}
$output .= "      	</pc:name>\n"; # Ende Doktorvater Name
$output .= "      	<pc:academicTitle>".utf8_encode($drtitel)."</pc:academicTitle>\n"; # Doktorvater Titel
$output .= "       </pc:person>\n"; # Ende Wurzelelement Personenangabe
$output .= "      </dc:contributor>\n"; # Ende Doktorvater

$output .= "      <dcterms:dateAccepted xsi:type=\"dcterms:W3CDTF\">".date("Y-m-d", $record[date_accepted])."</dcterms:dateAccepted>\n"; # Promotionsdatum Y-M-D

$output .= "      <dc:type xsi:type=\"dcterms:DCMIType\">ElectronicThesisandDissertation</dc:type>\n"; # Dokumenttyp statisch ElectronicThesisandDissertation
/* Andere mgliche Werte (derzeit nicht implementiert):
Collection
Dataset
Image
InteractiveResource
Service
Software
Sound
Text
PhysicalObject
*/

$output .= "      <dc:identifier xsi:type=\"urn:nbn\">".utf8_encode($record[urn])."</dc:identifier>\n"; # URN-Angabe

# Dateiinfos raussuchen
$p = $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus];
@$dh = opendir($p);
$anz = 0;
while (@$file = readdir($dh)) {
	if ($file == "original") {
		$p2 = $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/original";
		$dh2 = opendir($p2);
		$oind = 0;
		while ($file2 = readdir($dh2)) {
			if (is_file($p2."/".$file2) && $file2 != "." && $file2 != "..") {
				$farr = split("\.", $file2);
				$ind = count($farr);
				$f[$anz] = $farr[$ind-1];
				$orig[$oind] = $file2;
				$oind++;
				$anz++;
			}
		}
	}
	else if (is_dir($p."/".$file) && $file != "." && $file != "..") {
		$f[$anz] = $file;
		$anz++;
	}
}
@closedir($dh);
//$output .= "      <dcterms:extend>".$test."</dcterms:extend>\n"; # Dateigre des Dokuments - Kann auch rausgelassen werden, da die Gre automatisch durch DDB bei Eingang des Dokuments ermittelt wird
for ($x = 0; $f[$x]; $x++) { 
	$output .= "      <dcterms:medium xsi:type=\"dcterms:IMT\">".utf8_encode(conv_type($f[$x]))."</dcterms:medium>\n"; # Dateityp des Dokuments nach MIME
} 

//dcterms:source ist fr ein ursprngliches Dokument, das z.B. als Vorlage fr das hier beschriebene Dokument diente - wird in Opus nicht erfasst...
#$output .= "      <dcterms:source xsi:type=\"dcterms:URI\">".$volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus]."/</dcterms:source>\n"; # URL auf OPUS
#for ($t = 0; $orig[$t]; $t++) {
	#$output .= "      <dcterms:source xsi:type=\"dcterms:URI\">".$volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus]."/original/".$orig[$t]."</dcterms:source>\n"; # URL zum Originalformat der Dissertation
#}

$output .= "      <dc:language xsi:type=\"dcterms:ISO639-2\" lang=\"".utf8_encode($record[language])."\"/>\n"; # Sprache der Dissertation

$output .= "      <dc:rights xsi:type=\"ddb:noScheme\">".utf8_encode($dc_rights)."</dc:rights>\n"; # Copyright-Regelungen

if ($zug) {
# Eigene OPUS-Erweiterung Zugriffsrechte der TUHH, in der offiziellen OPUS-Distribution nicht enthalten
# Passwortschutz: Elementinhalt = Passwortschutz
# IP- oder Namensschutz: Elementinhalt = Fachbereichsname
$zcheck = $db->query("SELECT * FROM einzelfreigabe WHERE source_opus = ".$record[source_opus]);   
if (DB::isError($zcheck)) {
	die ($zcheck->getMessage());
}
$znum = $zcheck->numRows();
$zrecord = $zcheck->fetchRow(DB_FETCHMODE_ASSOC);

if ($znum > 0) {
	if ($zrecord[htpasswd]) {
		$output .= "      <dcterms:accessRights xsi:type=\"ddb:access\" ddb:type=\"ddb:noScheme\" ddb:kind=\"domain\">Passwortschutz</dcterms:accessRights>\n"; # Zugriffsberechtigungen
	}
	else if ($zrecord[dom] || $zrecord[ip]) {
		$output .= "      <dcterms:accessRights xsi:type=\"ddb:access\" ddb:type=\"ddb:noScheme\" ddb:kind=\"domain\">Nur Zugriff von $zrecord[dom] $zrecord[ip]</dcterms:accessRights>\n"; # Zugriffsberechtigungen
	}
}
else {
	$output .= "      <dcterms:accessRights xsi:type=\"ddb:access\" ddb:type=\"ddb:noScheme\" ddb:kind=\"free\"/>\n"; # Zugriffsberechtigungen
}
}

# Nhere Beschreibung der konkreten Disseratation
$output .= "      <thesis:degree>\n"; #  Infos zum akademischen Grad und der Vergabeinstitution

# Bislang nur Doktorarbeiten und Habilitationen
if ($record[type] == 8) $level = "thesis.doctoral";
if ($record[type] == 24) $level = "thesis.habilitation";
$output .= "      	<thesis:level>".$level."</thesis:level>\n"; #  Infos zum akademischen Grad und der Vergabeinstitution
/* Andere Werte fr thesis:level:
bachelor
master
post-doctoral
other
*/
$tcheck = $db->query("SELECT * FROM faculty WHERE nr = ".$record[publisher_faculty]);   
if (DB::isError($tcheck)) {
	die ($tcheck->getMessage());
}
$tnum = $tcheck->numRows();
$trecord = $tcheck->fetchRow(DB_FETCHMODE_ASSOC);
$output .= "      	<thesis:grantor xsi:type=\"cc:Corporate\">\n"; #  Titelvergebende Stelle
$output .= "      		<cc:universityOrInstitution>\n"; #  Uni
$output .= "      			<cc:name>".utf8_encode($univName)."</cc:name>\n"; # Name der titelvergebenden Stelle
$output .= "      			<cc:place>".utf8_encode($univOrt)."</cc:place>\n"; # Ort der titelvergebenden Stelle
if ($tnum > 0) {
$output .= " 	     		<cc:department>\n"; #  Uni
$output .= "    	  			<cc:name>".utf8_encode($trecord[fakultaet])."</cc:name>\n"; # Name der titelvergebenden Stelle (Arbeitsbereich)
$output .= "      			</cc:department>\n"; #  Ende Uni
}
$output .= "      		</cc:universityOrInstitution>\n"; #  Ende Uni
$output .= "      	</thesis:grantor>\n"; #  Ende Titelvergebende Stelle
$output .= "      </thesis:degree>\n"; #  Ende Infos zum akademischen Grad und der Vergabeinstitution

# Dateiinfos raussuchen
$p = $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus];
@$dh = opendir($p);
$anz = 0;
$anz_orig = 0;
$datei = array();
$komppfad = array();
$originaldatei = array();
$komporigpfad = array();
$dateityp = array();
$komporigurl = array();
$noarchiv = 0;
while (@$file = readdir($dh)) {
	if (is_dir($p."/".$file) && $file != "." && $file != ".." && $file != "original") {
		$format = $file;
		$p2 = $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/".$file;
		$dh2 = opendir($p2);
		while ($file2 = readdir($dh2)) {
			if (is_file($p2."/".$file2) && $file2 != "." && $file2 != "..") {
				$datei[$anz] = $file2;
				$komppfad[$anz] = $p2."/".$file2;
				$anz++;
			}
		}
		closedir($dh2);
	}
	else if ($file == "original") {
		$origpfad = $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/".$file;
		$dh2 = opendir($origpfad);
		while ($file2 = readdir($dh2)) {
			if (is_file($origpfad."/".$file2) && $file2 != "." && $file2 != "..") {
				$filetype = split("\.", $file2);
				$dateityp = strtolower($filetype[count($filetype)-1]);
				if ($dateityp == "xml" || $dateityp == "sgm" || $dateityp == "sgml" || $dateityp == "htm" || $dateityp == "html" || $dateityp == "tex" || $dateityp == "txt") {
					$originaldatei[$anz_orig] = $file2;
					$komporigpfad[$anz_orig] = $origpfad."/".$file2;
					$dateityp[$anz_orig] = strtolower($filetype[count($filetype)-1]);
					$anz_orig++;
					$anz++;
				}
				else {
					$komporigurl[$noarchiv] = $volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus]."/original/".$file2;
					$noarchiv++;
				}
			}
		}
		closedir($dh2);
	}
}
@closedir($dh);
$praes_arch = false;
#echo $anz_orig;

# Vorhandene Archivdateien lschen
@unlink ($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/container.tgz");
@unlink ($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/praesentation.tgz");
@unlink ($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/original.tgz");

// Wenn vorhanden und im richtigen Format werden die Originaldateien gepackt
// anerkannte Formate fr das Quellformat sind XML, SGML, HTML, TEX, TXT u.a. Klartextformate
if ($anz_orig > 0) {
	/*
	if (file_exists($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/container.tgz")) {
		rename($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/container.tgz", $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/praesentation.tgz");
	}
	else {*/
	# OM 29.04.05: container.tgz wird auf jeden Fall gelscht (s.o.) und anschliessend neu gebaut
	
	$praestar = new Archive_Tar($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/praesentation.tgz", "gz");
	$praestar->addModify($komppfad, ".", $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/".$format);
	#}

	$praes_arch = true;

	$origtar = new Archive_Tar($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/original.tgz", "gz");
	for ($x = 0; $x <= $anz_orig; $x++) {
		$origtar->addString($originaldatei[$x], $komporigpfad[$x]);
	}

	$gesamttar = new Archive_Tar($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/container.tgz", "gz");
	$gesamttar->addModify(array($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/original.tgz",$volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/praesentation.tgz"), ".",  $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]);
	// Die beiden neuen Dateien mssen eingetragen werden!
	$anz = $anz+2;
}

# Technische und administrative Daten
$output .= "      <ddb:contact ddb:contactID=\"".$ddb_idn."\"/>\n"; #  Publikations-Organ ID bei der DDB
$output .= "      <ddb:fileNumber>".$anz."</ddb:fileNumber>\n"; #  Anzahl Dateien dieses Dokumentes
for ($i = 0; $datei[$i]; $i++) {
	$output .= "      <ddb:fileProperties ddb:fileName=\"".utf8_encode($datei[$i])."\" ddb:fileID=\"file".$record[source_opus]."-".$i."\" ddb:fileSize=\"".filesize($komppfad[$i])."\" ddb:fileDirectory=\"/\">aus: Praesentationsformat</ddb:fileProperties>\n"; #  Nhere Beschreibung jeder einzelnen Datei
}
for ($i = 0; $originaldatei[$i]; $i++) {
	$output .= "      <ddb:fileProperties ddb:fileName=\"".utf8_encode($originaldatei[$i])."\" ddb:fileID=\"file".$record[source_opus]."-orig".$i."\" ddb:fileSize=\"".filesize($komporigpfad[$i])."\" ddb:fileDirectory=\"/\">aus: Originalformat</ddb:fileProperties>\n"; #  Nhere Beschreibung jeder einzelnen Datei
}

//Hier die tgz-Dateien hin!
if ($praes_arch) {
	$output .= "      <ddb:fileProperties ddb:fileName=\"praesentation.tgz\" ddb:fileID=\"praesentationsformat".$record[source_opus]."\" ddb:fileSize=\"".filesize($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/praesentation.tgz")."\" ddb:fileDirectory=\"/\">Archiv Praesentationsformat</ddb:fileProperties>\n"; #  FileProperties fr das Prsentationsformat
	$output .= "      <ddb:fileProperties ddb:fileName=\"original.tgz\" ddb:fileID=\"originalformat".$record[source_opus]."\" ddb:fileSize=\"".filesize($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/original.tgz")."\" ddb:fileDirectory=\"/\">Archiv Quellformat</ddb:fileProperties>\n"; #  FileProperties fr das Quellformat
	$output .= "      <ddb:transfer ddb:type=\"dcterms:URI\">".$volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus]."/container.tgz</ddb:transfer>\n"; #  Soll verwendet werden, wenn mehrere Dateien bermittelt werden sollen - dabei ist auch notwendig, dass ein einziges Archiv der zu bermittelnden Dateien bereitgestellt wird, das dann unter dieser Adresse erreichbar ist
}

if ($anz > 1 && !$praes_arch) {
	// Baue ein Archiv aus den Einzeldateien zusammen, falls noch keins vorhanden ist
	#if (!file_exists($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/container.tgz")) {
		$tar = new Archive_Tar($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/container.tgz", "gz");
		#$tar->create(); # Kann entfallen bei addModify (der legts automatisch an)
		// $komppfad enthaelt nur die Prsentationsdateien
		#for ($z = 0; $komppfad[$z]; $z++) {
		$tar->addModify($komppfad, ".", $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/".$format);
		#}
	#}
	$output .= "      <ddb:transfer ddb:type=\"dcterms:URI\">".utf8_encode($volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus])."/container.tgz</ddb:transfer>\n"; #  Soll verwendet werden, wenn mehrere Dateien bermittelt werden sollen - dabei ist auch notwendig, dass ein einziges Archiv der zu bermittelnden Dateien bereitgestellt wird, das dann unter dieser Adresse erreichbar ist
}

// Nicht archivierungswrdige Originaldateien bleiben hier, werden aber verlinkt
// OM 29.04.2005: nicht archivierungswrdige Originaldatateien werden nicht verlinkt!
/*for ($n = 0; $n < $noarchiv; $n++) {
	$output .= "      <ddb:identifier ddb:type=\"URL\">".utf8_encode($komporigurl[$n])."</ddb:identifier>\n"; #  Haupt-URL
}
*/
if ($anz > 1) {
	$output .= "      <ddb:identifier ddb:type=\"URL\">".utf8_encode($volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus])."/</ddb:identifier>\n"; #  Haupt-URL
}
else {
	$output .= "      <ddb:identifier ddb:type=\"URL\">".utf8_encode($volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus]."/".$f[0]."/".$datei[0])."</ddb:identifier>\n"; #  Haupt-URL
}
$output .= "      <ddb:rights ddb:kind=\"free\"/>\n"; # keine Zugriffsbeschrnkung


// Here, no changes need to be done
$output .=           
'     </'.$prefix;
if (isset($METADATAFORMATS[$prefix]['record_prefix'])) {
	$output .= ':'.$METADATAFORMATS[$prefix]['record_prefix'];
}
$output .= ">\n";
$output .= 
'   </metadata>'."\n";

//if ($encoding == "UTF-8") $output = utf8_encode($output);
?>
