<?
/*
* +----------------------------------------------------------------------+
* | PHP Version 4                                                        |
* +----------------------------------------------------------------------+
* | Copyright (c) 2002 Heinrich Stamerjohanns                            |
* |                                                                      |
* | getrecord.php -- Utilities for the OAI Data Provider                 |
* |                                                                      |
* | This is free software; you can redistribute it and/or modify it under|
* | the terms of the GNU General Public License as published by the      |
* | Free Software Foundation; either version 2 of the License, or (at    |
* | your option) any later version.                                      |
* | This software is distributed in the hope that it will be useful, but |
* | WITHOUT  ANY WARRANTY; without even the implied warranty of          |
* | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         |
* | GNU General Public License for more details.                         |
* | You should have received a copy of the GNU General Public License    |
* | along with  software; if not, write to the Free Software Foundation, |
* | Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA         |
* |                                                                      |
* +----------------------------------------------------------------------+
* | Derived from work by U. Mller, HUB Berlin                           |
* |                                                                      |
* | Written by Heinrich Stamerjohanns, May 2002                          |
* |            stamer@uni-oldenburg.de                                   |
* +----------------------------------------------------------------------+
*/
//
// $Id: getrecord.php,v 1.02 2003/04/08 14:22:07 stamer Exp $
//

// parse and check arguments

foreach($args as $key => $val) {

	switch ($key) { 
		case 'identifier':
			$identifier = $val; 
			break;

		case  'metadataPrefix':
			if (is_array($METADATAFORMATS[$val])
					&& isset($METADATAFORMATS[$val]['myhandler'])) {
				$metadataPrefix = $val;
				$inc_record  = $METADATAFORMATS[$val]['myhandler'];
			} else {
				$errors .= oai_error('cannotDisseminateFormat', $key, $val);
			}
			break;

		default:
			$errors .= oai_error('badArgument', $key, $val);
	}
}

if (!isset($args['identifier'])) {
	$errors .= oai_error('missingArgument', 'identifier');
}
if (!isset($args['metadataPrefix'])) {
	$errors .= oai_error('missingArgument', 'metadataPrefix');
} 

// remove the OAI part to get the identifier
$id = str_replace($oaiprefix, '', $identifier); 
if ($id == '') {
	$errors .= oai_error('idDoesNotExist', '', $identifier); 
} elseif( preg_match( "/\D/", $id) == 1 ){
	$errors .= oai_error( 'idDoesNotExist', '', $identifier);
}
if (!isset($errors)) {

	// Zuerst wird die Information aus opus geholt:
	
	if( $metadataPrefix == 'xMetaDiss' ) {
		$query = xmetadissQuery($id);
	}
	else {
		$query = selectallQuery($id);
	}
	
	$res = $db->query($query);

	if (DB::isError($res)) {
		echo "Query: $query<br />\n";
		die ($res->getMessage());
	}
	if (!$res->numRows()) {
		$errors .= oai_error('idDoesNotExist', '', $identifier); 
	}
	
	// Nun kommt die Autoren-Abfrage
	
	$query_author = selectAuthor($id); 
	$res_author = $db->query($query_author);
	if (DB::isError($res_author)) {
		echo "Query: $query_author<br />\n";
		die ($res_author->getMessage());
	}
	$num_rows_author = $res_author->numRows();
	if (DB::isError($num_rows_author)) {
		die ($num_rows_author->getMessage());
		$errors .= oai_error('badArgument', '', '');
	}

	// Nun kommt die Fakultaet/Institute-Abfrage
	
	$query_facinst = facinstQuery($id); 

	$res_facinst = $db->query($query_facinst);
	if (DB::isError($res_facinst)) {
		echo "Query: $query_facinst<br />\n";
		die ($res_facinst->getMessage());
	}
	$num_rows_facinst = $res_facinst->numRows();
	if (DB::isError($num_rows_facinst)) {
		die ($num_rows_facinst->getMessage());
	}
}

// break and clean up on error

if (isset($errors)) {
	oai_exit();
}

$output .= "  <GetRecord>\n";

$num_rows = $res->numRows();
if (DB::isError($num_rows)) {
	die ($num_rows->getMessage());
}
if ($num_rows) {
	$record = $res->fetchRow();
	if (DB::isError($record)) {
		die ($record->getMessage());
	}

	if( $metadataPrefix == 'epicur' ) {
	
		if( !$record[urn] ) {
		
			$errors .= oai_error('cannotDisseminateFormat', $key, $metadataPrefix);
			oai_exit();
		}
		
	}
	
	$identifier = $oaiprefix.$record[$SQL['identifier']];;
	
	// Es gibt in Opus ein date_creation und ein date_modified. Hier
	// wird das sptere gewhlt
	
	if( $record[date_modified] ) { $datumstempel = $record[date_modified]; }
	else { $datumstempel = $record[date_creation]; }
	
	$datestamp = formatDatestamp($datumstempel); 

	if (isset($record[$SQL['deleted']]) && ($record[$SQL['deleted']] == 'true') && 
		($deletedRecord == 'transient' || $deletedRecord == 'persistent')) {
		$status_deleted = TRUE;
	} else {
		$status_deleted = FALSE;
	}

	$sachgruppe_set = "ddc:".$record['sachgruppe_ddc'];
	$type_set = "pub-type:".$record['type'];


// print Header
	$output .= 
'  <record>'."\n";
	$output .= 
'  <header';
	if ($status_deleted) {
		$output .= ' status="deleted"';
	}  
	$output .='>'."\n";

	// use xmlrecord since we include stuff from database;
	$output .= xmlrecord($identifier, 'identifier', 3);
	$output .= xmlformat($datestamp, 'datestamp', 3);
	$output .= xmlrecord($sachgruppe_set, 'setSpec', 3);
	$output .= xmlrecord($type_set, 'setSpec', 3);
	$output .= 
'   </header>'."\n"; 

// return the metadata record itself
	if (!$status_deleted) 
		include('oai2/'.$inc_record); 

	$output .= 
'  </record>'."\n"; 
} 
else {
	// we should never get here
	oai_error('idDoesNotExist');
}

// End GetRecord
$output .= 
' </GetRecord>'."\n"; 
?>
