<?
/*
* +----------------------------------------------------------------------+
* | PHP Version 4                                                        |
* +----------------------------------------------------------------------+
* | Copyright (c) 2002 Heinrich Stamerjohanns                            |
* |                                                                      |
* | listrecords.php -- Utilities for the OAI Data Provider               |
* |                                                                      |
* | This is free software; you can redistribute it and/or modify it under|
* | the terms of the GNU General Public License as published by the      |
* | Free Software Foundation; either version 2 of the License, or (at    |
* | your option) any later version.                                      |
* | This software is distributed in the hope that it will be useful, but |
* | WITHOUT  ANY WARRANTY; without even the implied warranty of          |
* | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         |
* | GNU General Public License for more details.                         |
* | You should have received a copy of the GNU General Public License    |
* | along with  software; if not, write to the Free Software Foundation, |
* | Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA         |
* |                                                                      |
* +----------------------------------------------------------------------+
* | Derived from work by U. Mller, HUB Berlin                           |
* |                                                                      |
* | Written by Heinrich Stamerjohanns, May 2002                          |
* |            stamer@uni-oldenburg.de                                   |
* +----------------------------------------------------------------------+
*/
//
// $Id: listrecords.php,v 1.02 2003/04/08 14:24:21 stamer Exp $
//
//
// parse and check arguments
foreach($args as $key => $val) {

	switch ($key) { 
		case 'from':
			$from = $val;
			break;

		case 'until':
			$until = $val; 
			break;

		case 'metadataPrefix':
			if (is_array($METADATAFORMATS[$val])
					&& isset($METADATAFORMATS[$val]['myhandler'])) {
				$metadataPrefix = $val;
				$inc_record  = $METADATAFORMATS[$val]['myhandler'];
			} else {
				$errors .= oai_error('cannotDisseminateFormat', $key, $val);
			}
			break;

		case 'set':
			$set = $val;
			break;      

		case 'resumptionToken':
			$resumptionToken = $val;
			break;

		default:
			$errors .= oai_error('badArgument', $key, $val);
	}
}


// Resume previous session?
if (isset($args['resumptionToken'])) { 		
	if (isset($args['metadataPrefix']) || isset($args['$set_from']) 
			|| isset($args['set_until']) || isset($args['set'])) {
		$errors .= oai_error('exclusiveArgument');
//		echo "<p>1 error ist $errors</p>";

	} else {
		if (is_file("tokens/re-$resumptionToken")) {
			$fp = fopen("tokens/re-$resumptionToken", 'r');
			$filetext = fgets($fp, 255);
			$textparts = explode('#', $filetext); 
			$deliveredrecords = (int)$textparts[0]; 
			$extquery = $textparts[1];
			$metadataPrefix = $textparts[2];
			if (is_array($METADATAFORMATS[$metadataPrefix])
					&& isset($METADATAFORMATS[$metadataPrefix]['myhandler'])) {
				$inc_record  = $METADATAFORMATS[$metadataPrefix]['myhandler'];
			} else {
				$errors .= oai_error('cannotDisseminateFormat', $key, $val);
			}
			fclose($fp); 
			//unlink ("tokens/re-$resumptionToken");
		} else { 
			$errors .= oai_error('badResumptionToken', '', $resumptionToken); 
		}
	}
}

// no, we start a new session
else {
	$deliveredrecords = 0; 
	if (!$args['metadataPrefix']) {
		$errors .= oai_error('missingArgument', 'metadataPrefix');
	}

	$extquery = '';

	if (isset($args['from'])) {
		if (!checkDateFormat($from)) {
			$errors .= oai_error('badGranularity', 'from', $from); 
		}
		$from_creation .= fromQuery($from);
		$from_modified .= from_modifiedQuery($from);
	}

	if (isset($args['until'])) {
		if (!checkDateFormat($until)) {
			$errors .= oai_error('badGranularity', 'until', $until);
		}
		$until_creation .= untilQuery($until);
		$until_modified .= until_modifiedQuery($until);
	}
	
	if( isset($args['from']) and isset( $args['until'])) {
		$extquery = " and ((".$from_creation." and ".$until_creation." and ".$SQL['date_modified']." is null) or (".$from_modified." and ".$until_modified."))";
	} elseif( isset( $args['from'] )) {
		$extquery = " and ((".$from_creation." and ".$SQL['date_modified']." is null) or (".$from_modified."))";
	} elseif( isset( $args['until'] )) {
		$extquery = " and ((".$until_creation." and ".$SQL['date_modified']." is null) or (".$until_modified."))";
	}
	
    if (isset($args['set'])) {
    
	    if (is_array($SETS)) {
	    	$verb = "listrecords";
		    $extquery .= setQuery($set, $verb);
		    
	    } else {
			$errors .= oai_error('noSetHierarchy'); 
			oai_exit();
		}
	}
	
	if( $metadataPrefix == 'epicur' ) {
	
		$extquery .= " and urn LIKE 'urn%'";
		
	}

	// bei Print-on-Demand ueber Prorprint nur Dokumente ausgeben,
	// bei denen pod erlaubt ist.
	if( $metadataPrefix == 'oai_pp' ) {
		$extquery .= " AND l.pod_allowed = 1";
	}

	if( $metadataPrefix == 'xMetaDiss' ) {
	// in XMetaDiss nur Dissertationen und Habilitationen
		$extquery .= " AND (o.type = 8 OR o.type = 24)";
		
	}

}

if (!isset($errors)) {

	// Zuerst wird die Information aus opus geholt:
	
	if( $metadataPrefix == 'xMetaDiss' ) {
		$query = xmetadissQuery('') . $extquery;
	}
	else {
		if ( $metadataPrefix == 'oai_pp' ) {
			$query = oaippQuery('') . $extquery;
		}
		else {
			$query = selectallQuery('') . $extquery;
		}
	}
	
	#echo "<p>Query ist : $query</p>";


	$res = $db->query($query);   
	if (DB::isError($res)) {
		die ($res->getMessage());
	}
	
	$num_rows = $res->numRows();
	if (DB::isError($num_rows)) {
		die ($num_rows->getMessage());
	}

	if (!$num_rows) {
		$errors .= oai_error('noRecordsMatch'); 
	}
}

// break and clean up on error

#echo "<p>error ist $errors</p>";


if (isset($errors)) {
	oai_exit();
}

$output .= " <ListRecords>\n";

// Will we need a ResumptionToken?
if ($num_rows - $deliveredrecords > $MAXRECORDS) {
	$token = get_token(); 
	$fp = fopen ("tokens/re-$token", 'w'); 
	$thendeliveredrecords = (int)$deliveredrecords + $MAXRECORDS;  
	fputs($fp, "$thendeliveredrecords#"); 
	fputs($fp, "$extquery#"); 
	fputs($fp, "$metadataPrefix#"); 
	fclose($fp); 
	$restoken = 
'  <resumptionToken expirationDate="'.$expirationdatetime.'"
     completeListSize="'.$num_rows.'"
     cursor="'.$deliveredrecords.'">'.$token."</resumptionToken>\n"; 
}
// Last delivery, return empty ResumptionToken
elseif (isset($args['resumptionToken'])) {
	$restoken =
'  <resumptionToken completeListSize="'.$num_rows.'"
     cursor="'.$deliveredrecords.'"></resumptionToken>'."\n";
}

$maxrec = min($num_rows - $deliveredrecords, $MAXRECORDS);

// return records
$countrec  = 0;
while ($countrec++ < $maxrec) {
	// the second condition is due to a bug in PEAR
	if ($countrec == 1 && $deliveredrecords) {
		$record = $res->fetchRow(DB_FETCHMODE_ASSOC, $deliveredrecords); 
	} else {
		$record = $res->fetchRow(DB_FETCHMODE_ASSOC);
	}
	if (DB::isError($record)) {
		die ($result->getMessage());
    }

	// Nun kommt die Autoren-Abfrage
	
	$dc_creator = "";
	
	$query_author = selectAuthor($record[source_opus]); 
	$res_author = $db->query($query_author);
	if (DB::isError($res_author)) {
		echo "Query: $query_author<br />\n";
		die ($res_author->getMessage());
	}
	$num_rows_author = $res_author->numRows();
	if (DB::isError($num_rows_author)) {
		die ($num_rows_author->getMessage());
	}

	// Nun kommt die Fakultaet/Institute-Abfrage
	
	$dc_publisher = "";
	
	$query_facinst = facinstQuery($record[source_opus]); 
	
	$res_facinst = $db->query($query_facinst);
	if (DB::isError($res_facinst)) {
		echo "Query: $query_facinst<br />\n";
		die ($res_facinst->getMessage());
	}
	$num_rows_facinst = $res_facinst->numRows();
	if (DB::isError($num_rows_facinst)) {
		die ($num_rows_facinst->getMessage());
	}
	
	$identifier = $oaiprefix.$record[$SQL['identifier']];
	
	if( $record[date_modified] ) { $datumstempel = $record[date_modified]; }
	else { $datumstempel = $record[date_creation]; }
	
	$datestamp = formatDatestamp($datumstempel); 

	if (isset($record[$SQL['deleted']]) && ($record[$SQL['deleted']] == 'true') &&
		($deletedRecord == 'transient' || $deletedRecord == 'persistent')) {
		$status_deleted = TRUE;
	} else {
		$status_deleted = FALSE;
	}

	$sachgruppe_set = "ddc:".$record['sachgruppe_ddc'];
	$type_set = "pub-type:".$record['type'];
	
	

	$output .= '  <record>'."\n";
	$output .= '   <header>'."\n";
	// use xmlrecord since we use stuff from database
	$output .= xmlrecord($identifier, 'identifier', 4);
	$output .= xmlformat($datestamp, 'datestamp', 4);
	$output .= xmlrecord($sachgruppe_set, 'setSpec', 4);
	$output .= xmlrecord($type_set, 'setSpec', 4);

	$output .= '   </header>'."\n"; 

// return the metadata record itself

	if (!$status_deleted)
		include('oai2/'.$inc_record);

	$output .= '  </record>'."\n";   
}

// ResumptionToken
if (isset($restoken)) {
	$output .= $restoken;
}

// end ListRecords
$output .= 
' </ListRecords>'."\n";
  
?>
