<? 
/*
* +----------------------------------------------------------------------+
* | PHP Version 4                                                        |
* +----------------------------------------------------------------------+
* | Copyright (c) 2002 Heinrich Stamerjohanns                            |
* |                                                                      |
* | listsets.php -- Utilities for the OAI Data Provider                  |
* |                                                                      |
* | This is free software; you can redistribute it and/or modify it under|
* | the terms of the GNU General Public License as published by the      |
* | Free Software Foundation; either version 2 of the License, or (at    |
* | your option) any later version.                                      |
* | This software is distributed in the hope that it will be useful, but |
* | WITHOUT  ANY WARRANTY; without even the implied warranty of          |
* | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         |
* | GNU General Public License for more details.                         |
* | You should have received a copy of the GNU General Public License    |
* | along with  software; if not, write to the Free Software Foundation, |
* | Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA         |
* |                                                                      |
* +----------------------------------------------------------------------+
* | Derived from work by U. Mller, HUB Berlin                           |
* |                                                                      |
* | Written by Heinrich Stamerjohanns, May 2002                          |
* |            stamer@uni-oldenburg.de                                   |
* +----------------------------------------------------------------------+
*/
//
// $Id: listsets.php,v 1.00 2002/08/26 13:08:04 stamer Exp $
//

// Verknpfung mit der OPUS-Configdatei, aus der auch einige Daten genommen werden sollen
// Achtung: der relative Pfad ../../lib/ bezieht sich auf das aufrufenden Skript
// oai2.php, das sich eine Ebene hoeher befindet!
include_once ("../../lib/class.configFile.php");
$conf = new configFile ("../../lib/opus.conf");
$la = $conf->value("la");

// parse and check arguments
foreach($args as $key => $val) {

	switch ($key) { 
		case 'resumptionToken':
			$resumptionToken = $val;
			$errors .= oai_error('badResumptionToken', $key, $val); 
			break;

		default:
			$errors .= oai_error('badArgument', $key, $val);
	}
}

// break and clean up on error
if (isset($errors)) {
	oai_exit();
}

$output = " <ListSets>\n";

// Wir holen die Setinformation aus der Datenbank:

$db = DB::connect($DSN);

if (DB::isError($db)) {
	die ($db->getMessage());
}

// Aenderung Oliver Marahrens, TUB Hamburg-Harburg, 21.03.2006:
// Es sollen nur Sets angezeigt werden, die auch einen Inhalt haben
// Zuerst generieren wir die DDC-Sachgruppen-Sets:
$sql_sachgruppe = 'SELECT nr, sachgruppe_en FROM sachgruppe_ddc_'.$la.' RIGHT JOIN opus on sachgruppe_ddc_'.$la.'.nr = opus.sachgruppe_ddc WHERE nr <> "no" GROUP BY nr';

// Alte Abfrage ohne Eingrenzung
//$sql_sachgruppe = 'SELECT nr, sachgruppe_en FROM sachgruppe_ddc_'.$la.' WHERE nr <> "no"';

$sachgruppen_ergebnis = $db->query($sql_sachgruppe);
while ($sachgruppen_zeile = $sachgruppen_ergebnis->fetchRow()) {
	xmlformat($sachgruppen_zeile[1],'1');
	$output .= "  <set>\n";
	$output .= "   <setSpec>ddc:".$sachgruppen_zeile[0]."</setSpec>\n";
	$output .= "   <setName>".ereg_replace("\&", " and ", $sachgruppen_zeile[1])."</setName>\n";
	$output .= "  </set>\n";
}


// Aenderung Oliver Marahrens, TUB Hamburg-Harburg, 21.03.2006:
// Es sollen nur Sets angezeigt werden, die auch einen Inhalt haben
// Dann generieren wir die Type-Sets
$sql_type = 'SELECT typeid, resource_type_'.$la.'.type FROM resource_type_'.$la.' RIGHT JOIN opus ON resource_type_'.$la.'.typeid = opus.type GROUP BY resource_type_'.$la.'.type';


//Alte Abfrage ohne Eingrenzung
//$sql_type = 'SELECT typeid, type FROM resource_type_'.$la;

$type_ergebnis = $db->query($sql_type);
while ($type_zeile = $type_ergebnis->fetchRow()) {
	xmlformat($type_zeile[1],'1');
	$output .= "  <set>\n";
	$output .= "   <setSpec>pub-type:".$type_zeile[0]."</setSpec>\n";
	$output .= "   <setName>".ereg_replace("\&", " and ", $type_zeile[1])."</setName>\n";
	$output .= "  </set>\n";
}

// Die Verbindung zur Datenbank wird geschlossen

$db->disconnect();

$output .= " </ListSets>\n";

?>
