<?
/*
* +----------------------------------------------------------------------+
* | PHP Version 4                                                        |
* +----------------------------------------------------------------------+
* | Copyright (c) 2002 Heinrich Stamerjohanns                            |
* |                                                                      |
* | dc_record.php -- Utilities for the OAI Data Provider                 |
* |                                                                      |
* | This is free software; you can redistribute it and/or modify it under|
* | the terms of the GNU General Public License as published by the      |
* | Free Software Foundation; either version 2 of the License, or (at    |
* | your option) any later version.                                      |
* | This software is distributed in the hope that it will be useful, but |
* | WITHOUT  ANY WARRANTY; without even the implied warranty of          |
* | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         |
* | GNU General Public License for more details.                         |
* | You should have received a copy of the GNU General Public License    |
* | along with  software; if not, write to the Free Software Foundation, |
* | Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA         |
* |                                                                      |
* +----------------------------------------------------------------------+
* | Derived from work by U. Mller, HUB Berlin                           |
* |                                                                      |
* | Written by Heinrich Stamerjohanns, May 2002                          |
* |            stamer@uni-oldenburg.de                                   |
* |                                                                      |
* | Adapted for the OPUS Document Server by Anette Seiler, HBZ Kln      |
* |            seiler@hbz-nrw.de                                         |
* |                                                                      |
* +----------------------------------------------------------------------+
*/
//
// $Id: record_dc.php,v 1.02 2003/04/08 14:32:07 stamer Exp $
//

// this handles unqualified DC records, but can be also used as a sample
// for other formats.
// just specify the next variable according to your own metadata prefix
// change output your metadata records further below.

// please change to the according metadata prefix you use 
$prefix = 'oai_dc';

// you do need to change anything in the namespace and schema stuff
// the correct headers should be created automatically

// Opus-Metadaten mssen in DC-Metadaten umgewandelt werden

if( $record[title] or $record[title_en] ) {
	$dc_title = $record[title].' , '.$record[title_en];
	$dc_title = delimitersReplace( $dc_title );
}


while ($author_zeile = $res_author->fetchRow()) {
	$dc_creator .= $author_zeile[creator_name].' , ';
}
if( $record[creator_corporate] ) {
	$dc_creator .= $record[creator_corporate];
}	
$dc_creator = delimitersReplace( $dc_creator );

$dc_publisher = $record[publisher_university]." , ";
while ($facinst_zeile = $res_facinst->fetchRow()) {
	$dc_publisher .= $facinst_zeile[fakultaet].". ".$facinst_zeile[name]." , ";
}
$dc_publisher = delimitersReplace( $dc_publisher );

if( $record[subject_swd] or $record[subject_uncontrolled_german] or $record[subject_uncontrolled_english] or $record[sachgruppe_en] ) {
	$dc_subject = $record[subject_swd].' , '.$record[subject_uncontrolled_german].' , '.$record[subject_uncontrolled_english].' , '.$record[sachgruppe_en];
}

$query_klass = getClass($record[source_opus], $record[subject_type]); 
$res_klass = $db->query($query_klass);
if (DB::isError($res_klass)) {
	echo "Query: $query_klass<br />\n";
	die ($res_klass->getMessage());
}
$num_rows_klass = $res_klass->numRows();
if (DB::isError($num_rows_klass)) {
	die ($num_rows_klass->getMessage());
}
while( $klass_zeile = $res_klass->fetchRow()) {
	$dc_subject .= ' , '.$klass_zeile[bez].' , ';
}

$dc_subject = delimitersReplace( $dc_subject );

if( $record[description] or $record[description2] ) {
	$dc_description = $record[description].' , '.$record[description2];
	$dc_description = delimitersReplace( $dc_description );
}

if( $record[contributors_name] or $record[contributors_corporate] ) {
	$dc_contributor = $record[contributors_name].' , '.$record[contributors_corporate];
	$dc_contributor = delimitersReplace( $dc_contributor);
}

if( $record[type] ) {

	$query_type = "SELECT type FROM resource_type_$la WHERE typeid = '$record[type]'"; 
	
	$res_type = $db->query($query_type);
	if (DB::isError($res_type)) {
		echo "Query: $query_type<br />\n";
		die ($res_type->getMessage());
	}
	$num_rows_type = $res_type->numRows();
	
	if (DB::isError($num_rows_type)) {
		die ($num_rows_type->getMessage());
	}
	while( $type_zeile = $res_type->fetchRow()) {
		$dc_type = $type_zeile[type];
	}
	
}

if( $record[date_year] ) {
	$dc_date = $record[date_year];
}

if( $record[source_title] ) {
	$dc_source = $record[source_title];
}

if( $record[language] ) {
	$dc_language = $record[language];
}

$formatted_year = strftime("%Y", $record[date_creation]);

#$dc_url = getURL( $record[source_opus], $formatted_year );

# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# Falls in Altbestaenden (< Opus 3.0) kein Bereich angegeben ist,
# wird bereich_id auf 1 gesetzt = freier Zugriff auf die Dokumente,
# sonst kommt eine Fehlermeldung der Datenbank
$bereich_id = $record[bereich_id];
if ($bereich_id == "" || $bereich_id == 0) {
        $bereich_id = 1;
}
$res_bereich = $db->query("SELECT bereich, volltext_pfad, volltext_url FROM bereich_$la WHERE bereich_id = $bereich_id");
if (DB::isError($res_bereich)) {
        die ($res_bereich->getMessage());
}
$num = $res_bereich->numRows();
if ($num > 0) {
        $ber_record = $res_bereich->fetchRow(DB_FETCHMODE_ASSOC);
	$bereich = $ber_record[bereich];
	$volltext_pfad = $ber_record[volltext_pfad];
        $volltext_url = $ber_record[volltext_url];
        $dc_url = $volltext_url.'/'.$formatted_year.'/'.$record[source_opus].'/';
        $res_bereich->free();
}
# Ende Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche

$dc_identifier = $record[urn].' , '.$dc_url;
$dc_identifier = delimitersReplace( $dc_identifier );

$query_format = "SELECT extension, mime_type FROM format WHERE name <> 'Originalformat'";
$res_format = $db->query($query_format);
if (DB::isError($res_format)) {
	echo "Query: $query_format<br />\n";
	die ($res_format->getMessage());
}
$num_rows_format = $res_format->numRows();
if (DB::isError($num_rows_format)) {
	die ($num_rows_format->getMessage());
}
while( $format_zeile = $res_format->fetchRow()) {
	if (file_exists("$volltext_pfad/$formatted_year/$record[source_opus]/$format_zeile[extension]") == 1) {
		$dc_format = $format_zeile[mime_type];
	} 
}

# Lizenzvertrag
# Link auf Lizenz ausgeben, falls Feld lic belegt.
# Ansonsten Link auf urheberrecht.php ausgeben.
$lic = $record[lic];
$res_lic =  $db->query("SELECT link FROM license_$la WHERE shortname='$lic'");
if (DB::isError($res_lic)) {
        die ($res_lic->getMessage());
}
$num = $res_lic->numRows();
if ($num == 1) {
        $lic_record = $res_lic->fetchRow(DB_FETCHMODE_ASSOC);
        $dc_rights = $lic_record[link];
        $res_lic->free();
}
else {
        $dc_rights = "$opus_home/doku/urheberrecht.php";
}

$output .= 
'   <metadata>'."\n";

$output .= metadataHeader($prefix);

// please change according to your metadata format
$indent = 6;
$output .= xmlrecord($dc_title, 'dc:title', $indent);
$output .= xmlrecord($dc_creator,'dc:creator', $indent);
$output .= xmlrecord($dc_subject, 'dc:subject', $indent);
$output .= xmlrecord($dc_description, 'dc:description', $indent);
$output .= xmlrecord($dc_publisher, 'dc:publisher', $indent);
$output .= xmlrecord($dc_contributor, 'dc:contributor', $indent);
$output .= xmlrecord($dc_date, 'dc:date', $indent);
$output .= xmlrecord($dc_type, 'dc:type', $indent);
$output .= xmlrecord($dc_format, 'dc:format', $indent);
$output .= xmlrecord($dc_identifier, 'dc:identifier', $indent);
$output .= xmlrecord($dc_source, 'dc:source', $indent);
$output .= xmlrecord($dc_language, 'dc:language', $indent);
$output .= xmlrecord($dc_relation, 'dc:relation', $indent);
$output .= xmlrecord($dc_coverage, 'dc:coverage', $indent);
$output .= xmlrecord($dc_rights, 'dc:rights', $indent);

if ($bereich_id > 1) {
        $output .= "      <dc:rights>Volltextzugriff: ".utf8_encode($bereich)."</dc:rights>\n"; # Regelung Zugriffsrechte
}

unset ($dc_title, $dc_creator, $dc_subject, $dc_description, $dc_publisher, $dc_contributor, $dc_date, $dc_type, $dc_format, $dc_identifier, $dc_source, $dc_language, $dc_relation, $dc_coverage);

// Here, no changes need to be done
$output .=           
'     </'.$prefix;
if (isset($METADATAFORMATS[$prefix]['record_prefix'])) {
	$output .= ':'.$METADATAFORMATS[$prefix]['record_prefix'];
}
$output .= ">\n";
$output .= 
'   </metadata>'."\n";
?>
