<?
/*
* +----------------------------------------------------------------------+
* | PHP Version 4                                                        |
* +----------------------------------------------------------------------+
* | Copyright (c) 2002 Heinrich Stamerjohanns                            |
* |                                                                      |
* | dc_record.php -- Utilities for the OAI Data Provider                 |
* |                                                                      |
* | This is free software; you can redistribute it and/or modify it under|
* | the terms of the GNU General Public License as published by the      |
* | Free Software Foundation; either version 2 of the License, or (at    |
* | your option) any later version.                                      |
* | This software is distributed in the hope that it will be useful, but |
* | WITHOUT  ANY WARRANTY; without even the implied warranty of          |
* | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         |
* | GNU General Public License for more details.                         |
* | You should have received a copy of the GNU General Public License    |
* | along with  software; if not, write to the Free Software Foundation, |
* | Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA         |
* |                                                                      |
* +----------------------------------------------------------------------+
* | Derived from work by U. Mller, HUB Berlin                           |
* |                                                                      |
* | Written by Heinrich Stamerjohanns, May 2002                          |
* |            stamer@uni-oldenburg.de                                   |
* |                                                                      |
* | Adapted for the OPUS Document Server by Anette Seiler, HBZ Kln      |
* |            seiler@hbz-nrw.de                                         |
* |                                                                      |
* +----------------------------------------------------------------------+
*/
//
// $Id: record_dc.php,v 1.02 2003/04/08 14:32:07 stamer Exp $
//

// this handles unqualified DC records, but can be also used as a sample
// for other formats.
// just specify the next variable according to your own metadata prefix
// change output your metadata records further below.

// please change to the according metadata prefix you use 
$prefix = 'epicur';

// you do need to change anything in the namespace and schema stuff
// the correct headers should be created automatically

// wir mssen checken, ob es sich um einen neuen Metadatensatz oder um 
// einen genderten Metadatensatz handelt.

$update_statusType = "urn_new"; 

// Opus-Metadaten mssen in Epicur-Metadaten umgewandelt werden

if( $record[date_year] ) {
	$dc_date = $record[date_year];
}

$formatted_year = strftime("%Y", $record[date_creation]);

#$epicur_url = getURL( $record[source_opus], $formatted_year );

# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# Falls in Altbestaenden (< Opus 3.0) kein Bereich angegeben ist,
# wird bereich_id auf 1 gesetzt = freier Zugriff auf die Dokumente,
# sonst kommt eine Fehlermeldung der Datenbank
$bereich_id = $record[bereich_id];
if ($bereich_id == "" || $bereich_id == 0) {
        $bereich_id = 1;
}
$res_bereich = $db->query("SELECT volltext_url FROM bereich_$la WHERE bereich_id = $bereich_id");
if (DB::isError($res_bereich)) {
        die ($res_bereich->getMessage());
}
$num = $res_bereich->numRows();
if ($num > 0) {
        $ber_record = $res_bereich->fetchRow(DB_FETCHMODE_ASSOC);
        $volltext_url = $ber_record[volltext_url];
	$epicur_url = $volltext_url.'/'.$formatted_year.'/'.$record[source_opus].'/'; 
        $res_bereich->free();
}
# Ende Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche

$epicur_urn = $record[urn];
$epicur_format = "text/html";

$output .= 
'   <metadata>'."\n";

$output .= metadataHeader($prefix);

$output .= "      <administrative_data>\n";
$output .= "            <delivery>\n";
$output .= "                  <update_status type=\"$update_statusType\" />\n";
$output .= "            </delivery>\n";
$output .= "      </administrative_data>\n";
$output .= "      <record>\n";
$output .= "            <identifier scheme=\"urn:nbn:de\">$epicur_urn</identifier>\n";
$output .= "            <resource>\n";
$output .= "                  <identifier scheme=\"url\" type=\"frontpage\" role=\"primary\">$epicur_url</identifier>\n";
$output .= "                  <format scheme=\"imt\">$epicur_format</format>\n";
$output .= "            </resource>\n";
$output .= "      </record>\n";


unset ($epicur_url, $epicur_urn, $epicur_format);
	


// Here, no changes need to be done
$output .=           
'     </'.$prefix;
if (isset($METADATAFORMATS[$prefix]['record_prefix'])) {
	$output .= ':'.$METADATAFORMATS[$prefix]['record_prefix'];
}
$output .= ">\n";
$output .= 
'   </metadata>'."\n";
?>
