<?
/*
* +----------------------------------------------------------------------+
* | PHP Version 4                                                        |
* +----------------------------------------------------------------------+
* |                                                                      |
* | record_proprint.php -- XML-Expression of Datasets defined by ProPrint|
* |                                                                      |
* | This is free software; you can redistribute it and/or modify it under|
* | the terms of the GNU General Public License as published by the      |
* | Free Software Foundation; either version 2 of the License, or (at    |
* | your option) any later version.                                      |
* | This software is distributed in the hope that it will be useful, but |
* | WITHOUT  ANY WARRANTY; without even the implied warranty of          |
* | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         |
* | GNU General Public License for more details.                         |
* | You should have received a copy of the GNU General Public License    |
* | along with  software; if not, write to the Free Software Foundation, |
* | Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA         |
* |                                                                      |
* +----------------------------------------------------------------------+
* | Derived from work by U. Mller, HUB Berlin                           |
* | Derived from work by Heinrich Stamerjohanns, Uni Oldenburg           |
* +----------------------------------------------------------------------+
* | V. 0.2, 2004, Hans-Werner Hilse, SUB Goettingen, ProPrint            |
* |               hilse@sub.uni-goettingen.de                            |
* +----------------------------------------------------------------------+
*/

// will split a string into elements and return XML
// supposed to print values from database
// ADDED HERE: Possibility to express XML attributes
function xmlrecordattr($sqlrecord, $element, $attrs, $indent = 6)
{
	global $SQL;
	global $xmlescaped;
	global $charset;

	$str = '';
	$attrstr = '';

	if($attrs) foreach($attrs as $name => $value) {
		$convval = xmlstr($value, $charset, $xmlescaped);
		$attrstr.=" {$name}=\"{$convval}\"";
	}

	if ($sqlrecord != '') {
		if (isset($SQL['split'])) {
			$temparr = explode($SQL['split'], $sqlrecord);
			foreach ($temparr as $val) {
				$str .= str_pad('', $indent).'<'.$element.$attrstr.'>'.xmlstr($val, $charset, $xmlescaped).'</'.$element.">\n";
			}
			return $str;
		} else {
			return str_pad('', $indent).'<'.$element.$attrstr.'>'.xmlstr($val, $charset, $xmlescaped).'</'.$element.">\n";
		}
	} else {
		return '';
	}
}

// Gets an URL to an opus document directory and returns the name of the document file(s) if in format pdf.
// Returns 0 if there is no pdf-file (or if pdf among other formats). 
// Returns number of pdfs if more than one pdf-file. Returns -1 on error.
function getdoc($index) {
    if ( !$index ) { return "-1"; }
    if ( substr($index, -1) != "/" ) { // add a slash if needed
        $index_path=$index."/"; 
    } else {
        $index_path=$index; 	    
    }
    $find_begin=$index; // string that marks the appropriate (to find) line. this string can also be the directory, that has been fed to this function
    //$find_begin="^<td><a href=\"".$index; // regular expressions are possible, heres an example.
    $find_end=".pdf\">"; // string that marks the end of the line-chunk that we want to find
    $index_end=".pdf"; //extension of the filename(s) to find
    $index_name="index.html"; // name of the html-file, that represents an index (frontdoor, virtual frontpage) to a document in opus
    $j=0; $i=0;
    $index_file=$index_path.$index_name; // full name of indexfile
    $file_handle=@fopen($index_file, "r"); // open indexfile for reading
    if ( !$file_handle ) { // if open fails, return with error
        return "-1";
    }
    while (!feof($file_handle)) { // parse through index line by line
    	$line = fgets($file_handle, 4096);	    
	$gotit=ereg($find_begin, $line); // check if $find_begin is in the current line
	if ( $gotit ) {
	    $start=strpos($line, $index_path); // $find_begin found. now detect exact starting position of the filename that we have to find
	    if ( $start > -1 ) {
		$i++;
		$stop=strpos(strtolower($line), strtolower($find_end)); // check if $find_end is in the current line, detect position
		if ( $stop > -1 ) {
    		    $file_pdf[($j)]=substr($line, $start, ($stop-($start)+(strlen($index_end)))); // copy filename out of line and write it to an array				
		    $j++;
		}
	    }
	}
    }
    fclose ($file_handle);
    if ( $j == 0 ) { return "0"; }  //	no element in array. no pdf-filename has been found.
    if ( $j == 1 ) { return $file_pdf[0]; }  // one and only one element (pdf-filename) in array.
    if ( $j > 1 )  { 
	return strval($j);  // more than one filename found. return only the number of filenames.
    }
}
?>
