<?
/*
* +----------------------------------------------------------------------+
* | PHP Version 4                                                        |
* +----------------------------------------------------------------------+
* |                                                                      |
* | record_proprint.php -- XML-Expression of Datasets defined by ProPrint|
* |                                                                      |
* | This is free software; you can redistribute it and/or modify it under|
* | the terms of the GNU General Public License as published by the      |
* | Free Software Foundation; either version 2 of the License, or (at    |
* | your option) any later version.                                      |
* | This software is distributed in the hope that it will be useful, but |
* | WITHOUT  ANY WARRANTY; without even the implied warranty of          |
* | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         |
* | GNU General Public License for more details.                         |
* | You should have received a copy of the GNU General Public License    |
* | along with  software; if not, write to the Free Software Foundation, |
* | Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA         |
* |                                                                      |
* +----------------------------------------------------------------------+
* | Derived from work by U. Mller, HUB Berlin                           |
* | Derived from work by Heinrich Stamerjohanns, Uni Oldenburg           |
* +----------------------------------------------------------------------+
* | V. 0.2, 2004, Hans-Werner Hilse, SUB Goettingen, ProPrint            |
* |               hilse@sub.uni-goettingen.de                            |
* +----------------------------------------------------------------------+
*/

require_once('oai2/record_proprint-util.php');

$prefix = 'oai_pp';

$id=$record['urn']?$record['urn']:$identifier;

# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# Falls in Altbestaenden (< Opus 3.0) kein Bereich angegeben ist,
# wird bereich_id auf 1 gesetzt = freier Zugriff auf die Dokumente,
# sonst kommt eine Fehlermeldung der Datenbank
$bereich_id = $record[bereich_id];
if ($bereich_id == "" || $bereich_id == 0) {
        $bereich_id = 1;
}
$res_bereich = $db->query("SELECT volltext_url FROM bereich_$la WHERE bereich_id = $bereich_id");
if (DB::isError($res_bereich)) {
        die ($res_bereich->getMessage());
}
$num = $res_bereich->numRows();
if ($num > 0) {
        $ber_record = $res_bereich->fetchRow(DB_FETCHMODE_ASSOC);
        $volltext_url = $ber_record[volltext_url];
        $proprint_url = $volltext_url ."/".date("Y", $record[date_creation])."/".$record[source_opus]."/";
        $res_bereich->free();
}
# Ende Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche


$output .= '   <metadata>
      <PP:ProPrint xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:PP="http://www.proprint-service.de/xml/schemes/v1/CHECKED" xsi:schemaLocation="http://www.proprint-service.de/xml/schemes/v1/ http://www.proprint-service.de/xml/schemes/v1/PROPRINT_METADATA_SET.xsd">';

$output.= 
	"      <PP:Metadata id=\"{$id}\">\n".
	xmlrecord($id,'PP:DCTERMS.Identifier').
	xmlrecordattr($record['title'],'PP:DC.Title',array('language'=>'ger')).
	xmlrecordattr($record['title_en'],'PP:DC.Title',array('language'=>'eng')).
	xmlrecord($record['creator_corporate'],'PP:PPQ.Creator.CorporateName').
	xmlrecord($record['publisher_university'],'PP:DC.Publisher').
	xmlrecordattr($record['subject_swd'],'PP:DC.Subject',array('scheme'=>'swd')).
	xmlrecordattr($record['sachgruppe_en'],'PP:DC.Subject',array('language'=>'eng')).
	xmlrecordattr($record['subject_uncontrolled_german'],'PP:DC.Subject',array('language'=>'ger')).
	xmlrecordattr($record['subject_uncontrolled_english'],'PP:DC.Subject',array('language'=>'eng')).
	xmlrecordattr($record['description'],'PP:DCTERMS.Description.Abstract',array('language'=>'ger')).
	xmlrecordattr($record['description2'],'PP:DCTERMS.Description.Abstract',array('language'=>'eng')).
	xmlrecord($record['contributors_name'],'PP:DC.Contributor').
	xmlrecord($record['contributors_corporate'],'PP:PPQ.Contributor.CorporateName').
	xmlrecord($record['date_creation'],'PP:DCTERMS.Date.Created').
	xmlrecord($record['language'],'PP:DCTERMS.Language').
	xmlrecord($proprint_url,'PP:PP.Origin');

// ungenutzt: date_modified, type	


// hinzugefuegt, maile 25.1.2006
$output.=xmlrecord(getdoc($proprint_url),'PP:PP.Origindoc');

// hinzugefuegt, steiner 24.11.04
#$output.=xmlrecord(getdoc(getURL($record['source_opus'], strftime("%Y", $record['date_creation']))),'PP:PP.Origindoc');
		
while ($author = $res_author->fetchRow())
	$output.=xmlrecord($author['creator_name'],'PP:DC.Creator');

while ($facinst = $res_facinst->fetchRow())
	$output.=xmlrecord($record['publisher_university'].', '.
		$facinst['fakultaet'].'. '.$facinst['name'],'PP:DC.Publisher');

/*
$record[...]:
o.source_opus, o.title, o.creator_corporate, o.subject_swd, 
	o.description, o.publisher_university, o.contributors_name, o.contributors_corporate, 
	o.date_year, r.type, o.source_title, o.language, o.subject_uncontrolled_german, 
	o.subject_uncontrolled_english, o.title_en, o.description2, s.sachgruppe_en, 
	o.urn, o.date_creation, o.date_modified, o.subject_type
*/

$output .= '      </PP:Metadata>
     </PP:ProPrint>
   </metadata>'."\n";
?>
