<?
/**
 * OPUS Utilities for the OAI Data Provider
 * 
 * This file is part of OPUS. The software OPUS has been developed at the 
 * University of Stuttgart with funding from the German Research Net 
 * (Deutsches Forschungsnetz), the Federal Department of Higher Education and 
 * Research (Bundesministerium fuer Bildung und Forschung) and The Ministry of 
 * Science, Research and the Arts of the State of Baden-Wuerttemberg 
 * (Ministerium fuer Wissenschaft, Forschung und Kunst des Landes 
 * Baden-Wuerttemberg).
 * 
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at    
 * your option) any later version.
 * This software is distributed in the hope that it will be useful, but 
 * WITHOUT  ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with  software; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 * 
 * PHP versions 4 and 5
 * 
 * @package OPUS
 * @copyright Oliver Marahrens, 2004-2005 
 * @author Oliver Marahrens <o.marahrens@tu-harburg.de>, TU Hamburg-Harburg
 * @version $Id: record_xmetadiss.php 98 2006-09-27 09:10:32Z freudenberg $
 */

// Verknuepfung mit der OPUS-Configdatei, aus der auch einige Daten genommen werden sollen
// Achtung: der relative Pfad ../../lib/ bezieht sich auf das aufrufenden Skript
// oai2.php, das sich eine Ebene hoeher befindet!
include_once ("../../lib/class.configFile.php");
$conf = new configFile ("../../lib/opus.conf");

$ddb_idn = $conf->value("ddb_idn");

// this handles XMetaDiss Records 

// please change to the according metadata prefix you use 
$prefix = 'xMetaDiss';

// you do need to change anything in the namespace and schema stuff
// the correct headers should be created automatically

// Opus-Metadaten muessen in XMetaDiss-Metadaten umgewandelt werden

$output .= 
'   <metadata>'."\n";

$output .= metadataHeader($prefix);


# Daten zur Universitaet und zur Institution, die den Server betreibt 
# aus der DB lesen.
$unicheck = $db->query("SELECT * FROM university_$la WHERE universitaet = '$record[publisher_university]'");
if (DB::isError($unicheck)) {
        die ($unicheck->getMessage());
}
$uninum = $unicheck->numRows();
$unirecord = $unicheck->fetchRow(DB_FETCHMODE_ASSOC);
$univName = $unirecord[universitaet_anzeige];
$univOrt = $unirecord[univort];
$instName = $unirecord[instname];
$instAdresse = $unirecord[instadresse];
$ddb_idn = $unirecord[ddb_idn];
$unicheck->free();


# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# Falls in Altbestaenden (< Opus 3.0) kein Bereich angegeben ist,
# wird bereich_id auf 1 gesetzt = freier Zugriff auf die Dokumente,
# sonst kommt eine Fehlermeldung der Datenbank
$bereich_id = $record[bereich_id];
if ($bereich_id == "" || $bereich_id == 0) {
        $bereich_id = 1;
}
$res_bereich = $db->query("SELECT bereich, volltext_pfad, volltext_url FROM bereich_$la WHERE bereich_id = $bereich_id");
if (DB::isError($res_bereich)) {
        die ($res_bereich->getMessage());
}
$num = $res_bereich->numRows();
if ($num > 0) {
	$ber_record = $res_bereich->fetchRow(DB_FETCHMODE_ASSOC);
        $bereich = $ber_record[bereich];
        $volltext_pfad = $ber_record[volltext_pfad];
        $volltext_url = $ber_record[volltext_url];
        $res_bereich->free();
}
# Ende Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche


# Lizenzvertrag
# Link auf Lizenz ausgeben, falls Feld lic belegt.
# Ansonsten Link auf urheberrecht.php ausgeben.
$lic = $record[lic];
$res_lic =  $db->query("SELECT link FROM license_$la WHERE shortname='$lic'");
if (DB::isError($res_lic)) {
        die ($res_lic->getMessage());
}
$num = $res_lic->numRows();
if ($num == 1) {
	$lic_record = $res_lic->fetchRow(DB_FETCHMODE_ASSOC);
	$dc_rights = $lic_record[link];
	$res_lic->free();
}
else {
	$dc_rights = "$opus_home/doku/urheberrecht.php";
}

# Daten aus dem DB-Ergebnis ziehen und fuer die Ausgabe umwandeln
$title = $record[title];
# Formale bibliographische Angaben
$output .= "      <dc:title xsi:type=\"ddb:titleISO639-2\" lang=\"".$record[language]."\">".utf8_encode($title)."</dc:title>\n"; # Titel erste Sprache
if ($record[language] != "ger") {
	$title2 = $record[title_de];
	$lang2 = "ger";
}
else {
	$lang2 = "eng";
	$title2 = $record[title_en];
}
if ($title2) {
	$output .= "      <dc:title xsi:type=\"ddb:titleISO639-2\" lang=\"".$lang2."\" ddb:type=\"translated\">".utf8_encode($title2)."</dc:title>\n"; # Titel zweite Sprache
}


# Setzen der Autoren-Variablen
$name = $record[creator_name];
$namearr = split(",", $name);
if (count($namearr) > 1) {
	$vorname = $namearr[1];
	$nachname = $namearr[0];
	# Rausfischen von Namenspraefix
        $prefixarray = array("von und zu"," von","von "," zu","zu ");
        $nameprefix = "";
        foreach ($prefixarray as $item) {
                if (ereg($item, $vorname)) {
                        $nameprefix .= $item;
                        $vorname = str_replace($item, "", $vorname);
                }
                if (ereg($item, $nachname)) {
                        $nameprefix .= $item;
                        $nachname = str_replace($item, "", $nachname);
                }
        }
}
$email = "";
if (strstr($record[verification], "@")) {
	$email = $record[verification];
}

# optional; in OPUS nicht unterstuetzt: 
# <dcterms:alternative xsi:type=\"ddb:talternativeISO639-2\" lang=\"".."\"></dcterms:alternative> 
# Untertitel

$output .= "      <dc:creator xsi:type=\"pc:MetaPers\">\n"; # Autor(en)
$output .= "      		<pc:person>\n"; # Einzelner Autor : Weitere Attribute moeglich
$output .= "      			<pc:name type=\"nameUsedByThePerson\">\n"; # Autor Name : Weitere Attribute moeglich
if (count($namearr) > 1) {
	$output .= "      				<pc:foreName>".utf8_encode($vorname)."</pc:foreName>\n"; # Autor Vorname
	$output .= "      				<pc:surName>".utf8_encode($nachname)."</pc:surName>\n"; # Autor Name
        if ($nameprefix) {
                $output .= "                    <pc:prefix>".utf8_encode(ereg_replace("\ $", "", ereg_replace("^\ ", "", $nameprefix)))."</pc:prefix>\n"; # Autor Praefix
        }

}
else {
	$output .= "      				<pc:personEnteredUnderGivenName>".utf8_encode($name)."</pc:personEnteredUnderGivenName>\n"; # Autor Name, wenn nicht Vor- und Nachname
}
$output .= "      			</pc:name>\n"; # Ende Autor Name

# optional, kann evtl. aus Institut geschlossen werden
# $output .= "      			<pc:fieldOfStudy>".$test."</pc:fieldOfStudy>\n"; # Autor Studienfach

if ($email) {
	$output .= "      			<pc:email>".utf8_encode($email)."</pc:email>\n"; # Autor Mailadresse
}
$output .= "      		</pc:person>\n"; # Ende Einzelner Autor
$output .= "      </dc:creator>\n"; # Ende Autor(en)

# Sacherschliessung in OPUS ueber DDC, SWD und freie Schlagworte
if ($record[sachgruppe_ddc]) {
	$output .= "      <dc:subject xsi:type=\"xMetaDiss:DDC-SG\">".utf8_encode($record[sachgruppe_ddc])."</dc:subject>\n"; # Klassifikation nach DDC der DDB
}
if ($record[subject_swd]) {
	$output .= "      <dc:subject xsi:type=\"xMetaDiss:SWD\">".utf8_encode(htmlspecialchars($record[subject_swd]))."</dc:subject>\n"; # Schlagworte aus Schlagwort-Normdatei
}
if ($record[subject_uncontrolled_german] || $record[subject_uncontrolled_english]) {
	$output .= "      <dc:subject xsi:type=\"xMetaDiss:noScheme\">".utf8_encode(htmlspecialchars($record[subject_uncontrolled_german]." ".$record[subject_uncontrolled_english]))."</dc:subject>\n"; # freie Schlagworte deutsch und Englisch
}

# Weitere Klassifikationssysteme und Thesauri -- vorlaeufig nicht implementiert
# Deutsche Verbundklassifikationen
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:BK\">".$test."</dc:subject>\n"; # Klassifikation nach GBV-BK
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:RVK\">".$test."</dc:subject>\n"; # Klassifikation nach Regensburger Verbundklassifikation

# Internationale Klassifikationssysteme
#$output .= "      <dc:subject xsi:type=\"dcterms:DDC\">".$test."</dc:subject>\n"; # Klassifikation nach Dewey Decimal Classification
#$output .= "      <dc:subject xsi:type=\"dcterms:LCC\">".$test."</dc:subject>\n"; # Klassifikation nach LoC-Classification
#$output .= "      <dc:subject xsi:type=\"dcterms:UDC\">".$test."</dc:subject>\n"; # Klassifikation nach Universal Decimal Classification
#$output .= "      <dc:subject xsi:type=\"dcterms:NLM\">".$test."</dc:subject>\n"; # Klassifikation nach NLM (Amerikanische Medizin-Bibl.)
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:UMLS\">".$test."</dc:subject>\n"; # Klassifikation nach Unified Medical Language System
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:ZDM\">".$test."</dc:subject>\n"; # Klassifikation nach Didaktik der Mathematik

# Internationale Schlagwortdateien
#$output .= "      <dc:subject xsi:type=\"dcterms:LCSH\">".$test."</dc:subject>\n"; # Schlagworte aus LoC-Schlagwortdatei
#$output .= "      <dc:subject xsi:type=\"dcterms:MeSH\">".$test."</dc:subject>\n"; # Schlagworte aus Medizinischer Schlagwortdatei

# Internationale Thesauri
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:PACS2003\">".$test."</dc:subject>\n"; # Klassifikation nach PACS (Physik und Astronomie)
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:MCS1991\">".$test."</dc:subject>\n"; # Klassifikation nach MCS (Mathematik)
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:MCS2000\">".$test."</dc:subject>\n"; # Klassifikation nach MCS 2000 (Mathematik neue Version)
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:CCS1998\">".$test."</dc:subject>\n"; # Klassifikation nach CCS (ACM Computer)
#$output .= "      <dc:subject xsi:type=\"xMetaDiss:BK\">".$test."</dc:subject>\n"; # Klassifikation nach GBV-BK

if ($record[description]) {
	// Sonderzeichen raus-exen
	$rec = strip_tags($record[description]);
	if (function_exists("html_entity_decode")) {
		$rec = html_entity_decode($rec);
	}
	else {
		// Umlaute manuell decodieren
		$rec = ereg_replace("&ouml;", ";", $rec);
		$rec = ereg_replace("&Ouml;", ";", $rec);
		$rec = ereg_replace("&uuml;", ";", $rec);
		$rec = ereg_replace("&Uuml;", ";", $rec);
		$rec = ereg_replace("&auml;", ";", $rec);
		$rec = ereg_replace("&Auml;", ";", $rec);
		$rec = ereg_replace("&szlig;", ";", $rec);
	}
	$rec = ereg_replace("\&", "&amp;", $rec);
	$rec = ereg_replace("\>", "&gt;", $rec);
	$rec = ereg_replace("\<", "&lt;", $rec);
	$rec = ereg_replace("\'", "&apos;", $rec);
	$rec = ereg_replace("\"", "&quot;", $rec);
	$rec = utf8_encode($rec);
	$output .= "      <dcterms:abstract xsi:type=\"ddb:contentISO639-2\" lang=\"".utf8_encode($record[description_lang])."\" ddb:type=\"noScheme\">".$rec."</dcterms:abstract>\n"; # Abstract 1
}
if ($record[description2]) {
	$rec = strip_tags($record[description2]);
	if (function_exists("html_entity_decode")) {
		$rec = html_entity_decode($rec);
	}
	else {
		// Umlaute manuell decodieren
		$rec = ereg_replace("&ouml;", ";", $rec);
        $rec = ereg_replace("&Ouml;", ";", $rec);
        $rec = ereg_replace("&uuml;", ";", $rec);
        $rec = ereg_replace("&Uuml;", ";", $rec);
        $rec = ereg_replace("&auml;", ";", $rec);
        $rec = ereg_replace("&Auml;", ";", $rec);
        $rec = ereg_replace("&szlig;", ";", $rec);
	}
	$rec = ereg_replace("\&", "&amp;", $rec);
	$rec = ereg_replace("\>", "&gt;", $rec);
	$rec = ereg_replace("\<", "&lt;", $rec);
	$rec = ereg_replace("\'", "&apos;", $rec);
	$rec = ereg_replace("\"", "&quot;", $rec);
	$rec = utf8_encode($rec);
	$output .= "      <dcterms:abstract xsi:type=\"ddb:contentISO639-2\" lang=\"".utf8_encode($record[description2_lang])."\" ddb:type=\"noScheme\">".$rec."</dcterms:abstract>\n"; # Abstract 2
}

# Weitere bibliographische Angaben: Publizierende Organisation
$output .= "      <dc:publisher xsi:type=\"cc:Publisher\">\n"; # Verbreitende Stelle(n)
$output .= "      	<cc:universityOrInstitution>\n"; # Verbreitende Stelle: Universitaet
$output .= "      		<cc:name>".utf8_encode($instName)."</cc:name>\n"; # Name der verbreitenden Stelle
$output .= "      		<cc:place>".utf8_encode($univOrt)."</cc:place>\n"; # Ort der verbreitenden Stelle
$output .= "      	</cc:universityOrInstitution>\n"; # Verbreitende Stelle: Universitaet
$output .= "      	<cc:address cc:Scheme=\"DIN5008\">".utf8_encode($instAdresse)."</cc:address>\n"; # Adresse der verbreitenden Stelle
$output .= "      </dc:publisher>\n"; # Ende Verbreitende Stelle(n)

# Setzen der Doktorvater-Variablen
$dname = $record[advisor];
// Titel rausfischen
$dvorname = "";
$dnachname = "";

$drarr = split("\(", $dname);
$dnamearr = split(",", $drarr[0]);
if (count($dnamearr) > 1) {
	$dvorname = $dnamearr[1];
	$dnachname = $dnamearr[0];
	# Rausfischen von Namenspraefix
	$prefixarray = array("von und zu"," von","von "," zu","zu ");
	$dprefix = "";
	foreach ($prefixarray as $item) {
		if (ereg($item, $dvorname)) {
			$dprefix .= $item;
			$dvorname = str_replace($item, "", $dvorname);
		}
		if (ereg($item, $dnachname)) {
			$dprefix .= $item;
			$dnachname = str_replace($item, "", $dnachname);
		}
	}	
}
$drtitel = ereg_replace("\)", "", $drarr[1]);
// Wenn die Titelangaben leer sind mal nachgucken, ob Punkte im Namen auftauchen (evtl. Titel falsch angesetzt)
if ($dvorname || $dnachname) {
    $titelcountvn = 0;
    $titelcountnn = 0;
    $titelcountvn += substr_count($dvorname, ".");
    $titelcountnn += substr_count($dnachname, ".");
    if ($titelcountvn > 0) {
        $titelarr = split(" ", $dvorname);
        foreach ($titelarr as $item) {
	    # Wenn item aus mind. 2 Buchstaben und einem . am Ende besteht, wird
	    # der String zum Titel hinzugefuegt und im Namen geloescht.
	    # abgekuerzte Vornamen bleiben dadurch im Namen stehen.
            if (eregi("[a-z][a-z][a-z]*\.$", $item)) {
                if ($drtitel) $drtitel .= " ".$item;
                else $drtitel .= $item;
                $dvorname = str_replace($item, "", $dvorname);
            }
        }
        $dvorname = ereg_replace("\ $", "", $dvorname);
    }
    if ($titelcountnn > 0) {
        $titelarr = split(" ", $dnachname);
        foreach ($titelarr as $item) {
            # Wenn item aus mind. 2 Buchstaben und einem . am Ende besteht, wird
            # der String zum Titel hinzugefuegt und im Namen geloescht.
            # abgekuerzte Vornamen bleiben dadurch im Namen stehen.
            if (eregi("[a-z][a-z][a-z]*\.$", $item)) {
                if ($drtitel) $drtitel .= " ".$item;
                else $drtitel .= $item;
                $dnachname = str_replace($item, "", $dnachname);
            }
        }
        $dnachname = ereg_replace("\ $", "", $dnachname);
    }
}
else {
    $titelarr = split(" ", $drarr[0]);
    foreach ($titelarr as $item) {
        if (ereg("\.$", $item)) {
            if ($drtitel) $drtitel .= " ".$item;
	    else $drtitel .= $item;
            $drarr[0] = str_replace($item, "", $drarr[0]);
        }
    }
    $drarr[0] = ereg_replace("\ $", "", $drarr[0]);
}

# Bei Dissertationen (also alles, was mit XMetaDiss uebermittelt werden soll?)
# Dissertations-Angaben
$output .= "      <dc:contributor xsi:type=\"pc:Contributor\" thesis:role=\"advisor\">\n"; # Doktorvater
$output .= "       <pc:person>\n"; # Wurzelelement Personenangaben
$output .= "      	<pc:name type=\"nameUsedByThePerson\">\n"; # Name des Doktorvaters
if (count($dnamearr) > 1) {
	$output .= "                    <pc:foreName>".utf8_encode(ereg_replace("\ $", "", ereg_replace("^\ ", "", $dvorname)))."</pc:foreName>\n"; # Doktorvater Vorname
	$output .= "                    <pc:surName>".utf8_encode(ereg_replace("\ $", "", ereg_replace("^\ ", "", $dnachname)))."</pc:surName>\n"; # Doktorvater Name
	if ($dprefix) {
		$output .= "                    <pc:prefix>".utf8_encode(ereg_replace("\ $", "", ereg_replace("^\ ", "", $dprefix)))."</pc:prefix>\n"; # Doktorvater Praefix
	}
}
else {
	$output .= "                    <pc:personEnteredUnderGivenName>".utf8_encode(ereg_replace("\ $", "", ereg_replace("^\ ", "", $drarr[0])))."</pc:personEnteredUnderGivenName>\n"; # Doktorvater Name, wenn nicht Vor- und Nachname
}
$output .= "      	</pc:name>\n"; # Ende Doktorvater Name

if ($drtitel) {
	$output .= "      	<pc:academicTitle>".utf8_encode($drtitel)."</pc:academicTitle>\n"; # Doktorvater Titel
}

$output .= "       </pc:person>\n"; # Ende Wurzelelement Personenangabe
$output .= "      </dc:contributor>\n"; # Ende Doktorvater

$output .= "      <dcterms:dateAccepted xsi:type=\"dcterms:W3CDTF\">".date("Y-m-d", $record[date_accepted])."</dcterms:dateAccepted>\n"; # Promotionsdatum Y-M-D

$output .= "      <dc:type xsi:type=\"ddb:PublType\">ElectronicThesisandDissertation</dc:type>\n"; # Dokumenttyp statisch ElectronicThesisandDissertation
/* Andere moegliche Werte (derzeit nicht implementiert):
Collection
Dataset
Image
InteractiveResource
Service
Software
Sound
Text
PhysicalObject
*/

$output .= "      <dc:identifier xsi:type=\"urn:nbn\">".utf8_encode($record[urn])."</dc:identifier>\n"; # URN-Angabe

# Dateiinfos raussuchen
$p = $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus];
$dh = opendir($p);
$anz = 0;
$f = array();
while ($file = readdir($dh)) {
    if ($xmetadiss_orig) { # Wenn auch das Original in XMetaDiss enthalten sein soll
	if ($file == "original") { 
		$p2 = $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/original";
		$dh2 = opendir($p2);
		$oind = 0;
		while ($file2 = readdir($dh2)) {
			if (is_file($p2."/".$file2) && $file2 != "." && $file2 != "..") {
				$farr = split("\.", $file2);
				$ind = count($farr);
				$f[$anz] = $farr[$ind-1];
				$orig[$oind] = $file2;
				$oind++;
				$anz++;
			}
		}
	}
	else if (is_dir($p."/".$file) && $file != "." && $file != "..") {
	    $p2 = $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/".$file;
	    $dh2 = opendir($p2);
	    while ($file2 = readdir($dh2)) {
		if (is_file($p2."/".$file2) && $file2 != "." && $file2 != "..") {
		    $farr = split("\.", $file2);
		    $ind = count($farr);
		    if (!in_array($farr[$ind-1], $f)) {
			$f[$anz] = $farr[$ind-1];
			$anz++;
		    }
		}
	    }
	}
    }
    else { # Wenn das Originalformat nicht in XMetaDiss einbezogen werden soll
	if ($file != "original" && is_dir($p."/".$file) && $file != "." && $file != "..") {
	    $p2 = $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/".$file;
	    $dh2 = opendir($p2);
	    while ($file2 = readdir($dh2)) {
		if (is_file($p2."/".$file2) && $file2 != "." && $file2 != "..") {
		    $farr = split("\.", $file2);
		    $ind = count($farr);
		    if (!in_array($farr[$ind-1], $f)) {
			$f[$anz] = $farr[$ind-1];
			$anz++;
		    }
		}
	    }
	}
    }
}
closedir($dh);
//$output .= "      <dcterms:extend>".$test."</dcterms:extend>\n"; # Dateigroesse des Dokuments - Kann auch rausgelassen werden, da die Groesse automatisch durch DDB bei Eingang des Dokuments ermittelt wird
for ($x = 0; $f[$x]; $x++) { 
	$output .= "      <dcterms:medium xsi:type=\"dcterms:IMT\">".utf8_encode(conv_type($f[$x]))."</dcterms:medium>\n"; # Dateityp des Dokuments nach MIME
} 

//dcterms:source ist fuer ein urspruengliches Dokument, das z.B. als Vorlage fuer das hier beschriebene Dokument diente - wird in Opus nicht erfasst...
#$output .= "      <dcterms:source xsi:type=\"dcterms:URI\">".$volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus]."/</dcterms:source>\n"; # URL auf OPUS
#for ($t = 0; $orig[$t]; $t++) {
	#$output .= "      <dcterms:source xsi:type=\"dcterms:URI\">".$volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus]."/original/".$orig[$t]."</dcterms:source>\n"; # URL zum Originalformat der Dissertation
#}

// XMetaDiss < 1.3
//$output .= "      <dc:language xsi:type=\"dcterms:ISO639-2\" lang=\"".utf8_encode($record[language])."\"/>\n"; # Sprache der Dissertation
// Ab XMetaDiss 1.3
$output .= "      <dc:language xsi:type=\"dcterms:ISO639-2\">".utf8_encode($record[language])."</dc:language>\n"; # Sprache der Dissertation


$output .= "      <dc:rights xsi:type=\"ddb:noScheme\">".utf8_encode($dc_rights)."</dc:rights>\n"; # Copyright-Regelungen

if ($bereich_id > 1) {
	$output .= "      <dcterms:accessRights xsi:type=\"ddb:access\" ddb:type=\"noScheme\" ddb:kind=\"domain\">".utf8_encode($bereich)."</dcterms:accessRights>\n"; # Regelung Zugriffsrechte
}


# Naehere Beschreibung der konkreten Disseratation
$output .= "      <thesis:degree>\n"; #  Infos zum akademischen Grad und der Vergabeinstitution

# Bislang nur Doktorarbeiten und Habilitationen
if ($record[type] == 8) $level = "thesis.doctoral";
if ($record[type] == 24) $level = "thesis.habilitation";
$output .= "      	<thesis:level>".$level."</thesis:level>\n"; #  Infos zum akademischen Grad und der Vergabeinstitution
/* Andere Werte fuer thesis:level:
bachelor
master
post-doctoral
other
*/
$tcheck = $db->query("SELECT * FROM faculty_$la WHERE nr = ".$record[publisher_faculty]);   
if (DB::isError($tcheck)) {
	die ($tcheck->getMessage());
}
$tnum = $tcheck->numRows();
$trecord = $tcheck->fetchRow(DB_FETCHMODE_ASSOC);
$output .= "      	<thesis:grantor xsi:type=\"cc:Corporate\">\n"; #  Titelvergebende Stelle
$output .= "      		<cc:universityOrInstitution>\n"; #  Uni
$output .= "      			<cc:name>".utf8_encode($univName)."</cc:name>\n"; # Name der titelvergebenden Stelle
$output .= "      			<cc:place>".utf8_encode($univOrt)."</cc:place>\n"; # Ort der titelvergebenden Stelle
if ($tnum > 0) {
$output .= " 	     		<cc:department>\n"; #  Uni
$output .= "    	  			<cc:name>".utf8_encode($trecord[fakultaet])."</cc:name>\n"; # Name der titelvergebenden Stelle (Arbeitsbereich)
$output .= "      			</cc:department>\n"; #  Ende Uni
}
$output .= "      		</cc:universityOrInstitution>\n"; #  Ende Uni
$output .= "      	</thesis:grantor>\n"; #  Ende Titelvergebende Stelle
$output .= "      </thesis:degree>\n"; #  Ende Infos zum akademischen Grad und der Vergabeinstitution

# Dateiinfos raussuchen
$p = $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus];
$dh = opendir($p);
$anz = 0;
$anz_orig = 0;
$datei = array();
$komppfad = array();
$originaldatei = array();
$komporigpfad = array();
$dateityp = array();
$komporigurl = array();
$noarchiv = 0;
while ($file = readdir($dh)) {
	if (is_dir($p."/".$file) && $file != "." && $file != ".." && $file != "original") {
		$format = $file;
		$p2 = $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/".$file;
		$dh2 = opendir($p2);
		while ($file2 = readdir($dh2)) {
			if (is_file($p2."/".$file2) && $file2 != "." && $file2 != "..") {
				$datei[$anz] = $file2;
				$komppfad[$anz] = $p2."/".$file2;
				$anz++;
			}
		}
		closedir($dh2);
	}
	else if ($file == "original" && $xmetadiss_orig) {
		$origpfad = $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/".$file;
		$dh2 = opendir($origpfad);
		while ($file2 = readdir($dh2)) {
			if (is_file($origpfad."/".$file2) && $file2 != "." && $file2 != "..") {
				$filetype = split("\.", $file2);
				$dateityp = strtolower($filetype[count($filetype)-1]);
				if ($dateityp == "xml" || $dateityp == "sgm" || $dateityp == "sgml" || $dateityp == "htm" || $dateityp == "html" || $dateityp == "tex" || $dateityp == "txt") {
					$originaldatei[$anz_orig] = $file2;
					$komporigpfad[$anz_orig] = $origpfad."/".$file2;
					$dateityp[$anz_orig] = strtolower($filetype[count($filetype)-1]);
					$anz_orig++;
					$anz++;
				}
				else {
					$komporigurl[$noarchiv] = $volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus]."/original/".$file2;
					$noarchiv++;
				}
			}
		}
		closedir($dh2);
	}
}
closedir($dh);
$praes_arch = false;
#echo $anz_orig;

# Vorhandene Archivdateien loeschen
if ($xmetadiss_orig) {
	@unlink ($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/container.tgz");
	@unlink ($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/praesentation.tgz");
	@unlink ($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/original.tgz");
}

// Wenn vorhanden und im richtigen Format werden die Originaldateien gepackt
// anerkannte Formate fuer das Quellformat sind XML, SGML, HTML, TEX, TXT u.a. Klartextformate
if ($anz_orig > 0 && $xmetadiss_orig) {
	/*
	if (file_exists($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/container.tgz")) {
		rename($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/container.tgz", $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/praesentation.tgz");
	}
	else {*/
	# OM 29.04.05: container.tgz wird auf jeden Fall geloescht (s.o.) und anschliessend neu gebaut
	
	$praestar = new Archive_Tar($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/praesentation.tgz", "gz");
	$praestar->addModify($komppfad, ".", $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/".$format);
	#}

	$praes_arch = true;

	$origtar = new Archive_Tar($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/original.tgz", "gz");
	for ($x = 0; $x <= $anz_orig; $x++) {
		$origtar->addString($originaldatei[$x], $komporigpfad[$x]);
	}

	$gesamttar = new Archive_Tar($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/container.tgz", "gz");
	$gesamttar->addModify(array($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/original.tgz",$volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/praesentation.tgz"), ".",  $volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]);
	// Die beiden neuen Dateien muessen eingetragen werden!
	$anz = $anz+2;
}

# Technische und administrative Daten
$output .= "      <ddb:contact ddb:contactID=\"".$ddb_idn."\"/>\n"; #  Publikations-Organ ID bei der DDB
$output .= "      <ddb:fileNumber>".$anz."</ddb:fileNumber>\n"; #  Anzahl Dateien dieses Dokumentes
for ($i = 0; $datei[$i]; $i++) {
	$output .= "      <ddb:fileProperties ddb:fileName=\"".utf8_encode($datei[$i])."\" ddb:fileID=\"file".$record[source_opus]."-".$i."\" ddb:fileSize=\"".filesize($komppfad[$i])."\" ddb:fileDirectory=\"/\">aus: Praesentationsformat</ddb:fileProperties>\n"; #  Naehere Beschreibung jeder einzelnen Datei
}
for ($i = 0; $originaldatei[$i]; $i++) {
	$output .= "      <ddb:fileProperties ddb:fileName=\"".utf8_encode($originaldatei[$i])."\" ddb:fileID=\"file".$record[source_opus]."-orig".$i."\" ddb:fileSize=\"".filesize($komporigpfad[$i])."\" ddb:fileDirectory=\"/\">aus: Originalformat</ddb:fileProperties>\n"; #  Naehere Beschreibung jeder einzelnen Datei
}

//Hier die tgz-Dateien hin!
if ($praes_arch) {
	$output .= "      <ddb:fileProperties ddb:fileName=\"praesentation.tgz\" ddb:fileID=\"praesentationsformat".$record[source_opus]."\" ddb:fileSize=\"".filesize($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/praesentation.tgz")."\" ddb:fileDirectory=\"/\">Archiv Praesentationsformat</ddb:fileProperties>\n"; #  FileProperties fuer das Praesentationsformat
	$output .= "      <ddb:fileProperties ddb:fileName=\"original.tgz\" ddb:fileID=\"originalformat".$record[source_opus]."\" ddb:fileSize=\"".filesize($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/original.tgz")."\" ddb:fileDirectory=\"/\">Archiv Quellformat</ddb:fileProperties>\n"; #  FileProperties fuer das Quellformat
	$output .= "      <ddb:transfer ddb:type=\"dcterms:URI\">".$volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus]."/container.tgz</ddb:transfer>\n"; #  Soll verwendet werden, wenn mehrere Dateien uebermittelt werden sollen - dabei ist auch notwendig, dass ein einziges Archiv der zu uebermittelnden Dateien bereitgestellt wird, das dann unter dieser Adresse erreichbar ist
}

if ($anz > 1 && !$xmetadiss_orig) {
	if (file_exists($volltext_pfad."/".date("Y", $record[date_creation])."/".$record[source_opus]."/container.tgz")) {
		$output .= "      <ddb:transfer ddb:type=\"dcterms:URI\">".utf8_encode($volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus])."/container.tgz</ddb:transfer>\n"; #  Soll verwendet werden, wenn mehrere Dateien uebermittelt werden sollen - dabei ist auch notwendig, dass ein einziges Archiv der zu uebermittelnden Dateien bereitgestellt wird, das dann unter dieser Adresse erreichbar ist
	}
}

$output .= "      <ddb:identifier ddb:type=\"URL\">".utf8_encode($volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus])."/</ddb:identifier>\n"; #  Haupt-URL

#if ($anz > 1) {
#	$output .= "      <ddb:identifier ddb:type=\"URL\">".utf8_encode($volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus])."/</ddb:identifier>\n"; #  Haupt-URL
#}
#else {
#	$output .= "      <ddb:identifier ddb:type=\"URL\">".utf8_encode($volltext_url."/".date("Y", $record[date_creation])."/".$record[source_opus]."/".$f[0]."/".$datei[0])."</ddb:identifier>\n"; #  Haupt-URL
#}

if ($bereich_id == 1) {
	$output .= "      <ddb:rights ddb:kind=\"free\"/>\n"; # keine Zugriffsbeschraenkung
}
else {
	 $output .= "      <ddb:rights ddb:kind=\"domain\">".utf8_encode($bereich)."</ddb:rights>\n"; # Zugriffsbeschraenkung
}


// Here, no changes need to be done
$output .=           
'     </'.$prefix;
if (isset($METADATAFORMATS[$prefix]['record_prefix'])) {
	$output .= ':'.$METADATAFORMATS[$prefix]['record_prefix'];
}
$output .= ">\n";
$output .= 
'   </metadata>'."\n";

//if ($encoding == "UTF-8") $output = utf8_encode($output);
?>
