<?php
require("pod_util.php");
include("../lib/class.configFile.php");
$conf = new configFile ("../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");

include ("../lib/class.opus_$dbms.$php");
$opus = new opus;

$db = $conf->value("db");
$url = $conf->value("url");
$doku_pfad = $conf->value("doku_pfad");
$lic_active = $conf->value("license_active");
$pod_active = $conf->value("pod_active");
$pod_checklevel = $conf->value("pod_checklevel");
$pod_days_old = $conf->value("pod_days_old");
/**************************************************************************************************/
/* Ueberpruefung auf POD-Tauglichkeit der Publikation.                                            */
/* Jedes hoehere Level enthaelt auch die vorherigen Checks                                        */
/* 0: kein                                                                                        */
/* 1: check, if lic_active                                                                        */
/* 2: check, if pod_active                                                                        */
/* 3: check, if license allows Print-on-Demand                                                    */
/* 4: check, wether publication consists of _one_ pdf                                             */
/* 5: check, wether pdf is not encrypted and printable (onyl performed, if pdfinfo_active = 1     */
/* 6: check, wether publication was published at least pod_days_old days before                   */
/**************************************************************************************************/
$pp_name = $conf->value("pod_partner");
$pp_url = $conf->value("pod_partner_url");
$pp_icon = $conf->value("pod_partner_icon");
$pdfinfo_active = $conf->value("pdfinfo_active");
$pdfinfo = $conf->value("pdfinfo_path"); // Programm, das Infos zur PDF-Datei ausgibt
$marks = $conf->value("pdfinfo_marks"); // diese Angabe in der Konf-Datei enthaelt Merkmale, nach denen zu suchen ist, getrennt durch *
$volltext_url = $conf->value(volltext_url);
$volltext_pfad= $conf->value(volltext_pfad);

include ("../lib/stringValidation.php");
$urn = $_REQUEST['urn'];
$urn = eregi_replace("[`\n\r]","",$urn);
$docurl = $_REQUEST['docurl'];
$docurl = eregi_replace("[`\n\r]","",$docurl);
$lic = $_REQUEST['lic'];
$lic = eregi_replace("[`\n\r]","",$lic);
$aut = $_REQUEST['aut'];
$aut = eregi_replace("[`\n\r]","",$aut);
$tit = $_REQUEST['tit'];
$tit = eregi_replace("[`\n\r]","",$tit);
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# A.Maile 29.7.05: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}

# A. Maile, 29.7.05 Texte aus Textdatei in Programmvariablen füllen
$texte = new configFile ("../texte/$la/pod.conf");
$titel = $texte->value("titel");
$ueberschrift = $texte->value("ueberschrift");

# Annette Maile, 29.7.05 Design aus lib/design.php einlesen
require ("../lib/design.$php");
$design = new design;
$design->head_titel($titel);
$design->head_javascript();
$design->head_ueberschrift($ueberschrift, $la);

print("<FONT COLOR=red>");
$sock = $opus->connect();
if ($sock < 0 ) {
        echo ("Error: $ERRMSG\n");
        }
if ($opus->select_db($db) < 0 ) {
        echo ("Error: $ERRMSG\n");
        }
print("</FONT>");

$par = "<small><hr>".urldecode($urn)."<br>".urldecode($docurl)."<br>".$lic."<br>".stripslashes(rawurldecode($aut))."<br>".stripslashes(rawurldecode($tit))."<hr></small>\n";
$pod_active = 1;
$err = 0;

/* Checklevel 1 */
if ( $pod_checklevel > 0 ) {
  if ( $lic_active == 0 ) {
    $err = 1;
    $errmsg = "Lizenz-Modul nicht aktiviert.";
  }
}
/* Checklevel 2 */
if ( $pod_checklevel > 1 ) {
  //if ( $err == 0 ) {     echo "liz ok.<hr>"; }
  if ( $pod_active == 0 ) {
    $err = 1;
    $errmsg = "Print-on-Demand-Modul nicht aktiviert.";
  }
}
/* Checklevel 3 */
if ( $pod_checklevel > 2 ) {
  //if ( $err == 0 ) {     echo "pod ok.<hr>"; }
  if ( !(check_params($urn, $url, $lic, $aut, $tit)) ) {
    $err = 1;
    $errmsg = "Uebergebene Parameter sind nicht korrekt.".$par."<hr>";
  }
}
/* Checklevel 4 */
if ( $pod_checklevel > 3 ) {
  //if ( $err == 0 ) {     echo "params ok.<hr>"; }
  $licsql = "SELECT pod_allowed from license_$la where shortname = '".$lic."'";
  $licres = $opus->query($licsql);
  $licnum = $opus->num_rows($licres);
  if ($licnum == 1) {
    $licrow = $opus->fetch_row($licres);
    if ( $licrow[0] != 1 ) {
        $err = 1;
        $errmsg = "<p>Das angeforderte Dokument hat keine Lizenz mit POD-Erlaubnis (".$lic.": pod_allowed=".$licrow[0].").</p>";
    }
  } else {
    $err = 1;
    $errmsg = "Dokument hat KEINE Lizenz (".$lic.") - Feld lic ist leer).";
  }
  $opus->free_result($licres);
}
/* Checklevel 5 */
if ( ( $pod_checklevel > 4 ) AND ( $pdfinfo_active ) ) {
  //if ($err == 0 ) {echo "dok-lizenz ok.<hr>";}
  $this_pdf = check_pdf($docurl);
  //echo $this_pdf;
  if ( !$this_pdf ) {
    $err = 1;
    $errmsg = "<p>Die angeforderte Publikation liegt nicht im PDF-Format vor oder besteht NICHT aus genau einem PDF.</p>";
  } else {
    $tmp_pdf = str_replace($volltext_url, $volltext_pfad, $this_pdf);
    if ( !(check_printable($tmp_pdf, $pdfinfo, $marks)) ) {
	$err = 1;
	$errmsg = "<p>Die PDF-Datei ist verschluesselt bzw. nicht druckbar</p>";
    }
  }
}

/* Checklevel 6 */
if ( $pod_checklevel > 5 ) {
  $daysql = "SELECT source_opus, TO_DAYS(NOW()) - TO_DAYS(from_unixtime(date_creation)) as days_old";
  $daysql.= " FROM opus where urn = '".urldecode($urn)."'";
  $dayres = $opus->query($daysql);
  $daynum = $opus->num_rows($dayres);
  if ($daynum == 1) {
    $dayrow = $opus->fetch_row($dayres);
    $this_days_old = $dayrow[1];
  }
  if ( $this_days_old < $pod_days_old ) {
    $err = 1;
    $pod_again = $pod_days_old - $this_days_old;
    if ( $this_days_old == 0 ) { 
	$msg_old = "erst heute";
    } elseif ( $this_days_old == 1 ) {
	$msg_old = "gestern";
    } else {
	$msg_old = "vor ".$this_days_old." Tagen";
    }
    $errmsg = "<p>Die Publikation wurde ".$msg_old." ver&ouml;ffentlicht und ist noch nicht bei ".$pp_name." verf&uuml;gbar.</p>";
    $errmsg.= "<p>Bitte bestellen Sie sie in ca. ".$pod_again." Tagen erneut.</p>";
  }
}

if ( ( $err == 0 ) OR ( $pod_checklevel == 0 ) ) {
	    print("
		<form name=\"go_on\" method=\"post\" action=\"".$pp_url."\">
		<ul>
		<li>&Uuml;ber unseren Partner ".$pp_name." k&ouml;nnen Sie hier eine kostenpflichtige, gedruckte und gebundene Ausgabe dieser Publikation bestellen.</li>
		<li>Bitte &uuml;berpr&uuml;fen Sie noch einmal die Angaben und lesen Sie bei Bedarf die unten angegebenen Hinweise.</li>
		<li>Mit einem Klick verlassen Sie die Webseiten von Tobias-lib und gehen weiter zur Bestellung.</li>
		<p />
	    ");
	    print("<table class=\"infobox\" width=\"60%\">
		<tr><td class=\"info\">");
//	    print("<p><strong>".$aut."</strong>: ".stripslashes(rawurldecode($tit))."<br>".urldecode($docurl)."</p>\n");
	    print("<p><strong>".stripslashes(rawurldecode($aut))."</strong>: ".($tit)."<br>".($docurl)."</p>\n");
	    print("
		</td></tr>
		<tr><td align=\"center\">
		<a href=\"".$pp_url.urlencode($urn)."\" target=\"_blank\"><img src=\"".$pp_icon."\" border=\"0\" alt=\"Weiter zur Bestellung\"></a>
		</td></tr>
		<!--
		<tr><td align=\"center\">
		<input type=\"hidden\" name=\"oaiid\" value=\"".urlencode($urn)."\">
		<input type=\"submit\" name=\"order_pp\" value=\"Weiter zur Bestellung\">
		</td></tr>
		-->
		</table><p />
		</<li>
		</ul>
		</form>
	    ");
	    print("<ul>
		<li>
		Eine Bestellung in ".$pp_name." ist kostenpflichtig.<br>
		Die Preise richten sich nach den in Copyshops und Druckereien &uuml;blichen Tarifen.<br>
		Beispiel: Die Druckausgabe einer 100-seitigen Publikation (nur schwarz/weiss, DIN A5) wird mit ca. 10 Euro zu Buche schlagen.<br>
		Die genauen Preise werden Ihnen beim Bestellvorgang angezeigt oder Sie entnehmen sie aus den AGB von ".$pp_name.".
		</li>
        <li>
        Sie k&ouml;nnen sich das bestellte Dokument entweder liefern lassen, oder bei einem Druckdienstleister vor Ort (sofern verf&uuml;gbar) abholen.
        </li>
		<li>
		Die Universit&auml;tsbibliothek T&uuml;bingen stellt dieses Dokument mit Einwilligung des Autors / der Autorin zur Verf&uuml;gung.
		Die Herstellung eines Print-on-Demand-Exemplars darf nur &uuml;ber diesen Weg erfolgen.
		</li>
		<li>Weder die Universit&auml;tsbibliothek T&uuml;bingen noch ".$pp_name." verfolgen mit diesem Angebot kommerzielle Interessen.</li>
		<li>Sollten Sie nach Klick auf den &quot;Bestellen-Button&quot; eine <strong>Fehlermeldung</strong> erhalten,
		so kann &uuml;ber ".$pp_name." leider kein gedrucktes Exemplar hergestellt werden.<br>
		In diesen Ausnahmef&auml;llen liegt entweder ein brandaktuelle Publikation vor: 
		bitte versuchen Sie dann die Bestellung in 2 Tagen noch einmal.<br>
		Oder es verhindern technische Gr&uuml;nde den Druck (mehrteilige oder multimediale Dokumente, 
		Dokumente die nicht als PDF vorliegen oder &auml;hnliches). 
		</li>
	    </ul>");
} else {
        /* Checking the publication according to the pod_checklevel recognized problems: no print-on-demand-copy can be ordered, see error-message */
    	print("<table class=\"infobox\" width=\"60%\">
		<tr><td class=\"info\">
	    ");
	    print("<p><strong>".$aut."</strong>: ".$tit."<br>".$docurl."</p>\n");
	    print("
		</td></tr>
		</table>
		<p>
		<table class=\"info\" width=\"80%\">
		<tr><td>
		<strong>".$errmsg."</strong>
		</td></tr>
		<tr><td>
		Es kann zur Zeit leider <strong>kein Print-on-Demand-Exemplar</strong> dieser Publikation bestellt werden.
		Bitte wenden Sie sich an TOBIAS-lib, wenn Sie meinen, dass hier ein Fehler vorliegt.
		</tr></td>
		</table>
	    ");
}

$design->foot("pod.$php", $la);
?>
