<?php

function check_params($urn, $url, $lic, $aut, $tit) {
    /* Checks if we get an URL, URN, title and license (no author is ok) */
    if ( strlen($urn) > 0 ) { $ok = 1; }
    if ( strlen($url) > 0 ) { $ok = 1; }
    if ( strlen($lic) > 0 ) { $ok = 1; }
    if ( strlen($tit) > 0 ) { $ok = 1; }
    if ( $ok == 1 ) {
        return true;
    } else {
	return false;
    }
}

function check_podable($lic) {
    /* Checks, if the given license allows print-on-demand-copies */
    $licsql = "SELECT pod_allowed from license where shortname = '".$lic."'";
    $licres = $opus->query($licsql);
    $licnum = $opus->num_rows($licres);
    $opus->free_result($licres);
    if ($licnum == 1) {
	if ( $licres[0] == 1 ) {
	    return true;
	} else {
	    return false;
	}
    } else {
	return false;
    }
}

function check_pdf($index) {
    /* Gets an URL to an opus document directory and returns the name of the document file(s) if in format pdf. */
    /* Returns 0 if there is no pdf-file (or if pdf among other formats).                                       */
    /* Returns number of pdfs if more than one pdf-file. Returns -1 on error.                                   */
    if ( !$index ) { return "-1"; }
    if ( substr($index, -1) != "/" ) { // add a slash if needed
        $index_path=$index."/"; 
    } else {
        $index_path=$index; 	    
    }
    $find_begin=$index; // string that marks the appropriate (to find) line. this string can also be the directory, that has been fed to this function
    //$find_begin="^<td><a href=\"".$index; // regular expressions are possible, heres an example.
    $find_end=".pdf\">"; // string that marks the end of the line-chunk that we want to find
    $index_end=".pdf"; //extension of the filename(s) to find
    $index_name="index.html"; // name of the html-file, that represents an index (frontdoor, virtual frontpage) to a document in opus
    $j=0; $i=0;
    $index_file=$index_path.$index_name; // full name of indexfile
    $file_handle=@fopen($index_file, "r"); // open indexfile for reading
    if ( !$file_handle ) { // if open fails, return with error
        return "-1";
    }
    while (!feof($file_handle)) { // parse through index line by line
    	$line = fgets($file_handle, 4096);	    
	$gotit=ereg($find_begin, $line); // check if $find_begin is in the current line
	if ( $gotit ) {
	    $start=strpos($line, $index_path); // $find_begin found. now detect exact starting position of the filename that we have to find
	    if ( $start > -1 ) {
		$i++;
		$stop=strpos(strtolower($line), strtolower($find_end)); // check if $find_end is in the current line, detect position
		if ( $stop > -1 ) {
    		    $file_pdf[($j)]=substr($line, $start, ($stop-($start)+(strlen($index_end)))); // copy filename out of line and write it to an array				
		    $j++;
		}
	    }
	}
    }
    fclose ($file_handle);
    if ( $j == 0 ) { return false; }           // no element in array. no pdf-filename has been found. document is non-pdf
    if ( $j == 1 ) { return $file_pdf[0]; }  // one and only one element (pdf-filename) in array.
    if ( $j > 1 )  { return false; }           // more than one filename found. return "0".
}

function check_printable($pdf, $pdfinfo, $marks) {
/* Executes pdfinfo on pdf, checks if output contains marks                    */
/* marks contains strings, that characterize a not printable pdf in the output */
    $exe = $pdfinfo." ".escapeshellarg($pdf);
    unset($output);
    exec($exe, $output, $return_var);
    if ($return_var == 0) {
	  for ($p=0; $p <= count($output); $p++ ) { // checkt alle Ausgabezeilen von pdfinfo
	    $line = $output[$p];
	    $mark = strtok($marks, "*"); // holt erstes Merkmal fuer NICHT-pod-faehigkeit
	    while ($mark) {
          $findme = stristr($line, $mark);
		  if ( strlen($findme) > 0 ) {
		    return false; // GEFUNDEN, dieses PDF ist nicht pod-faehig, return false !!
		  } else {
		    $mark = strtok("*");  // naechstes Merkmal holen
		  }
	    }
	  }
    } else {
	  return false; // Fehler beim Ausfuehren
    }
    return true;
}

function check_printable_verbose($pdf, $pdfinfo, $marks) {
/* Executes pdfinfo on pdf, checks if output contains marks                       */
/* marks contains strings, that characterize a not printable pdf in the output    */
/* More information in return-value, than function check_printable                */
    $exe = $pdfinfo." ".escapeshellarg($pdf);
    unset($output);
    exec($exe, $output, $return_var);
    if ($return_var == 0) {
	$found = 0;
	for ($p=0; $p <= count($output); $p++ ) { // checkt alle Ausgabezeilen von pdfinfo
	    $line = $output[$p];
	    $mark = strtok($marks, "*"); // holt erstes Merkmal fuer NICHT-pod-faehigkeit
	    while ($mark) {
          $findme = stristr($line, $mark);
		  if ( strlen($findme) > 0 ) {
		    $erg.= "Gesucht in &quot;".$line."&quot; nach &quot;".$mark."&quot;: GEFUNDEN.<br>";
		    $found++;		    //return false; // GEFUNDEN, dieses PDF ist nicht pod-faehig, return false !!
		  } else {
		    $erg.= "Gesucht in: &quot;".$line."&quot;<br>"; // nach &quot;".$mark."&quot;: nicht enthalten.<br>";
		  }
          $mark = (strtok("*"));  // naechstes Merkmal holen
	    }

	}
    } else {
	  $erg.= "pdfinfo konnte nicht fehlerfrei ausgefuehrt werden";
	  return false;
    }
      return $found.$erg; // Liefert einen String zurueck. Enthaelt dieser als ersten Buchstaben eine 0, 
                          // dann ein Merkmal gefunden, Wert > 1: Anzahl der Treffer. 
                          // Keine Zahl->Kein Treffer
                          // false: Fehler beim Ausfuerhen 
}

?>

