<?
#############################################################
#
# Funktion: uni/publikationen_report.php
#
# letzte Aenderung
# 09.03.2007, Tobias Leidinger, SULB Saarbruecken
# Einfuehrung der Mehrsprachigkeit (Variable $la)
# Textdatei: texte/$la/uni/uni_index.conf
#
#############################################################

require("../../lib/class.configFile.php");
$conf = new configFile ("../../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");
$db = $conf->value("db");
$url = $conf->value("url");
$doku_pfad = $conf->value("doku_pfad");
$projekt = $conf->value("projekt");
$mehrsprachig = $conf->value("mehrsprachig");

include ("../../lib/class.opus_$dbms.$php");
$opus = new opus;


include ("../../lib/stringValidation.php");
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# BDressler, 8.7.04: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}

# O. Marahrens Automatisch alle Texte aus der Textdatei holen
$texte = new configFile ("../../texte/$la/report/publikationen_report.conf");
foreach ($texte->config_values as $k => $v) {
    $$k = $v;
}

# T. Leidinger, 06.03.2007 - bergebene Parameter prfen
$nummer_institut = $_REQUEST ["nummer_institut"];
#Wenn nur 4 Stellen dann ist es eine Nummer einer Fachrichtung ansonsten Institut
if (strlen($nummer_institut) == 4) {
        $fachr= true;
        } else {
        $fachr= false;
        }
$jahr = $_REQUEST ["jahr"];
$f_radio = $_REQUEST ["f_radio"];

if (!isset($_REQUEST ["type"])) {
	die($fehler1);
	}
else if ($f_radio == 'fachr_all') {  #Radiobutton alle Fachrichtungen markiert
          $fachr_all = true;
     } else if ($f_radio == 'inst_all') {  #Radiobutton alle Institute markiert
          $inst_all = true;
     } else if ($nummer_institut == 0 || $nummer_institut == "") {
	  die($fehler2);
     }
else if (!is_numeric($jahr) || $jahr <=0 ) {
	die($fehler3);
}
$type = $_REQUEST ["type"];
$print = $_REQUEST ["print"];


# Datenbank ffnen
$sock = $opus->connect();
if ($sock < 0 ) {
        echo ("Error: $ERRMSG\n");
        }
if ($opus->select_db($db) < 0 ) {
        echo ("Error: $ERRMSG\n");
        }

# t. leidinger, 08.03.2007 - Abfragen ob alle Institute oder alle Fachrichtungen angezeigt werden sollen
#                            wenn ja dann werden die Nummern im Array $nummer_inst gespeichert
if ($fachr_all) {
  $fachr = true;
  $res = $opus->query ("SELECT nr, fakultaet FROM faculty_$la ORDER BY nr");
  $anz = $opus->num_rows($res);
  $i = 0;
  while($i<$anz) {
    $i++;
    $mrow = $opus->fetch_row($res);
    $nummer_inst[] = $mrow;
  }
  $opus->free_result($res);

} else if ($inst_all) {
  $fachr = false;
  $res = $opus->query ("SELECT nr, name FROM institute_$la ORDER BY nr");
  $anz = $opus->num_rows($res);
  $i = 0;
  while($i<$anz) {
    $i++;
    $mrow = $opus->fetch_row($res);
    $nummer_inst[] = $mrow;
  }
  $opus->free_result($res);
} else {
  #Fakultt oder Fachrichtung auswhlen
  if ($fachr) {
      $res = $opus->query ("SELECT fakultaet FROM faculty_$la WHERE nr = $nummer_institut");
  } else {
      $res = $opus->query ("SELECT name FROM institute_$la WHERE nr = $nummer_institut");
  }
  $mrow = $opus->fetch_row($res);
  $fak = $mrow[0];
  $opus->free_result($res);
  $nummer_inst[] = array($nummer_institut,$fak);
}


# T. Leidinger, 06.03.2007 - PDF erzeugen und ausgeben falls Druck ausgewhlt
#                            ansonsten HTML-Grundgerst
#                            (bei Option Druck darf pas du tout html-Code an den Browser geschickt werden)
if ($print=="ja") {
    require("publikationen_drucken.php");  # Doku zur fpdf-lib unter www.fpdf.de
    $pdf=new PDF();
} else {
# Annette Maile, 17.3.05 Design aus lib/design.php einlesen
require ("../../lib/design.$php");
$design = new design;
$design->head_titel($titel);
$design->head_ueberschrift($ueberschrift, $la);

# Button fuer Anzeige des Skripts in weiteren Sprachen,
# falls mehrere Sprachen angeboten werden.
if ($mehrsprachig == 1) {
        $design->andere_sprache($la);
}
}

# T. Leidinger, 09.03.2007 - in der Schleife werden alle Instituts-/ Fachrichtungsnummern abgearbeitet
#                            falls nur ein Institut mit der Combobox ausgewhlt wurde hat $nummer_inst die Lnge 1

foreach($nummer_inst as $nummer_institut_row) {
#$data vor jedem Schleifendurchlauf zurcksetzen, da in $data die aktuellen Tabellendaten gespeichert werden
unset($data);
$nummer_institut = $nummer_institut_row[0];  //Institutsnummer
$fak = $nummer_institut_row[1];              //Institutsbezeichnung (spart jeweilige Datenbankabfrage)
$res = $opus->query ("SELECT typeid, dokumentart FROM resource_type_$la order by dokumentart");
$num = $opus->num_rows($res);

$i = 0;
$summe = 0;

# T. Leidinger, 06.03.2007 - zu jeweiliger Dokumentart Anzahl ermitteln + Summe errechnen
while ($i < $num) {
		$i++;
	        $mrow = $opus->fetch_row($res);
                 if (in_array($mrow[0],$type)) {
         		if ($fachr) {
                          $res_anz = $opus->query ("SELECT o.source_opus 
                                                    FROM opus AS o, opus_inst AS i 
                                                    WHERE o.type = $mrow[0] 
                                                          AND o.date_year = $jahr 
                                                          AND SUBSTRING(i.inst_nr,1,4) = $nummer_institut 
                                                          AND o.source_opus = i.source_opus 
                                                    ORDER BY source_opus");
                        } else {
                          $res_anz = $opus->query ("SELECT o.source_opus 
                                                    FROM opus AS o, opus_inst AS i 
                                                    WHERE o.type = $mrow[0] 
                                                          AND o.date_year = $jahr 
                                                          AND i.inst_nr = $nummer_institut 
                                                          AND o.source_opus = i.source_opus 
                                                    ORDER BY source_opus");
                        }
	                $wert = $mrow[1];
		        $anz = $opus->num_rows($res_anz);
                        $opus->free_result($res_anz);
                        $data[]=array($wert,$anz);
                         $summe += $anz;
                    	}
		}
$opus->free_result($res);


# t.leidinger, 08.03.2007 - auch in der Schleife entweder pdf oder html
if ($print=="ja") {
    $pdf->AddPage();  //neue Seite erzeugen
    $pdf->Table("$fak [$jahr]",$data);  //Tabelle erstellen und ausfllen
} else {
print ("<hr style=\"height:1px;\">\n");
print ("<b>$fak  [$jahr]</b>\n");   // berschrift
#T. Leidinger, 09.03.2007 - HTML-Tabelle erstellen
print('<table style="border: solid 1px; border-collapse : collapse">');

foreach ($data as $mrow) {
print('<tr><td style="border-bottom: solid 1px;">'.$mrow[0].'</td><td style="border-bottom: solid 1px; text-align:right;">'.$mrow[1].'</td></tr>');
}

print("<tr><td></td><td>Summe: $summe</td></tr>");
print("</table>");
print("<br><br>");
}
#
}
if ($print=="ja") {
    $pdf->Output();   // pdf-Datei erzeugen
} else {
    $design->foot("publikation_report.$php", $la);  // oder HTML-Fuzeile ausgeben
}
?>