<?
#############################################################
#
# Funktion: uni/publikationen_report.php
#
# letzte Aenderung
# 12.7.2004, Birgit Dressler, SULB Saarbruecken
# Einfuehrung der Mehrsprachigkeit (Variable $la)
# Textdatei: texte/$la/uni/uni_index.conf
#
#############################################################

require("../../lib/class.configFile.php");
$conf = new configFile ("../../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");
$db = $conf->value("db");
$url = $conf->value("url");
$doku_pfad = $conf->value("doku_pfad");
$projekt = $conf->value("projekt");
$mehrsprachig = $conf->value("mehrsprachig");

include ("../../lib/class.opus_$dbms.$php");
$opus = new opus;


/*

*/


include ("../../lib/stringValidation.php");
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# BDressler, 8.7.04: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}

# O. Marahrens Automatisch alle Texte aus der Textdatei holen
$texte = new configFile ("../../texte/$la/report/publikationen_report.conf");
foreach ($texte->config_values as $k => $v) {
    $$k = $v;
}

# T. Leidinger, 06.03.2007 - bergebene Parameter prfen
$nummer_institut = $_REQUEST ["nummer_institut"];
#Wenn nur 4 Stellen dann ist es eine Nummer einer Fachrichtung ansonsten Institut
if (strlen($nummer_institut) == 4) {
        $fachr= true;
        } else {
        $fachr= false;
        }
$jahr = $_REQUEST ["jahr"];
if (!isset($_REQUEST ["type"])) {
	die($fehler1);
	}
else if ($nummer_institut == 0 || $nummer_institut == "") {
	die($fehler2);
	}
else if (!is_numeric($jahr) || $jahr <=0 ) {
	die($fehler3);
}
$type = $_REQUEST ["type"];



# Datenbank ffnen
$sock = $opus->connect();
if ($sock < 0 ) {
        echo ("Error: $ERRMSG\n");
        }
if ($opus->select_db($db) < 0 ) {
        echo ("Error: $ERRMSG\n");
        }

#Fakultt oder Fachrichtung auswhlen
if ($fachr) {
    $res = $opus->query ("SELECT fakultaet FROM faculty_$la WHERE nr = $nummer_institut");
} else {
    $res = $opus->query ("SELECT name FROM institute_$la WHERE nr = $nummer_institut");
}
$mrow = $opus->fetch_row($res);
$fak = $mrow[0];
$opus->free_result($res);

$res = $opus->query ("SELECT typeid, dokumentart FROM resource_type_$la order by dokumentart");
$num = $opus->num_rows($res);

$i = 0;
$summe = 0;
while ($i < $num) {
		$i++;
	        $mrow = $opus->fetch_row($res);
                 if (in_array($mrow[0],$type)) {
			# T. Leidinger, 06.03.2007 - Jeweilige Anzahl ermitteln
         		if ($fachr) {
                          $res_anz = $opus->query ("SELECT o.source_opus 
                                                    FROM opus AS o, opus_inst AS i 
                                                    WHERE o.type = $mrow[0] 
                                                          AND o.date_year = $jahr 
                                                          AND SUBSTRING(i.inst_nr,1,4) = $nummer_institut 
                                                          AND o.source_opus = i.source_opus 
                                                    ORDER BY source_opus");
                        } else {
                          $res_anz = $opus->query ("SELECT o.source_opus 
                                                    FROM opus AS o, opus_inst AS i 
                                                    WHERE o.type = $mrow[0] 
                                                          AND o.date_year = $jahr 
                                                          AND i.inst_nr = $nummer_institut 
                                                          AND o.source_opus = i.source_opus 
                                                    ORDER BY source_opus");
                        }
	                $wert = $mrow[1];
		        $anz = $opus->num_rows($res_anz);
                        $opus->free_result($res_anz);
                        $data[]=array($wert,$anz);
                         # T. Leidinger, 06.03.2007 - Summe zwischenspeichern
                         $summe += $anz;
                    	}
		}
$opus->free_result($res);


# t.leidinger, 08.03.2007 - falls pdf erwnscht wird sie hier erzeugt, da dies geschehen muss, bevor Daten an den Browser geschickt wurden

if (isset($_POST['print'])) {
    require("publikationen_drucken.php");
# T. Leidinger, 06.03.2007 - PDF erzeugen und ausgeben
# Doku zur fpdf-lib unter www.fpdf.de
    $pdf=new PDF();
    $pdf->AddPage();
    $pdf->Table("$fak [$jahr]",$data);
    $pdf->Output();
} else {
# Annette Maile, 17.3.05 Design aus lib/design.php einlesen
require ("../../lib/design.$php");
$design = new design;
$design->head_titel($titel);
$design->head_ueberschrift($ueberschrift, $la);

# Button fuer Anzeige des Skripts in weiteren Sprachen,
# falls mehrere Sprachen angeboten werden.
if ($mehrsprachig == 1) {
        $design->andere_sprache($la);
}


#print ("<b>bersicht fr $fak im Jahr $jahr</b>\n");
print ("<hr>\n");
print('<table border="1">');


foreach ($data as $mrow) {
print("<tr><td>".$mrow[0]."</td><td style=\"text-align:right;\">".$mrow[1]."</td></tr>");
}


print("<tr><td></td><td>Summe: $summe</td></tr>");
print("</table>");

print("<br>");
# T. Leidinger, 06.03.2007 - Link zur PDF-Ausgabe erzeugen
/*print("<a href=\"publikationen_drucken.php?title=".
	        urlencode("$fak [$jahr]").
                "&data=".
                 urlencode($data).
                "\">Tabelle drucken</a>"
);*/


print("<br><br>");
$design->foot("publikation_report.$php", $la);
}
?>