<?php
###########################################################################
#
# 25.11.2004, Ulrich Herb, SULB Saarbruecken
#
# Php-Skript zur dynamischen Erstellung eines RSS-Feeds
# basierend auf newest.php (UB Tuebingen), d.h. angezeigt werden die 10 neuesten
# Veroeffentlichungen
#
# Die serverabhaengigen Daten werden aus lib/rss.conf gelesen, alles andere
# aus der mySql-Datenbank
#
###########################################################################

include ("../lib/class.configFile.php");

# UH, 25.11.04, Einlesen der Daten fuer RSS
$rconf = new configFile ("../lib/rss.conf");
$TITEL = $rconf->value("TITEL");
$LINK = $rconf->value("LINK");
$DESCRIPTION = $rconf->value("DESCRIPTION");
$COPYRIGHT = $rconf->value("COPYRIGHT");
$url = $rconf->value("url");
$imageurl = $rconf->value("imageurl");
$imagetitle = $rconf->value("imagetitle");
$imageserverurl = $rconf->value("imageserverurl");


$conf = new configFile ("../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");
include ("../lib/class.opus_$dbms.$php");
$opus = new opus;
$db = $conf->value("db");
$opustable = $conf->value("opus_table");
$opustable_autor="opus_autor";
$Lines_Displayed=10;

include ("../lib/stringValidation.php");
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# A.Maile 2.9.05: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}

$CONTENT_TYPE = 'Content-Type: text/xml';
header($CONTENT_TYPE);

print ("<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>\n");

print ("<rss version=\"2.0\">\n");
print ("<channel>\n");
print ("<title>$TITEL</title>\n");
print ("<link>$LINK</link>\n");
print ("<description>$DESCRIPTION</description>\n");
print ("<language>de-de</language>\n");
print ("<copyright>$COPYRIGHT</copyright>\n");
print ("<image>\n");
print ("<url>$imageurl</url>\n");
print ("<title>$imagetitle</title>\n");
print ("<link>$imageserverurl</link>\n");
print ("</image>\n\n");



$sock = $opus->connect();
if ( $sock < 0 ) {
	die("Error: $ERRMSG\n");
}
if ( $opus->select_db("$db")  < 0 ) {
	die("Error: $ERRMSG\n");
}
$sql ="SELECT o.source_opus, o.title, o.date_creation, r.dokumentart ";
$sql.="FROM opus AS o INNER JOIN resource_type_$la AS r ON o.type = r.typeid ";
//$sql.="ORDER  BY o.source_opus DESC ";
$sql.="ORDER BY o.date_creation DESC ";
$sql.="LIMIT ".$Lines_Displayed;
$res = $opus->query($sql);
$num = $opus->num_rows($res);

$i = 0;	$count = 1;
while ( $i < $num  ) {
    if ( $i % 2 == 0 ) {
	$class_now="erg_ger";
    } else {
	$class_now="erg_ung";
    }
    $i++;
    if ( $count <= $Lines_Displayed  ) {
	        $mrow = $opus->fetch_row($res);
	    	$count++;
		print("<item>\n");
		print("<title>");
		echo $titel = $mrow[1];
		print("</title>\n");


		$source_opus = $mrow[0];
		$date_creation = $mrow[2];
		$date_creation_format = strftime("%d.%m.%Y", $date_creation);
		$dok_art = $mrow[3];	$creator_name = "&nbsp;";
		$ausql="SELECT creator_name, reihenfolge from ".$opustable_autor." where source_opus=".$source_opus." ORDER BY reihenfolge";
		//echo $ausql;
		$autor = $opus->query($ausql);
		$num_autor = $opus->num_rows($autor);
		if ($num_autor > 0) {
			$mrow_autor = $opus->fetch_row($autor);
			$creator_name = $mrow_autor[0];
		}
		if ($num_autor > 1) {
			$creator_name = $creator_name . " et al.";
		}

		print( "<description>$dok_art</description>\n");
		print( "<link>$url/frontdoor.$php?source_opus=$source_opus</link>\n");
		$opus->free_result($autor);
		if ($creator_name == "") {
			$creator_name = "&nbsp;";
		}

               # Auskommentiert, da gemae Konvention in <author> eine Emailadresse enthalten sein muss
               # print( "<author>$creator_name</author>\n");
	       # Auskommentiert, da gemae Konvention in <pubdate> das Format RFC-822-kompatibel sein muss
               # print( "<pubDate>$date_creation_format</pubDate>");
                print("</item>\n" );
    }
}

print ("</channel>\n</rss>\n");
?>
