<?
#############################################################
# schriftenreihen.php - Browsen nach Schriftenreihen 
#
# letzte nderung:
# 18.3.2005, Annette Maile, UB Stuttgart
# Auslagerung Design in lib/design.php
# In Abhaengigkeit von $la kann das entsprechende Design eingelesen werden.
#
# 10.6.05, Annette Maile, UB Stuttgart
# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# in Abhaengigkeit der IP-Adresse des Nutzers und der
# Variablen $alle_doks_anzeigen wird die Suche generiert
#
# 21.9.2005, Annette Maile, UB Stuttgart
# Einfuehrung der Mehrsprachigkeit (Variable $la)
# Textdatei: texte/$la/schriftenreihen.conf
#
#############################################################

include ("../lib/class.configFile.php");
$conf = new configFile ("../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");

include ("../lib/class.opus_$dbms.$php");
$opus = new opus;

$db = $conf->value("db");
$opus_table = $conf->value("opus_table");
$url = $conf->value("url");
$table = $opus_table . "_schriftenreihe";
$schriftenreihe_alle_anzeigen = $conf->value("schriftenreihe_alle_anzeigen");
$alle_doks_anzeigen = $conf->value("alle_doks_anzeigen");

include ("../lib/stringValidation.php");
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# A.Maile, 18.03.05: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}

# A. Maile steht nun in der Textdatei
# $titel = $conf->value("titel_schriftenreihen_browsen");
# $ueberschrift = $conf->value("ueberschrift_schriftenreihen_browsen");

# A. Maile Texte aus Textdatei in Programmvariablen fllen
$texte = new configFile ("../texte/$la/schriftenreihen.conf");
$titel = $texte->value("titel");
$ueberschrift = $texte->value("ueberschrift");


# Annette Maile, 18.3.05 Design aus lib/design.php einlesen
require ("../lib/design.$php");
$design = new design;
$design->head_titel($titel);
$design->head_ueberschrift($ueberschrift, $la);

$sock = $opus->connect();
if ($sock < 0 ) {
        fatal ("Error: $ERRMSG\n");
}
if ($opus->select_db($db) < 0 ) {
        fatal ("Error: $ERRMSG\n");
}

# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# Es wird die IP des Nutzers ermittelt.
# Wenn alle_doks_anzeigen = 0 gesetzt ist:
# Es wird auf jeden Fall im Bereich 1 = freier Zugriff gesucht
# Falls in Altbestaenden (< Opus 3.0) kein Bereich angegeben ist,
# wird auch nach bereich_id = 0 und null gesucht
# Dann wird in der Tabelle ip_bereich nach den Bereichen gesucht,
# in deren IP-Range die IP liegt.
# Wenn alle_doks_anzeigen = 1 gesetzt ist:
# Es wird in allen Bereichen gesucht

$ip = $_SERVER['REMOTE_ADDR'];
if ($alle_doks_anzeigen == 0) {
        $bereichsgrenze = "(o.bereich_id = 1 or o.bereich_id = 0 or o.bereich_id is NULL";
        $res = $opus->query("SELECT bereich_id, ip_range FROM ip_bereich");
        $num = $opus->num_rows($res);
        if ($num > 0) {
                $i = 0;
                while ($i < $num) {
                        $mrow = $opus->fetch_row($res);
                        $bereich_id = $mrow[0];
                        $ip_range = $mrow[1];
                        if (ereg("^$ip_range", "$ip")) {
                                $bereichsgrenze = $bereichsgrenze . " OR o.bereich_id = $bereich_id";
                        }
                        $i++;
                }
                $opus->free_result($res);
                $bereichsgrenze = $bereichsgrenze . ")";
        }
}
else {
        # Es wird in allen Bereichen gesucht
        $bereichsgrenze = "(o.bereich_id is not null or o.bereich_id is null)";
}
# Ende Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche

$res = $opus->query ("SELECT * FROM schriftenreihen");
 
$num = $opus->num_rows($res);
if ($num > 0) {
	print("<UL> \n");
        $i = 0;
        while ($i < $num) {
                $i++;
                $mrow = $opus->fetch_row($res);
		$sr_id = $mrow[0];
		$name = $mrow[1];
			$res2 = $opus->query ("SELECT DISTINCT t.source_opus from $table t, $opus_table o where t.sr_id = $sr_id and t.source_opus = o.source_opus and $bereichsgrenze");
			$anzahl = $opus->num_rows($res2);
			if ($schriftenreihe_alle_anzeigen) {
				 print("<LI> \n<A HREF=\"$url/schriftenreihen_ebene2.$php?sr_id=$sr_id&la=$la\">$name</A> <FONT SIZE=2>( $anzahl Dok. )</FONT>\n<P>\n");
			}
			else {
				if ($anzahl > 0) {
					print("<LI> \n<A HREF=\"$url/schriftenreihen_ebene2.$php?sr_id=$sr_id&la=$la\">$name</A> <FONT SIZE=2>( $anzahl Dok. )</FONT>\n<P>\n");
				}
			}	
			$opus->free_result($res2);
        }
        $opus->free_result($res);
	print("</UL> \n");
}

$design->foot("schriftenreihen.$php", $la);
?>

