<?
#############################################################
# schriftenreihen_ebene2.php - Browsen nach Schriftenreihen
#
# letzte nderung:
# 18.3.2005, Annette Maile, UB Stuttgart
# Auslagerung Design in lib/design.php
# In Abhaengigkeit von $la kann das entsprechende Design eingelesen werden.
#
# 10.6.05, Annette Maile, UB Stuttgart
# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# in Abhaengigkeit der IP-Adresse des Nutzers und der
# Variablen $alle_doks_anzeigen wird die Suche generiert
#
# 21.9.2005, Annette Maile, UB Stuttgart
# Einfuehrung der Mehrsprachigkeit (Variable $la)
# Textdatei: texte/$la/schriftenreihen.conf
#
#############################################################

include ("../lib/class.configFile.php");
$conf = new configFile ("../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");

include ("../lib/class.opus_$dbms.$php");
$opus = new opus;

$db = $conf->value("db");
$opus_table = $conf->value("opus_table");
$url = $conf->value("url");
$table = $opus_table . "_schriftenreihe";
$alle_doks_anzeigen = $conf->value("alle_doks_anzeigen");

include ("../lib/stringValidation.php");
$sr_id = $_REQUEST['sr_id'];
if (! _is_valid($sr_id,0,10,"[0-9]*")) {die ("Fehler in Parameter sr_id");}
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# A.Maile, 18.03.05: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}

$sock = $opus->connect();
if ($sock < 0 ) {
        fatal ("Error: $ERRMSG\n");
}
if ($opus->select_db($db) < 0 ) {
        fatal ("Error: $ERRMSG\n");
}

# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
# Es wird die IP des Nutzers ermittelt.
# Wenn alle_doks_anzeigen = 0 gesetzt ist:
# Es wird auf jeden Fall im Bereich 1 = freier Zugriff gesucht
# Falls in Altbestaenden (< Opus 3.0) kein Bereich angegeben ist,
# wird auch nach bereich_id = 0 und null gesucht
# Dann wird in der Tabelle ip_bereich nach den Bereichen gesucht,
# in deren IP-Range die IP liegt.
# Wenn alle_doks_anzeigen = 1 gesetzt ist:
# Es wird in allen Bereichen gesucht

$ip = $_SERVER['REMOTE_ADDR'];
if ($alle_doks_anzeigen == 0) {
        $bereichsgrenze = "(o.bereich_id = 1 or o.bereich_id = 0 or o.bereich_id is NULL";
        $res = $opus->query("SELECT bereich_id, ip_range FROM ip_bereich");
        $num = $opus->num_rows($res);
        if ($num > 0) {
                $i = 0;
                while ($i < $num) {
                        $mrow = $opus->fetch_row($res);
                        $bereich_id = $mrow[0];
                        $ip_range = $mrow[1];
                        if (ereg("^$ip_range", "$ip")) {
                                $bereichsgrenze = $bereichsgrenze . " OR o.bereich_id = $bereich_id";
                        }
                        $i++;
                }
                $opus->free_result($res);
                $bereichsgrenze = $bereichsgrenze . ")";
        }
}
else {
        # Es wird in allen Bereichen gesucht
        $bereichsgrenze = "(o.bereich_id is not null or o.bereich_id is null)";
}
# Ende Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche


// **** Name der Schriftenreihe ($name) aus der $sr_id ziehen

$sr_res = $opus->query("SELECT name FROM schriftenreihen WHERE sr_id=$sr_id");
$num = $opus->num_rows($sr_res);
if ($num < 1) {
        echo("Schriftenreihe nicht gefunden.");
        exit();
}
$sr_row = $opus->fetch_row($sr_res);
$name = $sr_row[0];

// **** Ende ****

# A. Maile Texte aus Textdatei in Programmvariablen fllen
$texte = new configFile ("../texte/$la/schriftenreihen_ebene2.conf");
$titel = $texte->value("titel");
$ueberschrift = $texte->value("ueberschrift");

$titel .= " ". $name;
$ueberschrift .= " " . $name;;

# Annette Maile, 18.3.05 Design aus lib/design.php einlesen
require ("../lib/design.$php");
$design = new design;
$design->head_titel($titel);
$design->head_ueberschrift($ueberschrift, $la);

$sock = $opus->connect();
if ($sock < 0 ) {
        fatal ("Error: $ERRMSG\n");
}
if ($opus->select_db($db) < 0 ) {
        fatal ("Error: $ERRMSG\n");
}

$opus_table_sr = $opus_table . "_schriftenreihe";
$res = $opus->query ("SELECT os.source_opus, os.sequence_nr FROM $opus_table_sr os, $opus_table o WHERE sr_id=$sr_id and os.source_opus = o.source_opus and $bereichsgrenze ORDER BY sequence_nr");
 
$num = $opus->num_rows($res);
if ($num > 0) {
        
	print("<TABLE BORDER=1> \n");
	print("<TH VALIGN=TOP>Nr.</TH>\n");
	print("<TH VALIGN=TOP>Titel </TH>\n");
	print("<TH VALIGN=TOP>Autor </TH>\n");
        print("<TH VALIGN=TOP>Jahr </TH>\n");
        print("<TH VALIGN=TOP>Band </TH>\n");
	print("<TR> \n");
	
	$i = 0;

        while ($i < $num) {

                $i++;
                $mrow = $opus->fetch_row($res);
		$source_opus = $mrow[0];
		$sr_band = $mrow[1];
		$res2 = $opus->query ("SELECT DISTINCT title, date_year from $opus_table where source_opus = $source_opus");
		$anzahl = $opus->num_rows($res2);
		$mrow2 = $opus->fetch_row($res2);
		$title = $mrow2[0];
		$date_year = $mrow2[1];
		
		$res2 = $opus->query ("SELECT DISTINCT creator_name from opus_autor where source_opus = $source_opus");
		$mrow2 = $opus->fetch_row($res2);
		$author = $mrow2[0];
				
		$opus->free_result($res2);

		print("<TD VALIGN=MIDDLE>$i</TD>\n");
		print("<TD><A HREF=\"$url/frontdoor.$php?source_opus=$source_opus\">$title</A></TD>\n");
		print("<TD>$author</TD>\n");
		print("<TD>$date_year</TD>\n");
		print("<TD ALIGN=CENTER>$sr_band</TD>\n");
		print( "</TR>\n<TR>\n" );

	}

	print("</TR>\n</TABLE>\n");

        $opus->free_result($res);
}

$design->foot("schriftenreihen_ebene2.$php", $la);
?>

