<?
#############################################################
# index.php - Homepage
#
# letzte nderung:
# 18.3.2005, Annette Maile, UB Stuttgart
# Auslagerung Design in lib/design.php
# In Abhaengigkeit von $la kann das entsprechende Design eingelesen werden.
#
# 21.9.2005, Annette Maile, UB Stuttgart 
# Einfuehrung der Mehrsprachigkeit (Variable $la)
# Textdatei: texte/$la/index.conf
#
#############################################################

include ("../lib/class.configFile.php");
$conf = new configFile ("../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");
$projekt = $conf->value("projekt");

include ("../lib/class.opus_$dbms.$php");
$opus = new opus;

$url = $conf->value("url"); 

include ("../lib/stringValidation.php");
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# A.Maile, 18.03.05: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}

# A. Maile: steht nun in der Textdatei
# $titel = $conf->value("titel_index");
# $ueberschrift = $conf->value("ueberschrift_index");

# A. Maile Texte aus Textdatei in Programmvariablen fllen
$texte = new configFile ("../texte/$la/index.conf");
$titel = $texte->value("titel");
$ueberschrift = $texte->value("ueberschrift");
$suche = $texte->value("suche");
$volltextsuche = $texte->value("volltextsuche");
$browsen = $texte->value("browsen");
$newest = $texte->value("newest");
$ueber = $texte->value("ueber");

# Annette Maile, 18.3.05 Design aus lib/design.php einlesen
require ("../lib/design.$php");
$design = new design;
$design->head_titel($titel);
$design->head_ueberschrift($ueberschrift, $la);

print("

<h4>Wir &uuml;ber uns</h4>
<ul>
<li>
    <h4>Allgemeines</h4>
  </li>
Die Jahresbibliographie verzeichnet seit dem Berichtsjahr 1968 die Ver&ouml;ffentlichungen der
Angeh&ouml;rigen der Universit&auml;t des Saarlandes, seit 1973 auch die der anderen
Hochschulen
des Saarlandes. Als Printausgabe erschien sie zuletzt im Jahre 2000.
Die <a href=\"http://www.sulb.uni-saarland.de/literatur/jahresbib/\">Online-Version
/ Kumulierte Ausgabe</a> beinhaltet die Titel der Jahre <a
 href=\"http://www.sulb.uni-saarland.de/literatur/jahresbib/\">1993-2005</a>
sowie
zahlreiche Nachtr&auml;ge aus fr&uuml;heren Jahren. Mit der
vorliegenden, neukonzipierten Version werden die Titel ab dem
Erscheinungsjahr 2006 erfasst.<br>
</ul>
<ul>
  <li>
    <h4>Ziele</h4>
  </li>
</ul>
<div style=\"margin-left: 40px;\">\"Mit dem vorliegenden
Schriftenverzeichnis verfolgt die Universit&auml;t des Saarlandes das
Ziel,
die interessierte &Ouml;ffentlichkeit, aber auch die Mitglieder der
Universit&auml;t selbst &uuml;ber die wissenschaftlichen
Ver&ouml;ffentlichungen aus
ihrem Bereich zu informieren. Zugleich soll damit darauf hingewiesen
werden, dass die wissenschaftliche Forschung neben der stetig
wachsenden Belastung in der Lehre nicht vernachl&auml;ssigt wird und
werden
darf.\" <br>

(Rektor Prof. Dr. Hellmuth Sitte, Vorwort zur
Jahresbibliographie 1968)
<br>
<br>
\"Da die Erfassung in erster Linie auf den freiwilligen Meldungen der
Autoren beruhte, konnte keine Vollst&auml;ndigkeit angestrebt werden.\"<br>
(O. Vinzent, Einf&uuml;hrung, a.a.O.)<br>
<br>
Die aktuelle Version wurde nach Vorgaben der Universit&auml;tsleitung
neu konzipiert. Sie bietet verbesserte Recherchem&ouml;glichkeiten und
l&auml;sst sich nach verschiedenen Gesichtspunkten statistisch
auswerten.<br>
</div>
<ul>

  <li>
    <h4>Inhalt</h4>
  </li>
</ul>
<div style=\"margin-left: 40px;\">
<ul>
  <li>Aufgenommen werden ab dem <span style=\"font-weight: bold;\">Erscheinungsjahr
2006</span> selbst&auml;ndige und unselbst&auml;ndige
Ver&ouml;ffentlichungen,
die von Mitgliedern des Lehrk&ouml;rpers und anderen Mitarbeitern der
Hochschulen des Saarlandes w&auml;hrend der Zeit ihrer Mitgliedschaft
an
diesen Hochschulen verfasst wurden. Die Daten werden von den
Autoren, Herausgebern oder sonstigen beteiligten Personen gemeldet.
Beitr&auml;ge, die von mehreren
Autoren
gemeinsam verfasst wurden, brauchen nur einmal - bei Nennung aller
Autoren -
gemeldet zu werden. Folgende Dokumentarten werden mit Hilfe eigener <a
 href=\"http://jahrbib.sulb.uni-saarland.de/uni/\">Online Formulare</a>

erfasst:</li>
  <ul>
    <li>Artikel in Fachzeitschrift (print oder online), nicht
peer-reviewed <br>
    </li>
    <li>Artikel in Fachzeitschrift (print oder online), peer-reviewed <br>
    </li>
    <li>Buch (Autorenschaft)</li>

    <li>Buch (Herausgeberschaft)</li>
    <li>Buchbeitrag</li>
    <li>Patent <br>
    </li>
    <li>Weitere wichtige fachspezifische Publikationen (z.B. Lexikon-,
Konferenzenzbeitr&auml;ge (peer-reviewed)) <br>
    </li>

    <li>&Uuml;bersichtsartikel <br>
    </li>
    <li>Dissertationen<br>
    </li>
  </ul>
</ul>
<ul>
  <li><span style=\"font-weight: bold;\">Nicht</span> aufgenommen werden:<br>

  </li>
</ul>
<ul>
  <ul>
    <li>Unver&ouml;ffentlichte Beitr&auml;ge, wie z.B. interne Papiere,
Dienstanweisungen&nbsp; sowie Vorank&uuml;ndigungen (\"to
appear\", \"in press\", \"to be published\")</li>
    <li>Examensarbeiten (Diplom-, Magister-, Staatsexamensarbeiten),
Referate, Hausarbeiten<br>

    </li>
  </ul>
</ul>
</div>
<ul>
  <li>
    <h4>Hinweise f&uuml;r Titelmeldungen</h4>
  </li>
</ul>
<div style=\"margin-left: 40px;\">Mit der Umstellung auf die vorliegende
Version k&ouml;nnen ab dem Erscheinungsjahr 2006 nur noch
Online-Meldungen, die uns &uuml;ber die
jeweiligen <a href=\"http://jahrbib.sulb.uni-saarland.de/uni/\">Meldeformulare</a>

zugehen, bearbeitet werden. Bitte beachten Sie unsere Hinweise
(z.B. Eingabe der Autorennamen in der Form \"Familienname,
vollst&auml;ndige
Vornamen\")
bei den Formularfeldern und Hifetexten.
Sie erleichtern damit unsere Arbeit
erheblich und tragen zu einer schnellen Anzeige Ihrer Titel bei. <br>
</div>
<p style=\"margin-left: 40px;\">Da eine zeitaufwendige bibliographische
Nachbearbeitung in der Regel
nicht erfolgen kann, sollte jeder Titelmelder auf korrekte und
vollst&auml;ndige Daten achten. Mit Angabe der vollst&auml;ndigen
Autorennamen lassen sich Verwechslungen vermeiden. Bitte bedenken Sie
als Verfasser, dass
Ihre
Publikation in der Jahresbibliographie u. a. auch Studierenden und
Wissenschaftlern
anderer Fachrichtungen angezeigt wird, denen beispielsweise Ihre
fachspezifischen Zeitschriftentitelabk&uuml;rzungen nicht gel&auml;ufig
sind. <br>
</p>
<p style=\"margin-left: 40px;\">Titelmeldungen sind jederzeit
m&ouml;glich. Stichtage und Fristen
existieren
nicht. Im Interesse einer aktuellen Verzeichnung sollten die Titel
(einzeln) nach der Publikation gemeldet werden. Bei der
&Uuml;bermittlung
gr&ouml;&szlig;erer Titelmengen sowie zum Jahreswechsel muss mit
l&auml;ngeren Bearbeitungszeiten
gerechnet werden. Meldungen <span style=\"font-weight: bold;\">&auml;lterer</span>

(vor 2006)
Publikationen k&ouml;nnen f&uuml;r eine gewisse &Uuml;bergangszeit noch
in den bisherigen Formularen der <a
 href=\"http://www.sulb.uni-saarland.de/literatur/jahresbib/\">Online-Version
/ Kumulierte Ausgabe 1993/2005</a> vorgenommen werden.&nbsp; </p>
<br>

");

$design->foot("index.$php", $la);
?>

