<?
#############################################################
#
# Funktion: uni/jahrbib_einfuegen.php
#           fuegt Metadaten der Veroeffentlichungsmaske in die Jahresbibliographie ein
# letzte Aenderung:
# 8.4..2005, Birgit Dressler, SULB Saarbruecken
# Einfuehrung der Mehrsprachigkeit (Variable $la)
# Textdatei: texte/$la/jahrbib_einfuegen.conf
#
# 15.4.2005, Annette Maile, UB Stuttgart
# Auslagerung Design in lib/design.php
# In Abhaengigkeit von $la kann das entsprechende Design eingelesen werden.
#
# 18.4.2005, Annette Maile, UB Stuttgart
# Zugriff auf Volltexte weltweit/campusweit/weitere Bereiche
#
# 28.7.2005, Annette Maile, UB Stuttgart
# Einfuegen Lizenzvertrag ($lic)
#
# 12.5.06, BD/UH:
#             Verzahnung Jahrebibliographie und Volltextserver:
#             wenn $jahrbib_aktiv = 1, wird die URL des Volltextservers
#             $volltext_upload aufgrerufen
#############################################################

include ("../../lib/class.configFile.php");

$conf = new configFile ("../../lib/opus.conf");
$dbms = $conf->value("dbms");
$php = $conf->value("php");
$opt_inst = $conf->value("opt_institute");
$volltext_upload = $conf->value("volltext_upload");
$jahrbib_aktiv = $conf->value("jahrbib_aktiv");

include ("../../lib/stringValidation.php");
$identifier = $_FILES['identifier'];
$orig_identifier = $_FILES['orig_identifier'];
$bem_identifier = $_REQUEST['bem_identifier'];
if (is_array($bem_identifier)) {
  array_walk($bem_identifier, '_array_zeichen_loeschen');
}
else {$bem_identifier = array();}
$title = $_REQUEST['title'];
$title = eregi_replace("[`\n\r]","",$title);
$title_en = $_REQUEST['title_en'];
$title_en = eregi_replace("[`\n\r]","",$title_en);
$title_de = $_REQUEST['title_de'];
$title_de = eregi_replace("[`\n\r]","",$title_de);
$creator_corporate = $_REQUEST['creator_corporate'];
$creator_corporate = eregi_replace("[`\n\r]","",$creator_corporate);
$subject_swd = $_REQUEST['subject_swd'];
$subject_swd = eregi_replace("[`\n\r]","",$subject_swd);
$subject_uncontrolled_german = $_REQUEST['subject_uncontrolled_german'];
$subject_uncontrolled_german = eregi_replace("[`\n\r]","",$subject_uncontrolled_german);
$subject_uncontrolled_english = $_REQUEST['subject_uncontrolled_english'];
$subject_uncontrolled_english = eregi_replace("[`\n\r]","",$subject_uncontrolled_english);
$sachgruppe_ddc = $_REQUEST['sachgruppe_ddc'];
if (! _is_valid($sachgruppe_ddc,0,10,"[A-Za-z0-9\.]*")) {die ("Fehler in Parameter sachgruppe_ddc");}
$subject_type = $_REQUEST['subject_type'];
$subject_type = eregi_replace("[`\n\r]","",$subject_type);
$subject_value = $_REQUEST['subject_value'];
$subject_value = eregi_replace("[`\n\r]","",$subject_value);
$sr_id = $_REQUEST['sr_id'];
if (! _is_valid($sr_id,0,10,"[0-9]*")) {die ("Fehler in Parameter sr_id");}
$sr_band = $_REQUEST['sr_band'];
$sr_band = eregi_replace("[`\n\r]","",$sr_band);
$description = $_REQUEST['description'];
$description = eregi_replace("[`]","",$description);
$description2 = $_REQUEST['description2'];
$description2 = eregi_replace("[`]","",$description2);
$publisher_university = $_REQUEST['publisher_university'];
$publisher_university = eregi_replace("[`\n\r]","",$publisher_university);
$publisher_faculty = $_REQUEST['publisher_faculty'];
if (! _is_valid($publisher_faculty,0,5,"[A-Za-z0-9\-]*")) {die ("Fehler in Parameter publisher_faculty");}
$contributors_name = $_REQUEST['contributors_name'];
$contributors_name = eregi_replace("[`\n\r]","",$contributors_name);
$contributors_corporate = $_REQUEST['contributors_corporate'];
$contributors_corporate = eregi_replace("[`\n\r]","",$contributors_corporate);
$date_year = $_REQUEST['date_year'];
if (! _is_valid($date_year,0,4,"[0-9]*")) {die ("Fehler in Parameter date_year");}
$type = $_REQUEST['type'];
if (! _is_valid($type,0,5,"[0-9]*")) {die ("Fehler in Parameter type");}
$anzahlfiles = $_REQUEST['anzahlfiles'];
if (! _is_valid($anzahlfiles,0,10,"[0-9]*")) {die ("Fehler in Parameter anzahlfiles");}
if (empty($anzahlfiles)) {$anzahlfiles = 0;}
$isbn = $_REQUEST['isbn'];
if (! _is_valid($isbn,0,30,"[0-9xX-]*")) {die ("Fehler in Parameter isbn");}
$source_title = $_REQUEST['source_title'];
$source_title = eregi_replace("[`]","",$source_title);
$language = $_REQUEST['language'];
if (! _is_valid($language,0,3,"[A-Za-z]*")) {die ("Fehler in Parameter language");}
$verification = $_REQUEST['verification'];
$verification = eregi_replace("[`\n\r]","",$verification);
$bem_intern = $_REQUEST['bem_intern'];
$bem_intern = eregi_replace("[`\n\r]","",$bem_intern);
$date_accepted = $_REQUEST['date_accepted'];
if (! _is_valid($date_accepted,0,10,"[0-9\-]*")) {die ("Fehler in Parameter date_accepted");}
$advisor = $_REQUEST['advisor'];
$advisor = eregi_replace("[`\n\r]","",$advisor);
$dauer = $_REQUEST['dauer'];
if (! _is_valid($dauer,0,10,"[0-9]*")) {die ("Fehler in Parameter dauer");}
$description_lang = $_REQUEST['description_lang'];
if (! _is_valid($description_lang,0,3,"[A-Za-z]*")) {die ("Fehler in Parameter description_lang");}
$description2_lang = $_REQUEST['description2_lang'];
if (! _is_valid($description2_lang,0,3,"[A-Za-z]*")) {die ("Fehler in Parameter description2_lang");}
$creator_name = $_REQUEST['creator_name'];
if (is_array($creator_name)) {
  array_walk($creator_name, '_array_zeichen_loeschen');
}
else {$creator_name = array();}
$publisher_inst = $_REQUEST['publisher_inst'];
foreach ($publisher_inst as $i) {
  if (! _is_valid($i,0,10,"[A-Za-z0-9]*")) {die ("Fehler in Parameter publisher_inst");}
}
#$format = $_REQUEST['format'];
#if (! _is_valid($format,0,10,"[A-Za-z0-9]*")) {die ("Fehler in Parameter format");}
#$orig_format = $_REQUEST['orig_format'];
#if (! _is_valid($orig_format,0,10,"[A-Za-z0-9]*")) {die ("Fehler in Parameter orig_format");}
$action = $_REQUEST['action'];
if ($action != 'file_upload') {$action = 'no_file_upload';}
$bereich = $_REQUEST['bereich'];
if (! _is_valid($bereich,0,20,"[0-9]*")) {die ("Fehler in Parameter bereich");}
$la = $_REQUEST['la'];
if (! _is_valid($la,0,2,"[a-z]*")) {die ("Fehler in Parameter la");}

# A.Maile, 28.2.05: Sprache einlesen aus opus.conf, falls nicht gesetzt
if (!$la){
       $la = $conf->value("la");
}


include ("../../lib/class.opus_$dbms.$php");
$opus = new opus;

$db = $conf->value("db");
$url = $conf->value("url");
$temp_table = $conf->value("temp_table");
$home = $conf->value("home");
$projekt = $conf->value("projekt");
$incoming_pfad = $conf->value("incoming_pfad");
$incoming_url = $conf->value("incoming_url");
$email = $conf->value("email");
$opusmail = $conf->value("opusmail");
# BD, 8.4.05, steht nun in der Textdatei, nicht mehr in opus.conf
#$titel = $conf->value("titel_temp_einfuegen");
#$ueberschrift = $conf->value("ueberschrift_temp_einfuegen");

# BDressler Texte aus Textdatei in Programmvariablen fllen 
#$texte = new configFile ("../../texte/$la/jahrbib_einfuegen.conf");
$texte = new configFile ("../../texte/de/jahrbib_einfuegen.conf");
$titel = $texte->value("titel");
$ueberschrift = $texte->value("ueberschrift");
$unzul_format = $texte->value("unzul_format");
$original_format = $texte->value("original_format");
$datnamefehlt = $texte->value("datnamefehlt");
$datendungsfehler1 = $texte->value("datendungsfehler1");
$datendungsfehler2 = $texte->value("datendungsfehler2");
$datendungsfehler3 = $texte->value("datendungsfehler3");
$datendungsfehler4 = $texte->value("datendungsfehler4");
$datendungsfehler5 = $texte->value("datendungsfehler5");
$datnamefehler = $texte->value("datnamefehler");
$formatfehler1 = $texte->value("formatfehler1");
$formatfehler2 = $texte->value("formatfehler2");
$formatfehler3 = $texte->value("formatfehler3");
$uploadfehler1 = $texte->value("uploadfehler1");
$uploadfehler2 = $texte->value("uploadfehler2");
$dokument1 = $texte->value("dokument1");
$dokument2 = $texte->value("dokument2");
$dokument3 = $texte->value("dokument3");
$dokument4 = $texte->value("dokument4");
$dokument5 = $texte->value("dokument5");
$dokument6 = $texte->value("dokument6");
$dokument7 = $texte->value("dokument7");
$dokument8 = $texte->value("dokument8");
$fehlermeld1 = $texte->value("fehlermeld1");
$fehlermeld2 = $texte->value("fehlermeld2");
$text1 = $texte->value("text1");
$text2 = $texte->value("text2");
$text3 = $texte->value("text3");
$text4 = $texte->value("text4");
$text5 = $texte->value("text5");
$text6 = $texte->value("text6");
$text7 = $texte->value("text7");
$text8 = $texte->value("text8");
$text9 = $texte->value("text9");
$text10 = $texte->value("text10");
$lizenz = $texte->value("lizenz");
$mehr_info = $texte->value("mehr_info");
$dokument_einfuegen = $texte->value("dokument_einfuegen");

# Annette Maile, 17.3.05 Design aus lib/design.php einlesen
require ("../../lib/design.$php");
$design = new design;
$design->head_titel($titel);
$design->head_ueberschrift($ueberschrift, $la);

print("<FONT COLOR=red>");
$sock = $opus->connect();
if ($sock < 0 ) {
        echo ("Error: $ERRMSG\n");
}
if ($opus->select_db($db) < 0 ) {
        echo ("Error: $ERRMSG\n");
}
print ("</FONT>");



/*
BD/UH, 16.3.06: in Jahrebibliographie ist hier noch kein Format bekannt, da erst nach Abspeichern der Jahresbiblioigraphie-Daten die Dateien nach SciDok hochgeladen werden und die Daten in die SciDok-Datenbank eingespielt werden
also: zuerst abspeichern in die Jahrebibliographie-Datenbank
dann: Knopf zum Hochladen des Volltextes
dann: nun erst berprfung des Formates und Besttigung, dass upload nach SciDok funktioniert hat

if ($action == "file_upload") {
$slashed_format = addslashes($format);
$res = $opus->query("select name from format where extension = '$slashed_format'");
$num = $opus->num_rows($res);
$opus->free_result($res);
if ($num == 0) {
	print("$unzul_format"); 
	$design->foot("jahrbib_einfuegen.$php", $la);
	exit();
}
if ($orig_format == "") {$orig_format = "original";}
$slashed_orig_format = addslashes($orig_format);
#$res = $opus->query("select name from format where extension = '$slashed_orig_format'");
$num = $opus->num_rows($res);
$opus->free_result($res);
if ($num == 0) {
	print("$unzul_format $original_format");
	$design->foot("jahrbib_einfuegen.$php", $la);
	exit();
} 


$anz_files = count($identifier['name']);
if ($anz_files > 0) {
        if ($identifier['name'][0] == "none" || empty($identifier['name'][0])) {
                print("$datnamefehlt");
		$design->foot("jahrbib_einfuegen.$php", $la);
		exit();
        }
	else {
		$endung = explode(".", $identifier['name'][0]); 
		$last = count($endung) - 1;
	 	$ext = strtolower($endung[$last]);
		if ($ext == "htm") {
			$ext = "html";
		}
		$res = $opus->query("select name, zusatzextension from format where extension like '%$ext%'");
		$mrow = $opus->fetch_row($res);
		$name = $mrow[0];
		$zusatzextension = $mrow[1];
		$opus->free_result($res);
		if ($ext != $format) {
	#		print("Das Dokument ist eine $ext-Datei und nicht vom Format $format. Bitte Formatangabe &auml;ndern.");
			print("$formatfehler1 $ext $formatfehler2 $format $formatfehler3");
			$design->foot("jahrbib_einfuegen.$php", $la);
			exit();
		}
	}
	$i = 1;
	$j = 2;
	while ($i < $anz_files ) {
		if ($identifier['name'][$i] != "none" && !empty($identifier['name'][$i])) {
	                $endung = explode(".", $identifier['name'][$i]);
	                $last = count($endung) - 1;
	                $ext2 = strtolower($endung[$last]);
			$res = $opus->query(
				"select extension from format where zusatzextension like '%$ext2%' and extension like '%$ext%'");

			$num = $opus->num_rows($res);	
			$i++;
			if ($num == 0) {
			#	print "Datei $j ist vom Format $ext2 und und wird nicht in Verbindung mit Format $name unterst&uuml;tzt! Es sind nur die Dateiendungen $zusatzextension zul&auml;ssig.";
				print ("$datendungsfehler1 $j $datendungsfehler2 $ext2 $datendungsfehler3 $name $datendungsfehler4 $zusatzextension $datendungsfehler5");
				$design->foot("temp_einfuegen.$php", $la);
				exit();
			}
			else {
				$opus->free_result($res);
			}
		}
		$i++;
		$j++;
	}
}
if ($type == "8" || $type == "24"){
   if ($anz_files > 0) {
	if ($orig_identifier['name'][0] == "none" || empty($orig_identifier['name'][0])) {
		#print("Bitte geben Sie einen Dateinamen bei Originalformat an!");
                print ("$datnamefehler");
		$design->foot("temp_einfuegen.$php", $la);
		exit();
	}
   }
}
} 
*/  /* Ende Formatberprfung */

/* Wenn eine Klassifikation angewaehlt wurde, aber keine Werte eingegeben wurden, */
/* enthaelt die Variable subject_type einen falschen Wert und muss daher auf "" gesetzt werden. */
if ($subject_value == "") {
	$subject_type = ""; 
}
/* an die Variable $date_creation wird das Systemdatum uebergeben. */
$date_creation = mktime();
$jahr = date("Y");

/* Gueltigkeitsdatum berechnen, falls dauer > 0. */
/* Zum Monat des aktuellen Datums wird die Dauer */
/* addiert und ein Unixdatum erzeugt */
$dauer = $dauer;
if ($dauer > 0) {
	$date_valid = mktime(0,0,0,date("m")+$dauer, date("d"), date("Y"));
}
else {
	$date_valid = 0;
}
# nchste freie ID 
$source_opus = $opus->sequence("seq_temp");

/* Eintrag in die Datenbank */
$stat = $opus->query( 
	"INSERT INTO $temp_table (title, creator_corporate, subject_swd, description, publisher_university,
	    	contributors_name, contributors_corporate, date_year, 
	     	date_creation, type, source_opus, source_title, 
		language, verification, bem_intern,
		subject_uncontrolled_german, subject_uncontrolled_english,
		title_en, description2, subject_type, date_valid, 
		description_lang, description2_lang, sachgruppe_ddc, 
		status, bereich_id, lic, isbn)
	VALUES ('$title', '$creator_corporate','$subject_swd', 
	    	'$description', '$publisher_university',
		'$contributors_name', '$contributors_corporate', '$date_year', 
		$date_creation, '$type', $source_opus, '$source_title', 
		'$language','$verification', '$bem_intern', 
		'$subject_uncontrolled_german', '$subject_uncontrolled_english', 
		'$title_en', '$description2', '$subject_type', $date_valid, 
		'$description_lang', '$description2_lang', '$sachgruppe_ddc', 
		'neu', '$bereich', '$lic', '$isbn')");

if ( $stat < 0 ) {
	print("ERROR $temp_table: $ERRMSG <p><HR>\n");
}

$i = 0;
$temp_table_autor = $temp_table . "_autor";
$anzahl_creator_name = sizeof($creator_name);
if ($anzahl_creator_name > 1) {
	while ($i < $anzahl_creator_name) {
		if ($creator_name[$i] != "") {
			$j = $i + 1;
			$stat = $opus->query(
			"INSERT INTO $temp_table_autor (source_opus, creator_name, reihenfolge) 
			 VALUES ($source_opus, '$creator_name[$i]', $j)");
		}
		$i++;	
	}
	$autor = $creator_name[0] . " et al.";
}
else {
	if ($creator_name[0] != "") {
		$stat = $opus->query(
		"INSERT INTO $temp_table_autor (source_opus, creator_name, reihenfolge)
		 VALUES ($source_opus, '$creator_name[0]', 1)");
	}
	$autor = $creator_name[0];
}
if ( $stat < 0 ) {
	print("ERROR $temp_table_autor: $ERRMSG <p><HR>\n");
}


$i = 0;
$temp_table_inst = $temp_table . "_inst";
$anzahl_publisher_inst = sizeof($publisher_inst);
if ($anzahl_publisher_inst > 1) {
	while ($i < $anzahl_publisher_inst) {
	$stat = $opus->query(
	"INSERT INTO $temp_table_inst (source_opus, inst_nr)
	VALUES ($source_opus, '$publisher_inst[$i]')");
	$i++;
	}
}
else {
	$stat = $opus->query(
	"INSERT INTO $temp_table_inst (source_opus, inst_nr)
	VALUES ($source_opus, '$publisher_inst[0]')");
}
if ( $stat < 0 ) {
	print("ERROR $temp_table_inst: $ERRMSG <p><HR>\n");
}


if ($subject_type != "" && $subject_value != "") {
	$class = explode (",", $subject_value);
	$last = count($class);
	$i=0;
	$temp_table_subject_type = $temp_table . "_" . $subject_type;
	while ($i < $last) {
		/* fuehrende und nachfolgende Blanks entfernen */
		$class[$i] = trim($class[$i]); 
		$stat =  $opus->query(
		"INSERT INTO $temp_table_subject_type (source_opus, class)
		 VALUES ($source_opus, '$class[$i]')");	
		$i++;
	
	}
	if ( $stat < 0 ) {
		print("ERROR $temp_table_$subject_type: $ERRMSG <p><HR>\n");
	}
}


/* Bei Dissertationen wird zusaetzlich Tag der muendlichen Pruefung, Fakultaet */
/* und Hauptberichter in der Tabelle temp_diss abgespeichert. */
if ($type == "8" || $type == "24") {
	$temp_table_diss = $temp_table . "_diss";
	$stat = $opus->query(
		"INSERT INTO $temp_table_diss (source_opus, date_accepted, advisor, title_de, publisher_faculty)
                VALUES ($source_opus, '$date_accepted', '$advisor', '$title_de', '$publisher_faculty')");
}
if ( $stat < 0 ) {
	print("ERROR $temp_table_diss: $ERRMSG <p><HR>\n");
}

if ($sr_id != "") {
	$temp_table_schriftenreihe = $temp_table . "_schriftenreihe";
	$stat = $opus->query(
		"INSERT INTO $temp_table_schriftenreihe (sr_id, source_opus, sequence_nr) VALUES ('$sr_id','$source_opus','$sr_band') ");
}
if ( $stat < 0 ) {
        print("ERROR $temp_table_schriftenreihe: $ERRMSG <p><HR>\n");
}



$autor = stripslashes($autor);
$title = stripslashes($title);
#$message = "Ein neues Dokument mit \n\n";
$message = $dokument1 . "\n\n";
#$message = $message . "$projekt-IDN      : $source_opus \n";
$message = $message . $projekt;
$message = $message . $dokument2;
$message = $message . ": ";
$message = $message . $source_opus;
$message = $message . "\n";
#$message = $message . "Titel         : $title \n";
$message = $message . $dokument3;
$message = $message . ": ";
$message = $message . $title;
$message = $message . "\n";
#$message = $message . "Autor         : $autor \n";
$message = $message . $dokument4;
$message = $message . ": ";
$message = $message . $autor;
$message = $message . "\n";
#$message = $message . "Email         : $verification \n";
$message = $message . $dokument5;
$message = $message . ": ";
$message = $message . $verification;
$message = $message . "\n\n";
#$message = $message . "wurde in $projekt eingebracht. \n";
$message = $message . $dokument6 ." ";
$message = $message . $projekt ." ";
$message = $message . $dokument7;
$message = $message . "\n\n";
$message = $message . "$home/admin/aendern.$php?suchfeld=source_opus&suchwert=$source_opus&table=$temp_table";
#mail($email, "neuer Eintrag in $projekt: $autor", $message, "from: $opusmail");
mail($email, "$dokument8 $projekt: $autor", $message, "from: $opusmail");

# Meldung Publikation  erfolgreich aufgenommen in Jahrbib

print("$text7 $projekt $text8");

# bernahme der Daten in SciDok
# BD/UH, 7.4.06, Patente (Typ = 56) 
#                Zeitschrift (Herausgeberschaft) (Typ = 50) 
#       nicht in SciDok bernehmen!
if ($type != "56" || $type != "50")
{
print("$text9");

# BD/UH, 7.4.06, Dokumenttypen auf die Dokumentarten von SciDok mappen:
# 51, 52, 57, 58, 59 auf Dokumenttyp 2
# 53 auf Dokumenttyp 5
# 54, 55 auf Dokumenttyp 4

if ($type == "51") {$type_scidok = "2";}
elseif ($type == "52") {$type_scidok = "2";}
elseif ($type == "57") {$type_scidok = "2";}
elseif ($type == "58") {$type_scidok = "2";}
elseif ($type == "59") {$type_scidok = "2";}
elseif ($type == "53") {$type_scidok = "5";}
elseif ($type == "54") {$type_scidok = "4";}
elseif ($type == "55") {$type_scidok = "4";}
else $type_scidok = $type;

print("type: $type_scidok");

#BD/UH, aus Jahrebibliographie sollen die Daten in OPUS bernommen werden
if ($jahrbib_aktiv == 1)
{
# Volltext zur Jahresbibliographie hochladen in Volltextserver und in die OPUS-Datenbank schreiben

print("
<FORM METHOD=\"POST\" ACTION=\"$volltext_upload/uni/uploadform.$php\">
<INPUT TYPE=hidden NAME=\"title\" VALUE=\"$title\">
<INPUT TYPE=hidden NAME=\"title_en\" VALUE=\"$title_en\">
<INPUT TYPE=hidden NAME=\"title_de\" VALUE=\"$title_de\">
<INPUT TYPE=hidden NAME=\"creator_corporate\" VALUE=\"$creator_corporate\">
<INPUT TYPE=hidden NAME=\"subject_swd\" VALUE=\"$subject_swd\">
<INPUT TYPE=hidden NAME=\"subject_uncontrolled_german\" VALUE=\"$subject_uncontrolled_german\">
<INPUT TYPE=hidden NAME=\"subject_uncontrolled_english\" VALUE=\"$subject_uncontrolled_english\">
<INPUT TYPE=hidden NAME=\"sachgruppe_ddc\" VALUE=\"$sachgruppe_ddc\">
<INPUT TYPE=hidden NAME=\"subject_type\" VALUE=\"$subject_type\">
<INPUT TYPE=hidden NAME=\"subject_value\" VALUE=\"$subject_value\">
<INPUT TYPE=hidden NAME=\"sr_id\" VALUE=\"$sr_id\">
<INPUT TYPE=hidden NAME=\"sr_band\" VALUE=\"$sr_band\">
<INPUT TYPE=hidden NAME=\"description\" VALUE=\"$description\">
<INPUT TYPE=hidden NAME=\"description2\" VALUE=\"$description2\">
<INPUT TYPE=hidden NAME=\"publisher_university\" VALUE=\"$publisher_university\">
<INPUT TYPE=hidden NAME=\"contributors_name\" VALUE=\"$contributors_name\">
<INPUT TYPE=hidden NAME=\"contributors_corporate\" VALUE=\"$contributors_corporate\">
<INPUT TYPE=hidden NAME=\"date_year\" VALUE=\"$date_year\">
<INPUT TYPE=hidden NAME=\"type\" VALUE=\"$type_scidok\">
<!-- BD/UH, 7.4.06, Eine Zeile zum Hochladen der Datei soll bei der bergabe an OPUS angezeigt werden //-->
<INPUT TYPE=\"hidden\" NAME=\"anzahlfiles\" VALUE=\"1\">
<!--INPUT TYPE=\"hidden\" NAME=\"anzahlfiles\" VALUE=\"$anzahlfiles\"//-->
<INPUT TYPE=hidden NAME=\"isbn\" VALUE=\"$isbn\">
<INPUT TYPE=hidden NAME=\"source_title\" VALUE=\"$source_title\">
<INPUT TYPE=hidden NAME=\"language\" VALUE=\"$language\">
<INPUT TYPE=hidden NAME=\"verification\" VALUE=\"$verification\">
<INPUT TYPE=hidden NAME=\"date_accepted\" VALUE=\"$date_accepted\">
<INPUT TYPE=hidden NAME=\"advisor\" VALUE=\"$advisor\">
<INPUT TYPE=hidden NAME=\"dauer\" VALUE=\"$dauer\">
<INPUT TYPE=hidden NAME=\"description_lang\" VALUE=\"$description_lang\">
<INPUT TYPE=hidden NAME=\"description2_lang\" VALUE=\"$description2_lang\">
<input type=hidden name=\"bereich\" value=\"$bereich\">
");

$i = 0;
while ($i < $anzahl_creator_name) {
	if ($creator_name[$i] != "") {
		$creator_name[$i] = stripslashes(htmlspecialchars($creator_name[$i]));
	        print("<INPUT TYPE=hidden NAME=\"creator_name[]\" VALUE=\"$creator_name[$i]\"> \n");
	}
	$i++;
}

# BD/UH, 28.6.07, an SciDok aus Instituts-Tabelle nur die ersten 4 Stellen uebergeben
$institut_scidok = array();
$i = 0;
while ($i < $anzahl_publisher_inst) {
        if ($publisher_inst[$i] != "0") {
                $institut_scidok[$i] = substr($publisher_inst[$i], 0, 4);
                print("<INPUT TYPE=hidden NAME=\"publisher_inst[]\" VALUE=\"$institut_scidok[$i]\"> \n");
        }
        $i++;
}


# BD/UH, 28.6.07, an SciDok aus Fakultts-Tabelle nur die ersten 2 Stellen uebergeben
$faculty_scidok = substr($publisher_faculty, 0, 2);
print("
<INPUT TYPE=hidden NAME=\"publisher_faculty\" VALUE=\"$faculty_scidok\"> 
<INPUT TYPE=hidden NAME=\"zusatzfiles\" VALUE=\"0\">
<input type=\"hidden\" name=\"la\" value=\"$la\">
");

# Start Lizenzvertrag
$lic_active = $conf->value("license_active");
if ($lic_active > 0) {
        $lic = $_REQUEST['lic'];
        $lic = eregi_replace("[`\n\r]","",$lic);
        print("\n<input type=\"hidden\" name=\"lic\" value=\"$lic\">\n");
}
# Ende Lizenzvertrag

# Button mit: Dokument auf SciDok verffentlichen
print("
<CENTER><INPUT TYPE=submit VALUE=\"$dokument_einfuegen\"></CENTER> 

</FORM> 
");
} # Volltext in OPUS einspielen
} #if type != 56, != 50


# BD/UH, 28.4.06 Knopf "Weiteren Titel in der Jahresbibliographie melden
# sinnvolle Felder sollen bernommen werden
print("
<FORM METHOD=\"POST\" ACTION=\"$url/uni/index.$php\">
<INPUT TYPE=hidden NAME=\"type\" VALUE=\"$type\"> \n
");

print("
<INPUT TYPE=hidden NAME=\"creator_name[]\" VALUE=\"$creator_name[0]\"> \n
<INPUT TYPE=hidden NAME=\"publisher_inst[]\" VALUE=\"$publisher_inst[0]\"> \n
<INPUT TYPE=hidden NAME=\"date_year\" VALUE=\"$date_year\">
<INPUT TYPE=hidden NAME=\"verification\" VALUE=\"$verification\">
<INPUT TYPE=hidden NAME=\"bem_intern\" VALUE=\"$bem_intern\">");

print("
<CENTER><INPUT TYPE=submit VALUE=\"Weiteren Titel in der Jahresbibliographie melden\"></CENTER> 

</FORM> 
"); # Werte wieder zurckgeben an Eingabemaske
print("
<hr>
<TABLE BORDER=1>
");


# Ende Dateien hochladen

$opus->close($sock);
$opus->system ("chmod -R 775 $incoming_pfad/$jahr/$source_opus/");
$design->foot("jahrbib_einfuegen.$php", $la);
?>

