<H3>
Was sind Metadaten?</H3>
Metadaten k&ouml;nnen definiert werden als
<UL>Daten, die eine oder mehrere Resourcen beschreiben oder als
<BR>Daten, die mit einem Objekt verbunden sind und dieses Objekt beschreiben.</UL>
Prinzipiell stellen Metadaten daher eine Beschreibung von Dokumenten, Objekten
oder Diensten dar und enthalten Informationen zu deren Inhalt, Struktur
oder Form. Etwas abstrakter formuliert sind Metadaten Beschreibungen von
Daten bzw. "Daten &uuml;ber Daten". Bibliographische Datens&auml;tze und
Katalogeintr&auml;ge in Bibliotheken k&ouml;nnen als eine Form von Metadaten
gesehen werden.

<P>
Als Grundlage f&uuml;r die Metadaten soll das aus f&uuml;nfzehn Basiselementen
bestehende <A HREF="http://dublincore.org/">Dublin
Core Metadata Element Set</A> (kurz Dublin Core bzw. DC) dienen. Dublin
Core ist das Ergebnis internationalen Bem&uuml;hungen, einen gemeinsamen
Konsens bei der Beschreibung elektronischer Objekte (im weitesten Sinne)
zu finden. Die Library of Congress (LoC), das Online Cataloging Library
Center (OCLC) und eine Reihe von Nationalbibliotheken setzen sich in Projekten
mit Dublin Core auseinander bzw. stehen kurz vor dessen Einf&uuml;hrung.
Ebenso das Bibliotheksservice-Zentrum Baden W&uuml;rttemberg <A HREF="http://www.bsz-bw.de/diglib/medserv/konvent/metadat/metadat.html">(BSZ)</A>,
das die Verbunddatenbank des S&uuml;dwestdeutschen Bibliotheksverbunds
betreibt.
<CENTER></CENTER>

<CENTER>
<HR ALIGN=CENTER WIDTH=100% SIZE=2></CENTER>

<H3>
Die einzelnen Elemente des Anmeldeformulars</H3>

<H4>
1.&nbsp;<A NAME="title"></A>Titel (Title)</H4>
Titel des Dokuments oder des Objekts.

<P>Definition: Der vom Verfasser, Urheber oder Verleger vergebene Name
der Ressource.

<P>Verwendungshinweise: <IMG SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM>
obligatorisches Meta-Element.

<H4>
2.1&nbsp;<A NAME="creator_name"></A>Verfasser (Creator)</H4>
Name des Autors 

<P>Definition: Die Person(en), die den intellektuellen
Inhalt verantworten, z.B. Autoren bei Textdokumenten, K&uuml;nstler, Photographen
oder Illustratoren bei graphischen Dokumenten. 

<P>F&uuml;r Personennamen ist die normierte Schreibweise "Familienname,
Vorname" vorgeschriebenn, um die Suchbarkeit des Dokuments zu verbessern.

<P>Verwendungshinweise: Sofern m&ouml;glich (z.B. bei Diplom-, Magisterarbeiten) ein obligatorisches Meta-Element

<H4>
2.2&nbsp;<A NAME="creator_corporate"></A>Urheber (Creator)</H4>
Name der Organsiation 

<P>Definition: Die Organisation(en), die den intellektuellen
Inhalt des Dokuments verantworten. 

Organisationen (in der bibliothekarischen
Terminologie K&ouml;rperschaften genannt) sind i.d.R. dann f&uuml;r den
intellektuellen Inhalt verantwortlich, wenn es sich um ein Autorenkollektiv
handelt oder keine pers&ouml;nlichen Verfasser im Dokument genannt sind
(z.B. bei Pr&uuml;fungsordnungen o.&auml;.). Im Feld Urheber sollte daher
nicht automatisch das eigene Institut bzw. Fakult&auml;t angegeben werden.
Hierzu sind separate Felder <A HREF="#publisher">(Hochschule bzw. Fakult&auml;t)</A>
vorgesehen.

<P>Verwendungshinweise: Sofern m&ouml;glich ein obligatorisches Meta-Element

<H4>
3.1&nbsp;<A NAME="contributor"></A>Sonstige Beteiligte (Other Contributors)</H4>
Name einer Person oder Organisation

<P>Definition: Zus&auml;tzliche Person(en) und Organisation(en) zu jenen,
die in den Feldern Verfasser bzw. Urheber genannt wurden. Sie haben einen
bedeutsamen intellektuellen Beitrag zur Ressource geleistet, der aber sekund&auml;r
im Verh&auml;ltnis zu dem von Verfassern bzw. Urhebern ist. (z.B. Co-Autor,
Herausgeber, &Uuml;bersetzer, Illustratoren, auch Konferenzleiter, Moderatoren,
Sponsoren, Veranstalter etc.)

<P>F&uuml;r Personenamen ist die normierte Schreibweise "Familienname,
Vorname" vorgeschrieben, um die Suchbarkeit des Dokuments zu verbessern.

<P>Verwendungshinweise: kein obligatorisches, aber w&uuml;nschenswertes Meta-Element,
falls mehrere Personen in unterschiedlichen Funktionen an der Erstellung
des Dokuments beteiligt waren.

<h4>
3.2&nbsp;<a NAME="advisor"></a>Hauptberichter </h4>
Der Hauptberichter muss bei Dissertationen angegeben werden. Akademische Titel k&ouml;nnen optional angegeben werden (e.g. Muster, Hans Prof.Dr.). 
<P>Verwendungshinweise: <IMG SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM>
obligatorisches Meta-Element bei Dissertationen und Habilitationen


<H4>
4.1&nbsp;<A NAME="keywords"></A>Schlagw&ouml;rter
(Subject)</H4>
Schlagw&ouml;rter zur 
kontrollierten inhaltlichen Beschreibung des Dokuments m&uuml;ssen aus dem kontrollierten Schlagwortvokabular des SWB &uuml;bernommen werden.

<P>Verwendungshinweise: <IMG SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM>
obligatorisches Meta-Element

<P>
Zus&auml;tzlich gibt es die M&ouml;glichkeit, freie Schlagw&ouml;rter zu vergeben, 
wenn im kontrollierten Schlagwortvokabular keine passenden Begriffe gefunden werden konnten. 
Zur besseren internationalen Erschlie&szlig;ung besteht auch die M&ouml;glichkeit,
englische Schlagw&ouml;rter zu vergeben.  

<H4> 4.2&nbsp;<A NAME="classification"></A>Klassifikation
(Subject)</H4>
Da in einigen F&auml;llen eine verbale Inhaltserschlie&szlig;ung nicht ausreicht, wird zus&auml;tzlich
die M&ouml;glichkeit einer klassifikatorischen Erschlie&szlig;ung angeboten, sofern entsprechende 
Erschlie&szlig;ungssysteme online verf&uuml;gbar sind.
<P>
<P>Verwendungshinweise: fakultatives Metaelement

<H4>
5.&nbsp;<A NAME="description"></A>Inhaltliche Beschreibung (Description)</H4>
Abstract oder freie Beschreibung der Ressource.

<P>Definition: Eine textuelle Beschreibung des Ressourceninhalts inklusive
eines Referats (Abstract) bei dokument&auml;hnlichen Ressourcen oder Inhaltsbeschreibungen
bei graphischen Ressourcen. Die Beschreibung darf 2000 Zeichen nicht
&uuml;berschreiten. Sie kann per "Kopieren und Einf&uuml;gen" aus dem Dokument in das
Feld &uuml;bertragen werden. Ist keine Inhaltsbeschreibung erstellt worden,
kann stattdessen auch die Einleitung, die Zusammenfassung, das Inhaltsverzeichnis
o.&auml;. hier eingetragen werden.

<P>Verwendungshinweise: <IMG SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM>
obligatorisches Meta-Element

<H4>
6.&nbsp;<A NAME="publisher"></A>Hochschule bzw. Fakult&auml;t (Publisher)</H4>
Definition: Die Einrichtung, die verantwortet, dass die Ressource
in dieser Form zur Verf&uuml;gung steht. Zun&auml;chst sollen nur Angeh&ouml;rige
der Universit&auml;t Dokumente in den Publikationsverbund einbringen,
deshalb ist diese Hochschule als Standardwert eingetragen. Innerhalb der
Universit&auml;t wird nach <A HREF="../fak_liste.php">Fakult&auml;ten</A> untergliedert.

<P>Verwendungshinweise: <IMG SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM>
obligatorisches Meta-Element, das aus einer Liste
&uuml;bernommen werden muss.

<H4>
7.&nbsp;<A NAME="date"></A>Datum (Date)</H4>
Das Erstellungsjahr des Dokuments, das eingebracht wird.

<P>Das Ver&ouml;ffentlichungsdatum und das Datum der letzten &Auml;nderung
der Metadaten werden automatisch vom System erfasst.

<P>Verwendungshinweise: <IMG SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM>
obligatorisches Meta-Element

<H4>
8.&nbsp;<A NAME="type"></A>Dokumentart (Resource Type)</H4>
Definition: Art der Publikation wie z.B. Dissertation, Diplomarbeit, Gedicht,
Homepage usw. Verwendet wird ein kontrolliertes Vokabular aus einer <A HREF="../dokart_liste.php">Liste
zugelassener Bezeichnungen</A>, das auf 
der Liste der <A HREF="http://dublincore.org/documents/dces/">Dublin
Core Standard Object Types</A> basiert.

<P>Verwendungshinweise: <IMG SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM>
obligatorisches Meta-Element, das aus einer Liste
&uuml;bernommen werden mu&szlig;.

<H4>
9.&nbsp;<A NAME="format"></A>Format (Format)</H4>
Definition: Datentechnisches Format der Ressource, als Standardwert ist
hier <B>application/pdf</B> eingetragen. 

<P>Zur Zeit werden die Formate PDF, PostScript, HTML und im Zusammenhang damit auch verschiedene Grafikformate wie GIF, JPEG etc. zugelassen.
Die Angabe in diesem Element gibt die erforderlichen Informationen, die Menschen oder Maschinen ben&ouml;tigen, um &uuml;ber die Verarbeitungsm&ouml;glichkeiten der kodierten Daten zu entscheiden (z.B. Hard- und Software zum Anzeigen bzw. Ausf&uuml;hren dieser Ressource. F&uuml;r PDF-Dateien ist dies der Acrobat Reader.) 

<P>Verwendungshinweise: <IMG SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM>
obligatorisches Meta-Element.

<H4>
10.&nbsp;<A NAME="language"></A>Sprache (Language)</H4>
Definition: Sprache des intellektuellen Inhalts der Ressource. Verwendet
wird intern der <A HREF="http://www.bsz-bw.de/diglib/medserv/konvent/metadat/dcniso.html">NISO Z39.53-Standard</A>. 

<P>Verwendungshinweise: <IMG SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM>
obligatorisches Meta-Element, das aus einer Liste
&uuml;bernommen werden mu&szlig;.

<H4>
11.&nbsp;<A NAME="source"></A>Quelle (Source)</H4>
Definition: Gedruckte oder elektronische Quelle einer sonstigen Ver&ouml;ffentlichung
des vorliegenden Dokuments. F&uuml;r ein HTML-codiertes Sonnett von Shakespeare
w&auml;re dies beispielsweise die Printversion, aus dem die vorliegende
elektronische Version stammt. F&uuml;r einen Zeitschriftenaufsatz bedeutet
dies bei einer konventionellen Ver&ouml;ffentlichung Titel, Jahr, Band
und Seitenzahlen bzw. die URL einer anderen elektronischen Version.

<P>Verwendungshinweise: falls keine Erstver&ouml;ffentlichung im Volltextserver stattfindet,
ein sehr w&uuml;nschenswertes Meta-Element.

<H4>
12.&nbsp;<A NAME="verification"></A>Identifizierung</H4>
Hier muss die Person, die das Dokument abliefert, eine Kontaktm&ouml;glichkeit
angeben, um Missbrauch und unbefugte Nutzung auszuschlie&szlig;en.
In der Regel sollte hier eine e-mail-Adresse angegeben werden, an die dann
automatisch eine Best&auml;tigung des Eingangs gesandt wird. Da die Daten
auch noch manuell kontrolliert werden, ist hier in Ausnahmen auch die Angabe
einer Telefonnummer bzw. der Post- bzw. Institutsanschrift m&ouml;glich.

<P>Verwendungshinweise: <IMG SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM>
obligatorisches Meta-Element, das jedoch nur tempor&auml;r
gespeichert wird.

<P>

<!--
<HR ALIGN=LEFT WIDTH=100% SIZE=2>

<P><B>Experimentelle Felder:</B>

<P><B>14. Abdeckungsspektrum (coverage)</B>

<P>Definition: Abdeckungsaspekte (zeitliche, &ouml;rtliche, fl&auml;chenhafte
etc.), die zur Charakterisierung des Objekts sinnvolle Erg&auml;nzungen
geben, z.B. bei Karten, Bildern etc.

<P>Eine formale Spezifizierung f&uuml;r dieses Element ist in Arbeit.
<H4>
15. Rechtliche Bedingungen (rights management)</H4>
Definition: Vorgesehen f&uuml;r den Inhalt dieses Elements ist ein Link
(URL oder andere passende URI falls zutreffend) zu einem Urhebervermerk,
ein "Rights-Management"-Vermerk &uuml;ber die rechtlichen Bedingungen oder
ggf. zu einem Server, der solche Informationen dynamisch erzeugt.
-->

<P>
<H4>
13. &nbsp;<A NAME="number"></A>Anzahl der Dateien, die &uuml;bermittelt werden sollen</H4>

<P>
Hierbei handelt es sich nicht um ein Dublin Core Element. In diesem Feld sollte die Gesamtzahl aller Dateien angegeben werden, die auf den Volltextserver eingebracht werden soll. Zur Zeit werden die Formate PDF, PostScript, HTML und im Zusammenhang damit auch verschiedene Grafikformate wie GIF, JPEG etc. zugelassen. Wenn beispielsweise eine HTML-Datei mit drei Grafiken eingebracht werden soll, muss die Zahl vier angegeben werden. Auf einer sp&auml;teren Eingabeseite werden dann entsprechend viele Felder angeboten, um Pfad und Namen der Dateien auf dem lokalen Rechner anzugeben, damit sie korrekt auf den Volltextserver kopiert werden.

<P>Verwendungshinweise: <IMG SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM>
obligatorisches Element

<H4>
14. &nbsp;<A NAME="dauer"></A>G&uuml;ltigkeitsdauer</H4>
<P>
Hierbei handelt es sich nicht um ein Dublin Core Element. In diesem Feld kann eine befristete G&uuml;ltigkeit f&uuml;r ein Dokument angegeben werden, nach der es wieder gel&ouml;scht werden soll. Da die Dokumente in der Regel langfristig und zitierbar angeboten werden sollen, stellt dies eine Ausnahme dar.

<P>Verwendungshinweise: <IMG SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM>
obligatorisches Element


