<h3> What are meta data?</h3>
<p>Meta data can be defined as:</p>
<ul>
  <p>Data describing one or more ressources </p>
  <p>Data connected to one object and describing that object<br>
  </p>
</ul>
Basically, meta data are a description of documents, objects or services 
and contain information about their content, structure or form. More 
abstractly, meta data are descriptions of data (data about data). 
Bibliographic data sets and catalogue entries in libraries can be 
seen as a kind of meta data. 
<p>
  Basis for meta data is the <a href="http://www.purl.org/DC/">Dublin 
  Core Metadata Element Set</a> (short: Dublin Core (DC)) consisting 
  of fifteen basic elements. Dublin Core is the result of international 
  efforts to establish a collective consensus in describing electronic 
  objects. The Library of Congress (LoC), The Online Cataloging Library 
  Center (OCLC) and a row of (several) national libraries deal with 
  Dublin Core in many projects and are close to introduce the system 
  respectively. So does the Library Service Center of Baden W&uuml;rttember 
  (<a href="http://www.bsz-bw.de/diglib/medserv/konvent/metadat/metadat.html">BSZ</a>) 
  which runs the collective data set of the south-western library 
  network. 
<p> 
<hr>
<h3> Single elements of the application form</h3>

<h4> 1.&nbsp;<a NAME="title"></a> Title</h4>
Title of the document or the object. 
<p>Definition: The name of the ressource given by the author, the 
  publisher or the creator.
<p>Application reference: <img SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM> 
  obligatory meta-element. 
<p> Dissertations need to be specified with a German and an English 
  title. If the dissertation is written in another language, the title 
  has to be specified in all three languages. 

<h4> 2.1&nbsp;<a NAME="creator_name"></a>Creator</h4>
Name of the author 
<p>Definition: The person(s) who are/(is) responsible for the intellectual 
  content. For instance authors (text documents), artists, photographers 
  or illustrators (graphical documents). 
<p>For persons, the normed diction &quot;family name, first name&quot;is 
  obligatory, in order to improve searchability of the document. Please 
  do not mention academic titles. 
<p>Application reference: When possible (e.g. for diploma thesis or 
  thesis) this is an obligatory element. 

<h4> 2.2&nbsp;<a NAME="creator_corporate"></a>Creator (Urheber)</h4>
Name of the organisation 
<p>Definition: Organisation(s) which are responsible for the intellectual 
  content of the document. As a rule organisation(s) (in librarian 
  terms: corporate bodies) are responsible for the intellectual content, 
  if there is an author collective or no persons are mentioned as creators 
  in the document (e.g. in examination regulations). The field &quot;Creator&quot; 
  therefore is not necessarily to be filled automatically with the 
  own institute or facuIty. There are seperate fields for this purpose 
  <a href="#publisher">(university, faculty)</a>. 
<p>Application reference: If possible, this is an obligatory meta 
  element

<h4> 3.1&nbsp;<a NAME="contributor"></a>Contributor</h4>
Name of a person or an organisation. 
<p>Definition: Additional persons or organisations to the ones specified 
  in the field creator. They should have contributed a meaningful 
  intellectual feature to the ressource, which is secondary in relation 
  to publisher and creator (e.g. co-author, translator, illustrators...) 
<p>For persons&acute; names the normed diction &quot;family name, first 
  name&quot; is obligatory in order to increase searchability.

<h4> 3.2&nbsp;<a NAME="advisor"></a>Advisor </h4>
The main tutor has to be specified concerning 
dissertations. Academic titles may be added optionally. (e.g. Muster, 
Hans Prof.Dr.) 
<p>Application reference: No obligatory but desirable meta element 
  in the case that more persons participated in different functions 
  in creating the document. (Exceptions: <img SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM> 
  Specifying the main tutor concerning dissertations is obligatory)

<h4> 4.1&nbsp;<a NAME="keywords"></a>Controlled keywords (german)</h4>
The keywords for controlled description of the document&acute;s content 
can be automatically taken to the form sheet from the german (SWD) keyword vocabulary. 
<p>Application reference: <img SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM> 
  Obligatory meta-element 

<h4> 4.2&nbsp;<a NAME="keywords"></a>Free keywords (german and english)</h4>
 Additionally there is the possibility to give free keywords when 
  there are no useful keywords in the controlled vocabulary. 
  For better international searchability there is the possibility 
  to give English keywords too.
<p> <img SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM> For 
  dissertations it is necessary to give German and English keywords.

<h4> 4.3&nbsp;<a NAME="classification"></a>Classification</h4>
As in some cases a verbal description of the content is not adequate, 
the possibility of classificatory description is offered, when corresponding 
systems are availabe. 
<p> <a HREF="klassifikation.php">List </a> of available classifications 
<p> Application reference: fakultative meta element 

<h4> 5.&nbsp;<a NAME="description"></a>Short summary</h4>
Abstract or free description of the ressource. 
<p>Definition: A textual description of the ressource&acute;s content 
  inclusive a short abstract for document ressources. For graphical 
  ressources : Short description of the content. The description need 
  not be longer then 2000 signs. It can be imported from the document 
  through &quot;copy and paste&quot;. In the case, that no abstract 
  has been written, the Introduction or the table of content can be 
  used.
<p> For Dissertations it is necessary to give a summary in German 
  and English (independent from the actual language of the dissertation) 
<p>Application reference: <img SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM> 
  Obligatory meta element. 

<h4> 6.&nbsp;<a NAME="publisher"></a>University - Faculty (Publisher)</h4>

Definition: The institution which is responsible that the ressource 
is at hand. At first, members of the university should 
bring documents to the library network, which is why the university 
is entered standardly. Within the university there 
is arrangement according to <a href="../fak_liste.php">faculties</a>. 
<p>Application reference: <img SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM> 
  obligatory meta element, which has to be taken from a list. 

<h4> 7.&nbsp;<a NAME="date"></a> Year</h4>
The year of the document. For dissertation, the date of the 
oral examination has to be entered as well. For state doctorates, 
the day of the first public scientific presentation has to be specified. 
Standard ISO-8601 is used internally. 
<p>Publishing date and the last update of meta data is 
  processed automatically by the system. 
<p>Application reference: <img SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM> 
  obligatory meta element 

<h4> 8.&nbsp;<a NAME="type"></a>Resource Type</h4>
Definition: Type of publication (e.g. dissertation, diploma-thesis, 
degree-dissertation, poem, homepage). Controlled vocabulary from a 
<a href="../dokart_liste.php">list of accredited terms</a> 
based on the <a href="http://dublincore.org/documents/dces/">Dublin 
Core Standard Object Types </a>is used.
<p>Application reference: <img SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM> 
  obligatory meta element, which has to be taken from a list. 

<h4> 9.&nbsp;<a NAME="format"></a>Format </h4>
Definition: Data technical format of the ressource. Standard entry 
is <b>application/pdf</b> . 
<p>The following formats are availabe at the moment:PDF, PostScript, 
  HTML furthermore the following graphic formats are available: GIF, 
  JPEG etc. . 
<p><b>Dissertationen</b> have to specified in <b>PDF and in original 
  format</b> (e.g. Word, DVI etc.) of the used application (with all 
  used objects like images, graphics, tables etc..).
<p>The entries for this elements provides the necessary informations 
  in order to decide over processing possibilities of the coded data 
  (Hard-and Software to open the ressources (e.g. Acrobat Reader)). 
<p>Application reference: <img SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM> 
  obligatory meta-element. 

<h4> 10.&nbsp;<a NAME="language"></a> Language</h4>
Definition: Language of the intellectual content of the ressource. 
Internally the <a href="http://www.bsz-bw.de/diglib/medserv/konvent/metadat/dcniso.html">NISO 
Z39.53 standard</a> is used. 
<p>Application reference: <img SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM> 
  obligatory meta element which has to be taken from a list. 

<h4> 11.&nbsp;<a NAME="source"></a>Source</h4>
Definition: Printed or electronic source of other publications of 
the document. For html-coded Shakespeare sonnet this would be the 
printed version from which the particular electronic sonnet is taken. 
For a newspaper essay this means (for a conventional publication): 
Title, Year, Edition, Number and Page numbers and the URL of another 
electronic version respectively. 
<p>Application reference: If it is not the first publication, 
  this is a very desirable meta element. 


<h4> 12.&nbsp;<a NAME="verification"></a>E-mail address</h4>
The person delivering the document has to give a contact possibility 
in order to avoid abuse of unauthorized usage. As a rule, 
an e-mail address should be specified. To this address the confimration 
of the entry is sent automatically. As the data is controlled manually, 
entering a telephone number and a post/institute address is possible 
respectively. 
<p>Application reference: <img SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM> 
  obligatory meta element. Stored temporarily. 

<H4>13. &nbsp;<a NAME="number"></a>Number of files to be uploaded</h4>
This is not a Dublin Core Element. In this field the complete number of files 
  to be transmitted on the full text server hast to be specified. 
  At the moment the formats PDF, Post Script, HTML and various graphic 
  formats like GIF, JPEG etc are available. 
<p>For example: 
  A HTML file with three images has to be specified as four files. 
<p>On the file upload form corresponding fields are offered 
  to enter paths and names of the files on the local computer in order 
  to transfer them to the full text server correctly. At this point, 
  further fields can be use, if the number entered was not correct. 
  For the case that less data is to be transferred then entry fields 
  were specified this is possible without any problems.
<p> Because file names are to be kept, all files should be <strong>named 
  relevantly</strong>. (e.g. chap01.pdf, chap02.pdf..etc). If the 
  files are numbered, please do this by using two digits.
<p> File names should <strong>not contain Umlauts and no space</strong>. 
  Instead of space, lines (_) can be used (e.g. chapter_01_introduction.pdf). 
  Ideally, please orientate on ISO 9660-name convention (file names 
  with max. 8 signs, all file names are only allowed to use the letter 
  A to Z (without accents) and the number 0 to 9) 
<p>Dissertation have to be transferred as PDF and in original format 
  of the used application (Word, DVI etc). In this case, please do 
  only specify the number of files with one format and not the sum 
  of files in both formats. 
<p>Application reference: <img SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM> 
  obligatory element 

<H4>14.&nbsp; <a NAME="dauer"></a>Period of validity</h4>
This is not a Dublin Core Element. Here, limited validity of a document 
  can be entered. After the entered period the document is deleted. 
  As documents are offered over a long term and quotable, this is 
  an exception. 
<p>Application reference: <img SRC="../Icons/u76.gif" HEIGHT=15 WIDTH=15 ALIGN=BOTTOM> 
  obligatory element </font> </td>
	 	</tr>
</table>
  
